package ag.ion.bion.officelayer.draw.shapes;

import ag.ion.bion.officelayer.draw.shapes.properties.ILineChangable;
import ag.ion.bion.officelayer.draw.shapes.properties.IRotatable;
import ag.ion.bion.officelayer.draw.shapes.properties.IShadowSetable;
import ag.ion.bion.officelayer.draw.shapes.properties.ITextSetable;

/**
 * @author Sebastian Patschorke
 */
public interface IConnector extends IShape, IShadowSetable, IRotatable,
		ITextSetable, ILineChangable {

	public static final String PROPERTY_START_SHAPE = "StartShape"; //$NON-NLS-1$
	public static final String PROPERTY_START_GLUEPOINT = "StartGluePointIndex"; //$NON-NLS-1$
	public static final String PROPERTY_END_SHAPE = "EndShape"; //$NON-NLS-1$
	public static final String PROPERTY_END_GLUEPOINT = "EndGluePointIndex"; //$NON-NLS-1$

	public enum Orientation {
		Top, Left, Bottom, Right;
	}

	public void setStart(IShape shape, Orientation orientation);

	public void setEnd(IShape shape, Orientation orientation);
}
