package ag.ion.bion.officelayer.draw.shapes;

import com.sun.star.awt.Point;
import com.sun.star.awt.Size;
import com.sun.star.drawing.XShape;

/**
 * @author Sebastian Patschorke
 */
public interface IShape {

	public static final String CLOSED_BEZIER_SHAPE = "com.sun.star.drawing.ClosedBezierShape"; //$NON-NLS-1$
	public static final String CONNECTOR = "com.sun.star.drawing.ConnectorShape"; //$NON-NLS-1$
	public static final String ELLIPSE = "com.sun.star.drawing.EllipseShape"; //$NON-NLS-1$
	public static final String GRAPHIC_OBJECT_SHAPE = "com.sun.star.drawing.GraphicObjectShape"; //$NON-NLS-1$
	public static final String GROUP_SHAPE = "com.sun.star.drawing.GroupShape"; //$NON-NLS-1$
	public static final String LINE = "com.sun.star.drawing.LineShape"; //$NON-NLS-1$
	public static final String RECTANGLE = "com.sun.star.drawing.RectangleShape"; //$NON-NLS-1$
	public static final String TEXT_SHAPE = "com.sun.star.drawing.TextShape"; //$NON-NLS-1$

	public void setSize(Size size);

	public void setPosition(Point position);

	public XShape getXShape();

	public void setProperty(String property, Object value);

	public boolean addToPage();

	public boolean removeFromPage();

	public String getType();
	
	public void update();
}
