package ag.ion.bion.officelayer.draw.shapes;

import ag.ion.noa.graphic.GraphicInfo;

/**
 * 
 * @author Sebastian Patschorke
 * 
 */
public interface IShapeFactory {

	public IRectangle createRectangle(int width, int height);

	public ITextShape createTextShape(int width, int height, String text);

	public IGraphicObjectShape createGraphicObjectShape(GraphicInfo graphicInfo);

	public IGroupShape createGroup();

	public IClosedBezierShape createClosedBezierShape();

	public IConnector createConnector();

	public IEllipse createEllipse(int width, int height);

	public ILine createLine(int width, int height);

}
