package ag.ion.bion.officelayer.draw.shapes.data;

import java.util.ArrayList;
import java.util.List;

import com.sun.star.awt.Point;
import com.sun.star.drawing.PolyPolygonBezierCoords;
import com.sun.star.drawing.PolygonFlags;

/**
 * 
 * @author Sebastian Patschorke
 * 
 */
public class PolyPolygon {
	private List<Polygon> polygons = new ArrayList<Polygon>();

	public PolyPolygon() {
		super();
	}

	public List<Polygon> getPolygons() {
		return polygons;
	}

	public PolyPolygonBezierCoords getCoords() {
		PolyPolygonBezierCoords coords = new PolyPolygonBezierCoords();
		coords.Coordinates = new Point[polygons.size()][];
		coords.Flags = new PolygonFlags[polygons.size()][];

		for (int i = 0; i < polygons.size(); i++) {
			coords.Coordinates[i] = polygons.get(i).getPoints();
			coords.Flags[i] = polygons.get(i).getFlags();
		}
		return coords;
	}
}
