package ag.ion.bion.officelayer.draw.shapes.properties;

import java.awt.Color;

/**
 * @see <a href=
 *      "http://api.openoffice.org/docs/common/ref/com/sun/star/drawing/FillProperties.html">
 *      OpenOffice documentation </a>
 * 
 * @author Sebastian Patschorke
 * 
 */
public interface IFillProperties {

	public static final String STYLE = "FillStyle"; //$NON-NLS-1$
	public static final String COLOR = "FillColor"; //$NON-NLS-1$
	public static final String TRANSPARENCE = "FillTransparence"; //$NON-NLS-1$
	public static final String TRANSPARENCE_GRADIENT_NAME = "FillTransparenceGradientName"; //$NON-NLS-1$
	public static final String TRANSPARENCE_GRADIENT = "FillTransparenceGradient"; //$NON-NLS-1$
	public static final String GRADIENT_NAME = "FillGradientName"; //$NON-NLS-1$
	public static final String GRADIENT = "FillGradient"; //$NON-NLS-1$
	public static final String HATCH_NAME = "FillHatchName"; //$NON-NLS-1$
	public static final String HATCH = "FillHatch"; //$NON-NLS-1$
	public static final String BITMAP_NAME = "FillBitmapName"; //$NON-NLS-1$
	public static final String BITMAP = "FillBitmap"; //$NON-NLS-1$
	public static final String BITMAP_URL = "FillBitmapURL"; //$NON-NLS-1$
	public static final String BITMAP_OFFSET_X = "FillBitmapOffsetX"; //$NON-NLS-1$
	public static final String BITMAP_OFFSET_Y = "FillBitmapOffsetY"; //$NON-NLS-1$
	public static final String BITMAP_POSITION_OFFSET_X = "FillBitmapPositionOffsetX"; //$NON-NLS-1$
	public static final String BITMAP_POSITION_OFFSET_Y = "FillBitmapPositionOffsetY"; //$NON-NLS-1$
	public static final String BITMAP_RECTANGLE_POINT = "FillBitmapRectanglePoint"; //$NON-NLS-1$
	public static final String BITMAP_LOGICAL_SIZE = "FillBitmapLogicalSize"; //$NON-NLS-1$
	public static final String BITMAP_SIZE_X = "FillBitmapSizeX"; //$NON-NLS-1$
	public static final String BITMAP_SIZE_Y = "FillBitmapSizeY"; //$NON-NLS-1$
	public static final String BITMAP_MODE = "FillBitmapMode"; //$NON-NLS-1$
	public static final String BACKGROUND = "FillBackground"; //$NON-NLS-1$

	public void setFillColor(Color color);
}
