package ag.ion.bion.officelayer.draw.shapes.properties;

import java.awt.Color;

import ag.ion.bion.officelayer.draw.shapes.data.Arrow;

/**
 * @see <a href=
 *      "http://api.openoffice.org/docs/common/ref/com/sun/star/drawing/LineProperties.html">
 *      OpenOffice documentation </a>
 * 
 * @author Sebastian Patschorke
 * 
 */
public interface ILineProperties {

	public static final String STYLE = "LineStyle"; //$NON-NLS-1$
	public static final String DASH = "LineDash"; //$NON-NLS-1$
	public static final String COLOR = "LineColor"; //$NON-NLS-1$
	public static final String TRANSPARENCE = "LineTransparence"; //$NON-NLS-1$
	public static final String WIDTH = "LineWidth"; //$NON-NLS-1$
	public static final String JOINT = "LineJoint"; //$NON-NLS-1$
	public static final String START_NAME = "LineStartName"; //$NON-NLS-1$
	public static final String START = "LineStart"; //$NON-NLS-1$
	public static final String END_NAME = "LineEndName"; //$NON-NLS-1$
	public static final String END = "LineEnd"; //$NON-NLS-1$
	public static final String START_CENTER = "LineStartCenter"; //$NON-NLS-1$
	public static final String START_WIDTH = "LineStartWidth"; //$NON-NLS-1$
	public static final String END_CENTER = "LineEndCenter"; //$NON-NLS-1$
	public static final String END_WIDTH = "LineEndWidth"; //$NON-NLS-1$

	public void setLineColor(Color color);

	public void setLineWidth(long width);

	public void setStartArrow(String name);

	public void setStartArrow(Arrow arrow);

	public void setEndArrow(String name);

	public void setEndArrow(Arrow arrow);

	public void setStartArrowWidth(int width);

	public void setEndArrowWidth(int width);

}
