package ag.ion.bion.officelayer.internal.draw.shapes;

import ag.ion.bion.officelayer.draw.shapes.IClosedBezierShape;
import ag.ion.bion.officelayer.draw.shapes.IShape;
import ag.ion.bion.officelayer.draw.shapes.data.PolyPolygon;
import ag.ion.bion.officelayer.draw.shapes.data.Polygon;
import ag.ion.bion.officelayer.internal.draw.DrawPage;

import com.sun.star.drawing.XShape;

/**
 * 
 * @author Sebastian Patschorke
 * 
 */
public class ClosedBezierShape extends Shape implements IClosedBezierShape {

	private PolyPolygon polyPolygon = new PolyPolygon();

	protected ClosedBezierShape(XShape xShape, DrawPage drawPage) {
		super(xShape, drawPage);
		update();
	}

	@Override
	public void addPolygon(Polygon polygon) {
		if (polygon == null)
			return;
		polyPolygon.getPolygons().add(polygon);
		update();
	}

	@Override
	public void setPolyPolygon(PolyPolygon polyPolygon) {
		if (polyPolygon == null)
			return;
		this.polyPolygon = polyPolygon;
		update();
	}

	@Override
	public boolean addToPage() {
		boolean result = super.addToPage();
		update();
		return result;
	}

	@Override
	public void update() {
		super.update();
		if (isAdded())
			setProperty(IClosedBezierShape.PROPERTY_POLYPOLYGON_BEZIER,
					polyPolygon.getCoords());
	}

	@Override
	public String getType() {
		return IShape.CLOSED_BEZIER_SHAPE;
	}
}
