package ag.ion.bion.officelayer.internal.draw.shapes;

import ag.ion.bion.officelayer.draw.shapes.IConnector;
import ag.ion.bion.officelayer.draw.shapes.IShape;
import ag.ion.bion.officelayer.internal.draw.DrawPage;

import com.sun.star.drawing.XShape;

/**
 * 
 * @author Sebastian Patschorke
 * 
 */
public class Connector extends Shape implements IConnector {

	protected Connector(XShape shape, DrawPage drawPage) {
		super(shape, drawPage);
	}

	@Override
	public void setStart(IShape shape, Orientation orientation) {
		if (shape == null)
			return;
		int orientationKey = getOrientationKey(orientation);
		if (orientationKey == -1)
			return;
		setProperty(IConnector.PROPERTY_START_SHAPE, shape.getXShape());
		setProperty(IConnector.PROPERTY_START_GLUEPOINT, new Integer(
				orientationKey));
	}

	@Override
	public void setEnd(IShape shape, Orientation orientation) {
		if (shape == null)
			return;
		int orientationKey = getOrientationKey(orientation);
		if (orientationKey == -1)
			return;
		setProperty(IConnector.PROPERTY_END_SHAPE, shape.getXShape());
		setProperty(IConnector.PROPERTY_END_GLUEPOINT, new Integer(
				orientationKey));
	}

	private int getOrientationKey(Orientation orientation) {
		switch (orientation) {
		case Top:
			return 0;
		case Left:
			return 1;
		case Bottom:
			return 2;
		case Right:
			return 3;
		default:
			return -1;
		}
	}

	@Override
	public String getType() {
		return IShape.CONNECTOR;
	}
}
