package ag.ion.bion.officelayer.internal.draw.shapes;

import java.util.ArrayList;
import java.util.List;

import ag.ion.bion.officelayer.draw.shapes.IGroupShape;
import ag.ion.bion.officelayer.draw.shapes.IShape;
import ag.ion.bion.officelayer.internal.draw.DrawPage;

import com.sun.star.drawing.XShape;
import com.sun.star.drawing.XShapes;

/**
 * 
 * @author Sebastian Patschorke
 * 
 */
public class GroupShape extends Shape implements IGroupShape {

	private List<IShape> queue = new ArrayList<IShape>();
	private XShapes xShapes;

	protected GroupShape(XShape xShape, DrawPage drawPage) {
		super(xShape, drawPage);
		xShapes = doCast(XShapes.class, getXShape());
	}

	@Override
	public void add(IShape shape) {
		if (isAdded())
			addToGroup(shape);
		else
			queue.add(shape);
	}

	@Override
	public boolean addToPage() {
		boolean result = super.addToPage();
		for (IShape shape : queue)
			addToGroup(shape);
		return result;
	}

	private void addToGroup(IShape shape) {
		xShapes.add(shape.getXShape());
		shape.update();
	}

	@Override
	public String getType() {
		return IShape.GROUP_SHAPE;
	}
}
