package ag.ion.bion.officelayer.internal.draw.shapes.properties;

import java.awt.Color;

import ag.ion.bion.officelayer.draw.shapes.IShape;
import ag.ion.bion.officelayer.draw.shapes.properties.IFillProperties;

/**
 * @author Sebastian Patschorke
 */
public class FillProperties implements IFillProperties {

	private IShape shape;

	public FillProperties(IShape shape) {
		super();
		this.shape = shape;
	}

	@Override
	public void setFillColor(Color color) {
		if (color == null)
			return;
		shape.setProperty(IFillProperties.COLOR, convertColor(color));
	}

	private Integer convertColor(Color color) {
		return new Integer(color.getRGB() & 0xFFFFFF);
	}
}
