package ag.ion.bion.officelayer.internal.draw.shapes.properties.text;

import ag.ion.bion.officelayer.draw.shapes.properties.IShapeText;
import ag.ion.bion.officelayer.internal.text.Text;
import ag.ion.bion.officelayer.text.ICharacterProperties;
import ag.ion.bion.officelayer.text.ITextCursor;
import ag.ion.bion.officelayer.text.TextException;

import com.sun.star.text.XText;

/**
 * This is an Adapter of ag.ion.bion.officelayer.internal.text.Text. Only a part
 * of the functionality is given to the user, because a shape text is simpler
 * then a whole text document.
 * 
 * @author Sebastian Patschorke
 * 
 */
public class ShapeText implements IShapeText {

	private String text;
	private Text textAdaptee;

	public ShapeText(XText text) throws java.lang.IllegalArgumentException {
		textAdaptee = new Text(new DummyTextDocument(), text);
	}

	@Override
	public String getText() {
		return textAdaptee.getText();
	}

	@Override
	public void setText(String text) {
		if (text == null)
			return;
		this.text = text;
		textAdaptee.setText(text);
	}

	public void update() {
		setText(text);
	}

	@Override
	public XText getXText() {
		return textAdaptee.getXText();
	}

	@Override
	public ICharacterProperties getCharacterProperties(int begin, int length) {
		try {
			ITextCursor cursor = textAdaptee.getTextCursorService()
					.getTextCursor();
			cursor.gotoStart(false);
			cursor.goRight((short) begin, false);
			cursor.goRight((short) length, true);
			return cursor.getCharacterProperties();
		} catch (TextException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}

}
