package ag.ion.bion.officelayer.internal.presentation;

import com.sun.star.drawing.XDrawPage;
import com.sun.star.presentation.XPresentationPage;
import com.sun.star.uno.UnoRuntime;

import ag.ion.bion.officelayer.draw.IDrawPage;
import ag.ion.bion.officelayer.internal.draw.DrawPage;
import ag.ion.bion.officelayer.presentation.IPresentationDocument;
import ag.ion.bion.officelayer.presentation.IPresentationPage;

/**
 * @author Sebastian Patschorke
 */
public class PresentationPage implements IPresentationPage {

	private XPresentationPage xPresentationPage;
	private IPresentationDocument presentationDocument;

	private IDrawPage drawPage = null;

	public PresentationPage(IPresentationDocument presentationDocument,
			XPresentationPage xPresentationPage) {
		super();
		this.presentationDocument = presentationDocument;
		this.xPresentationPage = xPresentationPage;
	}

	@Override
	public IDrawPage getDrawPage() {
		if (drawPage == null) {
			XDrawPage xDrawPage = getXDrawPage();
			drawPage = new DrawPage(presentationDocument, xDrawPage);
		}
		return drawPage;
	}

	public void setDrawPage(IDrawPage drawPage) {
		this.drawPage = drawPage;
	}

	@Override
	public XPresentationPage getXPresentationPage() {
		return xPresentationPage;
	}

	private XDrawPage getXDrawPage() {
		XDrawPage xDrawPage = (XDrawPage) UnoRuntime.queryInterface(
				XDrawPage.class, xPresentationPage);
		return xDrawPage;

	}
}
