/****************************************************************************
 * ubion.ORS - The Open Report Suite                                        *
 *                                                                          *
 * ------------------------------------------------------------------------ *
 *                                                                          *
 * Subproject: Office Editor Activation                                     *
 *                                                                          *
 *                                                                          *
 * The Contents of this file are made available subject to                  *
 * the terms of GNU Lesser General Public License Version 2.1.              *
 *                                                                          * 
 * GNU Lesser General Public License Version 2.1                            *
 * ======================================================================== *
 * Copyright 2003-2005 by IOn AG                                            *
 *                                                                          *
 * This library is free software; you can redistribute it and/or            *
 * modify it under the terms of the GNU Lesser General Public               *
 * License version 2.1, as published by the Free Software Foundation.       *
 *                                                                          *
 * This library is distributed in the hope that it will be useful,          *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of           *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU        *
 * Lesser General Public License for more details.                          *
 *                                                                          *
 * You should have received a copy of the GNU Lesser General Public         *
 * License along with this library; if not, write to the Free Software      *
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,                    *
 * MA  02111-1307  USA                                                      *
 *                                                                          *
 * Contact us:                                                              *
 *  http://www.ion.ag                                                       *
 *  info@ion.ag                                                             *
 *                                                                          *
 ****************************************************************************/
 
/*
 * Last changes made by $Author$, $Date$
 */
package ag.ion.bion.workbench.office.editor.activation;

import org.eclipse.ui.plugin.AbstractUIPlugin;

import org.eclipse.jface.resource.ImageDescriptor;

import org.osgi.framework.BundleContext;

/**
 * The main plugin class to be used in the desktop.
 * 
 * @author Andreas Brker
 * @version $Revision$
 */
public class ActivationPlugin extends AbstractUIPlugin {

  private static ActivationPlugin plugin = null;
  
  //----------------------------------------------------------------------------
  /**
   * The constructor.
   * 
   * @author Andreas Brker
   */
  public ActivationPlugin() {
  	plugin = this;
  }
  //----------------------------------------------------------------------------
  /**
   * This method is called upon plug-in activation.
   * 
   * @param context context to be used
   * 
   * @throws Exception if the bundle can not be started
   * 
   * @author Andreas Brker
   */
  public void start(BundleContext context) throws Exception {
  	super.start(context);
  }
  //----------------------------------------------------------------------------
  /**
   * This method is called when the plug-in is stopped.
   * 
   * @param context context to be used
   * 
   * @throws Exception if the bundle can not be stopped
   * 
   * @author Andreas Brker
   */
  public void stop(BundleContext context) throws Exception {
  	super.stop(context);
  	plugin = null;
  }
  //----------------------------------------------------------------------------
  /**
   * Returns the shared instance.
   * 
   * @return shared instance
   * 
   * @author Andreas Brker
   */
  public static ActivationPlugin getDefault() {
  	return plugin;
  }
  //----------------------------------------------------------------------------
  /**
   * Returns an image descriptor for the image file at the given
   * plug-in relative path.
   *
   * @param path the path
   * 
   * @return the image descriptor
   * 
   * @author Andreas Brker
   */
  public static ImageDescriptor getImageDescriptor(String path) {
  	return AbstractUIPlugin.imageDescriptorFromPlugin("ag.ion.bion.workbench.office.editor.activation", path);
  }
  //----------------------------------------------------------------------------
  
}