/****************************************************************************
 *                                                                          *
 * NOA (Nice Office Access)                                     						*
 * ------------------------------------------------------------------------ *
 *                                                                          *
 * The Contents of this file are made available subject to                  *
 * the terms of GNU Lesser General Public License Version 2.1.              *
 *                                                                          * 
 * GNU Lesser General Public License Version 2.1                            *
 * ======================================================================== *
 * Copyright 2003-2006 by IOn AG                                            *
 *                                                                          *
 * This library is free software; you can redistribute it and/or            *
 * modify it under the terms of the GNU Lesser General Public               *
 * License version 2.1, as published by the Free Software Foundation.       *
 *                                                                          *
 * This library is distributed in the hope that it will be useful,          *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of           *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU        *
 * Lesser General Public License for more details.                          *
 *                                                                          *
 * You should have received a copy of the GNU Lesser General Public         *
 * License along with this library; if not, write to the Free Software      *
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,                    *
 * MA  02111-1307  USA                                                      *
 *                                                                          *
 * Contact us:                                                              *
 *  http://www.ion.ag																												*
 *  http://ubion.ion.ag                                                     *
 *  info@ion.ag                                                             *
 *                                                                          *
 ****************************************************************************/
 
/*
 * Last changes made by $Author: andreas $, $Date: 2006-08-07 13:59:32 +0200 (Mo, 07 Aug 2006) $
 */
package ag.ion.noa4e.editor.ui;

import ag.ion.noa4e.editor.ui.actions.PrintAction;

import org.eclipse.ui.IActionBars;
import org.eclipse.ui.IEditorActionBarContributor;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.IWorkbenchPage;

import org.eclipse.ui.actions.ActionFactory;

import org.eclipse.ui.part.EditorActionBarContributor;

/**
 * Contributor for office editors.
 * 
 * @author Andreas Brker
 * @version $Revision: 9209 $
 * @date 15.07.2006
 */ 
public class OfficeEditorActionBarContributor extends EditorActionBarContributor implements IEditorActionBarContributor {
	
	private PrintAction printAction = null;
	
  //----------------------------------------------------------------------------
	/**
	 * Constructs new OfficeEditorActionBarContributor.
	 * 
	 * @author Andreas Brker
	 * @date 15.07.2006
	 */
	public OfficeEditorActionBarContributor() {
		super();
		createActions();
	}
  //----------------------------------------------------------------------------
	/**
	 * Inits the contributor.
	 * 
	 * @param bars action bars to be used
	 * @param page workbench page to be used
	 * 
	 * @author Andreas Brker
	 * @date 15.07.2006
	 */
	public void init(IActionBars bars, IWorkbenchPage page) {
    super.init(bars, page);
    bars.setGlobalActionHandler(ActionFactory.PRINT.getId(), printAction);
    bars.updateActionBars();
	}
  //----------------------------------------------------------------------------
	/**
	 * Sets active editor.
	 * 
	 * @param targetEditor new target editor to be used
	 * 
	 * @author Andreas Brker
	 * @date 15.07.2006
	 */
	public void setActiveEditor(IEditorPart targetEditor) {
		printAction.setActiveEditor(printAction, targetEditor);
  }
  //----------------------------------------------------------------------------
	/**
	 * Constructs actions. 
	 * 
	 * @author Andreas Brker
	 * @date 15.07.2006
	 */
  private void createActions() {
  	printAction = new PrintAction();
  	printAction.setActionDefinitionId(ActionFactory.PRINT.getId());
  }
  //----------------------------------------------------------------------------
  
}