/****************************************************************************
 *                                                                          *
 * NOA (Nice Office Access)                                     						*
 * ------------------------------------------------------------------------ *
 *                                                                          *
 * The Contents of this file are made available subject to                  *
 * the terms of GNU Lesser General Public License Version 2.1.              *
 *                                                                          * 
 * GNU Lesser General Public License Version 2.1                            *
 * ======================================================================== *
 * Copyright 2003-2006 by IOn AG                                            *
 *                                                                          *
 * This library is free software; you can redistribute it and/or            *
 * modify it under the terms of the GNU Lesser General Public               *
 * License version 2.1, as published by the Free Software Foundation.       *
 *                                                                          *
 * This library is distributed in the hope that it will be useful,          *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of           *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU        *
 * Lesser General Public License for more details.                          *
 *                                                                          *
 * You should have received a copy of the GNU Lesser General Public         *
 * License along with this library; if not, write to the Free Software      *
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,                    *
 * MA  02111-1307  USA                                                      *
 *                                                                          *
 * Contact us:                                                              *
 *  http://www.ion.ag																												*
 *  http://ubion.ion.ag                                                     *
 *  info@ion.ag                                                             *
 *                                                                          *
 ****************************************************************************/
 
/*
 * Last changes made by $Author: andreas $, $Date: 2006-08-07 13:09:58 +0200 (Mo, 07 Aug 2006) $
 */
package ag.ion.noa4e.internal.search.ui;

import org.eclipse.search.ui.ISearchResult;
import org.eclipse.search.ui.SearchResultEvent;

/**
 * Event of am office search result.
 * 
 * @author Andreas Brker
 * @version $Revision: 9195 $
 * @date 12.07.2006
 */ 
public class OfficeSearchResultEvent extends SearchResultEvent {

	/** Event of an added match. */
	public static final short MATCH_ADDED 	= 1;
	/** Event of a removed match. */
	public static final short MATCH_REMOVED = 2;
	
	private static final long serialVersionUID = 5998534297035427119L;
	
	private short type = MATCH_ADDED;
	
  //----------------------------------------------------------------------------
	/**
	 * Constructs new OfficeSearchResultEvent.
	 * 
	 * @param searchResult search result to be used
	 * 
	 * @author Andreas Brker
	 * @date 12.07.2006
	 */
	public OfficeSearchResultEvent(ISearchResult searchResult) {
		super(searchResult);
	}
  //----------------------------------------------------------------------------
	/**
	 * Constructs new OfficeSearchResultEvent.
	 * 
	 * @param type type of the event
	 * @param searchResult search result to be used
	 * 
	 * @author Andreas Brker
	 * @date 12.07.2006
	 */
	public OfficeSearchResultEvent(short type, ISearchResult searchResult) {
		this(searchResult);
		if(type == MATCH_ADDED || type == MATCH_REMOVED)
			this.type = type;
	}
  //----------------------------------------------------------------------------
	/**
	 * Returns type of the event.
	 * 
	 * @return type of the event
	 * 
	 * @see OfficeSearchResultEvent#MATCH_ADDED
	 * @see OfficeSearchResultEvent#MATCH_REMOVED
	 * 
	 * @author Andreas Brker
	 * @date 12.07.2006
	 */
	public short getType() {
		return type;
	}
  //----------------------------------------------------------------------------
	
}