/****************************************************************************
 *                                                                          *
 * NOA (Nice Office Access)                                     						*
 * ------------------------------------------------------------------------ *
 *                                                                          *
 * The Contents of this file are made available subject to                  *
 * the terms of GNU Lesser General Public License Version 2.1.              *
 *                                                                          * 
 * GNU Lesser General Public License Version 2.1                            *
 * ======================================================================== *
 * Copyright 2003-2006 by IOn AG                                            *
 *                                                                          *
 * This library is free software; you can redistribute it and/or            *
 * modify it under the terms of the GNU Lesser General Public               *
 * License version 2.1, as published by the Free Software Foundation.       *
 *                                                                          *
 * This library is distributed in the hope that it will be useful,          *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of           *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU        *
 * Lesser General Public License for more details.                          *
 *                                                                          *
 * You should have received a copy of the GNU Lesser General Public         *
 * License along with this library; if not, write to the Free Software      *
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,                    *
 * MA  02111-1307  USA                                                      *
 *                                                                          *
 * Contact us:                                                              *
 *  http://www.ion.ag																												*
 *  http://ubion.ion.ag                                                     *
 *  info@ion.ag                                                             *
 *                                                                          *
 ****************************************************************************/
 
/*
 * Last changes made by $Author: andreas $, $Date: 2006-08-07 13:09:58 +0200 (Mo, 07 Aug 2006) $
 */
package ag.ion.noa4e.search;

import org.eclipse.ui.plugin.AbstractUIPlugin;

import org.eclipse.jface.resource.ImageDescriptor;

import org.osgi.framework.BundleContext;

/**
 * The main plugin class to be used in the desktop.
 * 
 * @author Andreas Brker
 * @version $Revision: 9195 $
 * @date 10.07.2006
 */
public class NOASearchPlugin extends AbstractUIPlugin {

	/** ID of the plugin. */
	public static final String PLUGIN_ID = "ag.ion.noa4e.search";
		
	//The shared instance.
	private static NOASearchPlugin plugin;
	
  //----------------------------------------------------------------------------
	/**
	 * The constructor.
	 * 
	 * @author Andreas Brker
	 * @date 10.07.2006
	 */
	public NOASearchPlugin() {
		plugin = this;
	}
  //----------------------------------------------------------------------------
  /**
   * This method is called upon plug-in activation.
   * 
   * @param context bundle context
   * 
   * @throws Exception if the bundle can not be started
   * 
   * @author Andreas Brker
	 * @date 10.07.2006
   */
	public void start(BundleContext context) throws Exception {
		super.start(context);
	}
  //----------------------------------------------------------------------------
  /**
   * This method is called when the plug-in is stopped.
   * 
   * @param context bundle context
   * 
   * @throws Exception if the bundle can not be stopped
   * 
   * @author Andreas Brker
	 * @date 10.07.2006
   */
	public void stop(BundleContext context) throws Exception {
		super.stop(context);
		plugin = null;
	}
  //----------------------------------------------------------------------------
  /**
   * Returns the shared instance.
   * 
   * @return shared instance
   * 
   * @author Andreas Brker
	 * @date 10.07.2006
   */
	public static NOASearchPlugin getDefault() {
		return plugin;
	}
  //----------------------------------------------------------------------------
	/**
	 * Returns an image descriptor for the image file at the given
	 * plug-in relative path.
	 *
	 * @param path the path 
	 * 
	 * @return the image descriptor
	 * 
	 * @author Andreas Brker
	 * @date 10.07.2006
	 */
	public static ImageDescriptor getImageDescriptor(String path) {
		return AbstractUIPlugin.imageDescriptorFromPlugin("ag.ion.noa4e.search", path);
	}
  //----------------------------------------------------------------------------
	
}