package junit.requirementsontology.test;

import java.util.Map;
import java.util.Set;
import java.util.TreeSet;

import org.deft.requirementsontology.DataProperty;
import org.deft.requirementsontology.OntologyAccessor;
import org.junit.Assert;
import org.junit.BeforeClass;
import org.junit.Ignore;
import org.junit.Test;
import org.semanticweb.owl.model.OWLConstant;
import org.semanticweb.owl.model.OWLDataPropertyExpression;

public class DataPropertyTest
{

	private static OntologyAccessor oA;
	private static DataProperty dataProperty;
	
	@BeforeClass
	public static void setUpBeforeClass() throws Exception
	{
		oA = new OntologyAccessor("RO_version_1_4_1_social_network_consistent.owl");
		Map<OWLDataPropertyExpression,Set<OWLConstant>> dataPropertyMap = oA.getOwlDataProperties("DataControl");
		Set<OWLConstant> constantSet = new TreeSet<OWLConstant>();
		
		Assert.assertEquals(1,dataPropertyMap.size());
		
		for (OWLDataPropertyExpression dataPropertyExpression : dataPropertyMap.keySet())
		{
			constantSet = dataPropertyMap.get(dataPropertyExpression);
		}
		// end for
		
		Assert.assertEquals(1,constantSet.size());

		dataProperty = new DataProperty("hasRefinementReason",((OWLConstant) constantSet.toArray()[0]));
	}
	// end setUpBeforeClass
	
	@Ignore
	public void testDataProperty()
	{
		Assert.fail("Not yet implemented");
	}
	// end testDataProperty

	@Test
	public void testGetDataPropertyConstant()
	{
		Assert.assertEquals("The user must be allowed to completely control which data shall be displayed and which not in order to satisfy data security plocies from government.",dataProperty.getDataPropertyConstant().getLiteral());
	}
	// end testGetDataPropertyConstant
	
	@Test
	public void testGetDataValue()
	{
		Assert.assertEquals("The user must be allowed to completely control which data shall be displayed and which not in order to satisfy data security plocies from government.",dataProperty.getDataValue());
	}
	// end testGetDataValue

	@Test
	public void testGetSimpleName()
	{
		Assert.assertEquals("hasRefinementReason",dataProperty.getSimpleName());
	}
	// end testGetSimpleName

	@Test
	public void testToString()
	{
		Assert.assertEquals("hasRefinementReason : The user must be allowed to completely control which data shall be displayed and which not in order to satisfy data security plocies from government.",dataProperty.toString());
	}
	// end testToString
}
// end class DataPropertyTest