package org.deft;

import org.eclipse.swt.graphics.Point;
import org.eclipse.ui.application.ActionBarAdvisor;
import org.eclipse.ui.application.IActionBarConfigurer;
import org.eclipse.ui.application.IWorkbenchWindowConfigurer;
import org.eclipse.ui.application.WorkbenchWindowAdvisor;

/**
 * Configures the workbench window. Sets the DeftActionBarAdvisor, which creates
 * the DEFT menu bar.
 * 
 * @author abartho
 */
public class DeftWorkbenchWindowAdvisor extends WorkbenchWindowAdvisor{
	
	public DeftWorkbenchWindowAdvisor(IWorkbenchWindowConfigurer configurer) {
		super(configurer);
	}
	
	public void preWindowOpen() {
		super.preWindowOpen();
        getWindowConfigurer().setInitialSize(new Point(1000, 800));
        getWindowConfigurer().setShowCoolBar(true);
        getWindowConfigurer().setShowStatusLine(true);
	}

	
	@Override
	public ActionBarAdvisor createActionBarAdvisor(IActionBarConfigurer abConfigurer) {
		return new DeftActionBarAdvisor(abConfigurer);
	}
	
}
