package org.deft;

import org.deft.repository.datamodel.Artifact;
import org.deft.repository.datamodel.Folder;
import org.deft.repository.datamodel.Project;
import org.deft.repository.exception.DeftErrorException;
import org.deft.repository.fragmentsource.FragmentSource;
import org.deft.repository.fragmentsource.OriginalFragmentLocation;

public class ErrorMessageDisplayingRepositoryFacade extends RepositoryFacade {

	@Override
	public Artifact importArtifact(Project project, Folder parent, 
			FragmentSource fragmentSource, OriginalFragmentLocation location)  {
		try {
			return super.importArtifact(project, parent, fragmentSource, location);
		}
		catch (DeftErrorException dee) {
			System.err.println(dee.getErrors());
			dee.printStackTrace();
		}
		return null;
	}

}
