package org.deft;

import java.util.List;

import org.deft.artifactviewer.ArtifactViewerConnector;
import org.deft.configuration.IntegratorGui;
import org.deft.configuration.OperationGui;
import org.deft.exporter.Exporter;
import org.deft.integrator.EditorIntegrator;
import org.deft.operation.Operation;
import org.deft.operation.OperationChain;
import org.deft.repository.integrator.Integrator;
import org.deft.repository.service.ExtensionService;
import org.deft.representationrenderer.RepresentationRenderer;
import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.ui.IPerspectiveDescriptor;

/**
 * ExtensionService interface which also contains 
 * methods that involve the GUI. 
 */
public interface ExtensionServiceExtension extends ExtensionService {

	public IPerspectiveDescriptor getPerspective(String projectTypeId);
	public String getChapterEditorId(String projectTypeId, String chapterTypeId);
	
	public ArtifactViewerConnector getArtifactViewerConnectorForRendererId(String rendererId);
	public List<RepresentationRenderer> getRenderersForRepresentationType(String representationType);
	public RepresentationRenderer getRepresentationRenderer(String rendererId);
	
	public OperationGui getOperationGui(Operation operation);
	public String getOperationGuiName(Operation operation);
	
	public IntegratorGui getIntegratorGui(Integrator integrator);
	public String getIntegratorGuiName(Integrator integrator);
	
	public List<EditorIntegrator> getEditorIntegrators();
	public EditorIntegrator getEditorIntegrator(String id);
	public List<EditorIntegrator> getEditorIntegratorsForChapterType(String chapterTypeId);
	
	public List<String> getEditorIntegratorIds();
	public List<EditorIntegrator> getEditorIntegratorsForOperationChain(String operationChainId);

	public List<OperationChain> getCompatibleOperationChainsForEditorIntegration(String artifactTypeId, String chapterTypeId);
	
	
	public List<String> getExporterIds();
	public List<String> getExporterIds(String chapterTypId);
	public Exporter getExporter(String exporterId);
	public List<WizardPage> getWizardPages(String exporterId);
}
