package org.deft.actions;

import org.deft.artifacttypesupport.codefile.transform.OutlineNode;
import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.Viewer;

class AstContentProvider implements ITreeContentProvider {

	private OutlineNode content;
	
	public Object[] getChildren(Object parentElement) {
		OutlineNode node = (OutlineNode) parentElement;
		if (node.hasChildren())
			return node.getChildren().toArray();
		return new Object[0];
	}

	public Object getParent(Object element) {
		OutlineNode node = (OutlineNode) element;
		return node.getParent();
	}

	public boolean hasChildren(Object element) {
		OutlineNode node = (OutlineNode) element;
		return node.hasChildren();
	}

	public Object[] getElements(Object inputElement) {
		if (content != null)
			return content.getChildren().toArray();

		return new Object[0];
	}

	public void dispose() {
		if (content != null) {
			content = null;
		}
	}

	@Override
	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
		if (newInput instanceof OutlineNode) {
			content = (OutlineNode)newInput;
		}
	}

}
