package org.deft.actions;
 
import org.deft.gui.view.project.ProjectExplorerView;
import org.deft.util.ScreenshotUtil;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.ImageData;
import org.eclipse.swt.graphics.ImageLoader;
import org.eclipse.ui.IViewPart;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.navigator.CommonNavigator;
 
public class CreateScreenshotAction extends AbstractDeftAction {
	
    /**
     * The constructor.
     */
    public CreateScreenshotAction(IWorkbenchWindow window) {
		super(window);
		setText("Screenshot");
	}
 

    public void run() {
    	IViewPart part = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().findView(ProjectExplorerView.ID);
    	if (part instanceof CommonNavigator) {
    		CommonNavigator cn = (CommonNavigator)part;
    		Viewer v = cn.getCommonViewer();
    		Image image = ScreenshotUtil.makeScreenshot(v.getControl());
			ImageLoader imageLoader = new ImageLoader();
			imageLoader.data = new ImageData[]{image.getImageData()};
			imageLoader.save("d:/screenShot.jpg", SWT.IMAGE_JPEG);
    	}
    }
 
    /**
     * We can use this method to dispose of any system
     * resources we previously allocated.
     * @see IWorkbenchWindowActionDelegate#dispose
     */
    public void dispose() {
    }


	@Override
	protected void setEnabledState() {
		setEnabled(true);
	}
}