package org.deft.actions;

import org.deft.RepositoryFacade;
import org.deft.gui.SelectionHelper;
import org.deft.repository.datamodel.ArtifactReference;
import org.deft.repository.datamodel.Chapter;
import org.eclipse.ui.IWorkbenchWindow;

public class ForceRepresentationsUpdateAction extends AbstractDeftAction {


	public ForceRepresentationsUpdateAction(IWorkbenchWindow window) {
		super(window);
		setText("Recompute references");
	}
	
	

	@Override
	protected void setEnabledState() {
		SelectionHelper selection = getSelectionHelper();
		boolean chapterSelected = selection.isOnlySingleChapterNodeSelected();
		boolean referenceSelected = selection.isOnlySingleArtifactReferenceNodeSelected();
		if (chapterSelected) {
			setEnabled(true);
		} else if (referenceSelected) {
			setEnabled(true);
		} else {
			setEnabled(false);
		}
	}

    public void run() {
    	SelectionHelper selection = getSelectionHelper();
		boolean chapterSelected = selection.isOnlySingleChapterNodeSelected();
		boolean referenceSelected = selection.isOnlySingleArtifactReferenceNodeSelected();
    	if (chapterSelected) {
	    	Chapter chapter = selection.getSelectedChapter();
	    	for (ArtifactReference ref : chapter.getArtifactReferences()) {
	    		RepositoryFacade.instance().setArtifactReferenceUnchecked(ref);
	    	}
    	} else if (referenceSelected) {
    		ArtifactReference reference = selection.getSelectedArtifactReference();
    		RepositoryFacade.instance().setArtifactReferenceUnchecked(reference);
    	}
    }
}
