package org.deft.actions;

import org.deft.chaptereditor.ChapterEditorPart;
import org.deft.gui.EditorHelper;
import org.deft.gui.SelectionHelper;
import org.deft.integrator.EditorChapterDocument;
import org.deft.repository.datamodel.Chapter;
import org.eclipse.ui.IWorkbenchWindow;

/**
 * Action for opening chapters. 
 */
public class OpenChapterAction extends AbstractDeftAction {
	
	public OpenChapterAction(IWorkbenchWindow window) {
		super(window);
		setText("Open");
	}

	public void run() {
		SelectionHelper selection = getSelectionHelper();
		if (selection.isOnlySingleChapterNodeSelected()) {
			Chapter chapter = selection.getSelectedChapter();
			openChapter(chapter);
		}
	}
	
	
	public EditorChapterDocument openChapter(Chapter chapter) {
		EditorHelper editorHelper = getEditorHelper();
		ChapterEditorPart editor = editorHelper.openEditor(chapter);
		EditorChapterDocument chapterDocument = editor.getChapterDocument();
		return chapterDocument;
	}


	@Override
	protected void setEnabledState() {
		boolean enabled = selectionIsAChapter();
		setEnabled(enabled);
	}
	
	private boolean selectionIsAChapter() {
		SelectionHelper selection = getSelectionHelper();
		boolean isChapter = selection.isOnlySingleChapterNodeSelected();
		return isChapter;
	}
	

}
