package org.deft.actions;

import org.deft.gui.SelectionHelper;
import org.deft.repository.datamodel.Artifact;
import org.eclipse.ui.IWorkbenchWindow;

/**
 * Opens a MultiPageArtifactViewerPart which shows all available representations of an Artifact.
 */
public class OpenRepresentationAction extends AbstractDeftAction {

	public OpenRepresentationAction(IWorkbenchWindow window) {
		super(window);
		this.setText("Open");
	}

	
	@Override
	protected void setEnabledState() {
		setEnabled(false);
		if (selectionIsAnArtifact()) {
			Artifact artifact = getSelectionHelper().getSelectedArtifact();
			if (getEditorHelper().canBeDisplayedInViewer(artifact)) {
				setEnabled(true);		
			}
		} 
	}
	
	
	
	private boolean selectionIsAnArtifact() {
		SelectionHelper selection = getSelectionHelper();
		boolean isArtifact = selection.isOnlySingleArtifactNodeSelected();
		return isArtifact;
	}

	
	
	@Override
	public void run() {
		SelectionHelper selection = getSelectionHelper();
		if (selection.isOnlySingleArtifactNodeSelected()) {
			Artifact artifact = selection.getSelectedArtifact();
			openRepresentationsInMultiPageArtifactViewer(artifact);
		}
	}
	
	
	/**
	 * Opens a MultiPageArtifactViewer with a tab for each representation that could be found.
	 */
	public void openRepresentationsInMultiPageArtifactViewer(Artifact artifact) {
		getEditorHelper().openViewer(artifact);
	}
	

	
	

	

	
	



	
}
