package org.deft.actions;

import org.deft.RepositoryFacade;
import org.deft.gui.SelectionHelper;
import org.deft.repository.datamodel.ArtifactReference;
import org.deft.repository.datamodel.ArtifactReferenceUpdateType;
import org.eclipse.ui.IWorkbenchWindow;

public class SetArtifactReferenceCheckedAction extends AbstractDeftAction {

	protected RepositoryFacade repository = RepositoryFacade.instance();
	
	public SetArtifactReferenceCheckedAction(IWorkbenchWindow window) {
		super(window);
		setText("Accept Changes");
	}
	
	
	@Override
	protected void setEnabledState() {
		SelectionHelper selection = getSelectionHelper();
		if (selection.isOnlySingleArtifactReferenceNodeSelected()) {
			boolean isNormalUpdateType = isNormalUpdateType();
			setEnabled(isNormalUpdateType);
		} else {
			setEnabled(false);
		}
	}
	
	private boolean isNormalUpdateType() {
		SelectionHelper selection = getSelectionHelper();
		ArtifactReference ref = selection.getSelectedArtifactReference();
		ArtifactReferenceUpdateType refType = ref.getUpdateType();
		return refType == ArtifactReferenceUpdateType.NORMALUPDATE;
	}
	
	
	public void run() {
		SelectionHelper selection = getSelectionHelper();
		ArtifactReference ref = selection.getSelectedArtifactReference();
		acceptChanges(ref);
	}
	
	public void acceptChanges(ArtifactReference reference) {
		repository.setArtifactReferenceChecked(reference);
	}
	
}
