package org.deft.actions;

import org.deft.ExtensionServiceExtension;
import org.deft.RepositoryFacade;
import org.deft.gui.view.project.nodes.ProjectNode;
import org.deft.gui.view.project.nodes.ProjectViewNode;
import org.deft.repository.datamodel.Project;
import org.eclipse.ui.IPerspectiveDescriptor;
import org.eclipse.ui.IWorkbenchWindow;

public class SetPerspectiveAction extends AbstractDeftAction {

	private ExtensionServiceExtension extensionService;
	
	public SetPerspectiveAction(IWorkbenchWindow window) {
		super(window);
		this.extensionService = RepositoryFacade.instance().getExtensionService();
		setText("Set Perspective");
	}

	@Override
	protected void setEnabledState() {
//		Project project = getSelectedProject();
//		boolean hasPerspective = project != null && getPerspective(project) != null;
//		setEnabled(hasPerspective);
		setEnabled(true);
	}
	
	private IPerspectiveDescriptor getPerspective(Project project) {
		IPerspectiveDescriptor perspective = extensionService.getPerspective(project.getProjectTypeId());
		return perspective;
	}
	
	private IPerspectiveDescriptor getDeftPerspective() {
		return getWindow().getWorkbench().getPerspectiveRegistry().findPerspectiveWithId("org.deft.DeftPerspective");
	}
	
	@Override
	public void run() {
		Project project = getSelectedProject();
		IPerspectiveDescriptor perspective = getPerspective(project);
		if (perspective == null) {
			perspective = getDeftPerspective();
		}
		getWindow().getActivePage().setPerspective(perspective);
	}
	
	
	
	
	private Project getSelectedProject() {
		ProjectViewNode node = getSelectionHelper().getFirstSelectedProjectViewNode();
		while (node != null && !(node instanceof ProjectNode)) {
			node = node.getParent();
		}
		if (node == null) {
			return null;
		} else {
			Project project = ((ProjectNode)node).getProject();
			return project;
		}
	}

}
