package org.deft.actions;

import java.util.List;

import org.deft.RepositoryFacade;
import org.deft.fragmentsourcegui.FragmentSourceGui;
import org.deft.gui.SelectionHelper;
import org.deft.repository.datamodel.Artifact;
import org.deft.repository.datamodel.Project;
import org.deft.repository.fragmentsource.FragmentSource;
import org.deft.repository.fragmentsource.OriginalFragmentLocation;
import org.eclipse.ui.IWorkbenchWindow;

public class UpdateArtifactWithAction extends AbstractDeftAction {

	private FragmentSourceGui fragmentSourceGui;
	
	public UpdateArtifactWithAction(IWorkbenchWindow window, FragmentSourceGui fragmentSourceGui) {
		super(window);
		this.fragmentSourceGui = fragmentSourceGui;
		this.setText(fragmentSourceGui.getName());
	}

	@Override
	protected void setEnabledState() {
		SelectionHelper selection = getSelectionHelper();
		boolean isOnlySingleArtifactNodeSelected = selection.isOnlySingleArtifactNodeSelected();
		setEnabled(isOnlySingleArtifactNodeSelected);
	}
	
	
	
    public void run() {
    	SelectionHelper selection = getSelectionHelper();
    	Artifact selectedArtifact = selection.getSelectedArtifact();

    	List<OriginalFragmentLocation> locations = fragmentSourceGui.getLocationsForImport();
    	if (locations.size() == 1) {
    		OriginalFragmentLocation location = locations.get(0);
        	FragmentSource fragmentSource = fragmentSourceGui.getFragmentSource();
        	
        	Project project = selectedArtifact.getProject();
    		int latestRevision = project.getLatestRevision();
    		int newRevision = latestRevision + 1;
        	RepositoryFacade.instance().updateArtifactWith(selectedArtifact, fragmentSource, location, newRevision);
    		getEditorHelper().updateViewerIfOpen(selectedArtifact);
    	}
    	
    }

}
