package org.deft.actions.contributionitem;

import org.deft.actions.DeftActionFactory;
import org.eclipse.jface.action.ActionContributionItem;
import org.eclipse.jface.action.ContributionItem;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.action.Separator;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.ui.IWorkbenchWindow;


/**
 * This ContributionItem shows a menu with actions for creating new Fragments.
 * Those Fragments are: Project, Chapter, Tutorial and Folder.
 */
public class NewMenu extends ContributionItem {

	private IWorkbenchWindow window;

	public NewMenu(IWorkbenchWindow window, String id) {
		super(id);
		this.window = window;
	}

	@Override
	public void fill(Menu menu, int index) {

		IAction newProjectAction = DeftActionFactory.NEW_PROJECT.create(window);
		IAction newChapterAction = DeftActionFactory.NEW_CHAPTER.create(window);
		IAction newTutorialAction = DeftActionFactory.NEW_TUTORIAL.create(window);
		IAction newFolderAction = DeftActionFactory.NEW_FOLDER.create(window);
		
		new ActionContributionItem(newProjectAction).fill(menu, -1);
		new Separator().fill(menu, -1);
		new ActionContributionItem(newChapterAction).fill(menu, -1);
		new ActionContributionItem(newTutorialAction).fill(menu, -1);
		new ActionContributionItem(newFolderAction).fill(menu, -1);
	}
}
