package org.deft.actions.contributionitem;

import org.deft.actions.UpdateArtifactWithAction;
import org.deft.fragmentsourcegui.EclipseFragmentSourceGuiRegistry;
import org.deft.fragmentsourcegui.FragmentSourceGui;
import org.deft.fragmentsourcegui.FragmentSourceGuiRegistry;
import org.eclipse.jface.action.ActionContributionItem;
import org.eclipse.jface.action.ContributionItem;
import org.eclipse.jface.action.IContributionItem;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.ui.IWorkbenchWindow;


/**
 * This ContributionItem shows a menu with sources from which artifacts
 * can be updated
 * 
 * This ContributionItem is provided via the ImportDropDownAction.
 */
public class UpdateWithMenu extends ContributionItem {

	private IWorkbenchWindow window;
	private FragmentSourceGuiRegistry registry = new EclipseFragmentSourceGuiRegistry();

	/**
	 * Creates a new UpdateWithMenu containing UpdateArtifactWithActions
	 */
	public UpdateWithMenu(IWorkbenchWindow window, String id) {
		super(id);
		this.window = window;
	}

	@Override
	public void fill(Menu menu, int index) {
		for (String id : registry.getFragmentSourceGuiIds()) {
			FragmentSourceGui fsg = registry.getFragmentSourceGui(id);
			addMenuForFragmentSource(menu, fsg);
		}
	}
	
	private void addMenuForFragmentSource(Menu menu, FragmentSourceGui fsg) {
		UpdateArtifactWithAction action = new UpdateArtifactWithAction(window, fsg);
		IContributionItem item = new ActionContributionItem(action);
		item.fill(menu, -1);
	}
	



}
