package org.deft.artifacttypesupport.codefile;

import java.io.File;
import java.io.InputStream;
import java.nio.CharBuffer;

import org.deft.repository.ast.TreeNodeRoot;
import org.deft.repository.exception.DeftParseException;


public interface Parser {
	
	/**
	 * Returns a tree representation of the given code file.
	 */
	public TreeNodeRoot getAst(String code) throws DeftParseException;
	
	/**
	 * Returns a tree representation of the given code file.
	 */
	public TreeNodeRoot getAst(InputStream is) throws DeftParseException;
	
	/**
	 * Returns a tree representation of the given code file.
	 */
	public TreeNodeRoot getAst(CharBuffer cb) throws DeftParseException;
	
	/**
	 * Returns a tree representation of the given code file.
	 */
	public TreeNodeRoot getAst(File file) throws DeftParseException;
	

}
