package org.deft.artifacttypesupport.codefile.java;

import org.deft.artifacttypesupport.codefile.AstTransformerRegistry;
import org.deft.artifacttypesupport.codefile.LanguageSpecifics;
import org.deft.artifacttypesupport.codefile.XPathGenerator;
import org.deft.artifacttypesupport.codefile.java.templates.JavaTokenTypeDecorator;
import org.deft.artifacttypesupport.codefile.java.transformer.JavaAstTransformerRegistry;
import org.deft.artifacttypesupport.codefile.java.xpath.JavaXPathGenerator;
import org.deft.repository.ast.decoration.tokentype.TokenTypeDecorator;

public class JavaLanguageSpecifics implements LanguageSpecifics {

	private JavaXPathGenerator xpathGenerator = new JavaXPathGenerator();
	private JavaAstTransformerRegistry transformerRegistry = new JavaAstTransformerRegistry();
	
	@Override
	public String getLanguageId() {
		return "java";
	}
	
	@Override
	public TokenTypeDecorator getTokenTypeDecorator() {
		return new JavaTokenTypeDecorator();
	}

	@Override
	public XPathGenerator getXPathGenerator() {
		return xpathGenerator;
	}

	@Override
	public AstTransformerRegistry getTransformerRegistry() {
		return transformerRegistry;
	}

}
