package org.deft.artifacttypesupport.codefile.java.debug;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.nio.CharBuffer;

import org.deft.artifacttypesupport.codefile.java.parser.JavaParser;
import org.deft.repository.ast.TreeNodeRoot;
import org.deft.repository.exception.DeftParseException;


public class Main {

	private static final String path = "D:/Projekte/Eclipse/deft/deft/trunk/org.deft.repository/testdata/Repository/javafiles/";
	private static final String fileName = "EmptyBlockTest";
	private static final String ext = ".java";
	
	
	private static void writeTestOutput(TreeNodeRoot root) throws IOException {
		File file = new File(path + fileName + "out" + ext);
		BufferedWriter bw = new BufferedWriter(new FileWriter(file), 1024);
		bw.write(root.getTextContent().toCharArray());
		bw.flush();		
	}
	
	public static void main(String[] args) throws IOException {
		//PropertyConfigurator.configure("log4j.properties");
		File file = new File(path + fileName + ext);
		
		//JavaCore.getPlugin().getStateLocation();
		JavaParser jp = new JavaParser();
		TreeNodeRoot root;
		try {
			String input = "class A { void x() { do {} while (true); } }";
			CharBuffer cb = CharBuffer.wrap(input.toCharArray());
			root = jp.getAst(cb);
			//writeTestOutput(root);		
			DeftASTFrame daf = new DeftASTFrame(root);
	        daf.setTitle(file.getName());
	        daf.setSize(400, 800);
	        daf.setVisible(true);

		} catch (DeftParseException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}	
	
}


