package org.deft.artifacttypesupport.codefile.java.transformer;

import org.deft.artifacttypesupport.codefile.AstTransformerRegistry;
import org.deft.artifacttypesupport.codefile.transform.AstTransformer;
import org.deft.artifacttypesupport.codefile.transform.OutlineNodeTransformer;
import org.deft.artifacttypesupport.codefile.transform.RuleBasedOutlineNodeTransformer;
import org.deft.artifacttypesupport.codefile.transform.TransformerRuleSet;

public class JavaAstTransformerRegistry implements AstTransformerRegistry {

	//plugin id is passed along as parameter because it is later needed to
	//retrieve the icons of the outline nodes
	private String pluginId = "org.deft.artifacttypesupport.codefile.java";
	
	@Override
	public OutlineNodeTransformer getSimpleOutlineTransformer() {
		TransformerRuleSet ruleSet = new JavaSimpleOutlineTransformerRuleSet();
		OutlineNodeTransformer transformer = new RuleBasedOutlineNodeTransformer(ruleSet, pluginId);
		return transformer;
	}

	@Override
	public OutlineNodeTransformer getDetailedOutlineTransformer() {
		TransformerRuleSet ruleSet = new JavaDetailedOutlineTransformerRuleSet();
		OutlineNodeTransformer transformer = new RuleBasedOutlineNodeTransformer(ruleSet, pluginId);
		return transformer;
	}

	
	@Override
	public AstTransformer getTransformer(String id) {
		throw new UnsupportedOperationException("later...");
	}

}
