package org.deft.artifacttypesupport.codefile.transform;

import org.deft.repository.ast.TreeNode;

public interface AstTransformer {

	/**
	 * This method is called to transform a TreeNode AST of a code file
	 * into a tree of OutlineNodes.
	 */
	public TreeNode transform(TreeNode node);

	/**
	 * This method is called to transform a TreeNode AST of a code file
	 * into a tree of OutlineNodes.
	 * 
	 * @param removeRootElement
	 *            this could be useful if you had to create a dummy root
	 *            element for encapsulating two or more children
	 */
	public TreeNode transform(TreeNode node, boolean removeRootElement);
}

