package org.deft.artifacttypesupport.codefile.transform;

import org.deft.repository.ast.TreeNode;



public interface IOutlineNodeFactory{

	/**
	 * This is the default callback for all TreeNodes. Besides that
	 * you are free in defining more specific callbacks.
	 * @param TreeNode
	 * @return
	 */
	public OutlineNode createNode(TreeNode node);
	
	/**
	 * Returns the root node under which all other TreeNodes are grouped.
	 * @return
	 */
	public OutlineNode createRootNode();
	
	/**
	 * Returns an object node for a group node you have specified
	 * @param the group name you have specified for the new node
	 * @param an TreeNode the have to be grouped under this new node
	 * @return
	 */
	public OutlineNode createGroupingNode(String groupName, TreeNode node);
	
}
