package org.deft.artifacttypesupport.codefile.transform;

import org.deft.repository.ast.TreeNode;


public interface NodeCreator {
	
	/**
	 * This is the default method that is called to create tree nodes from a given xml node. 
	 * @param node
	 * @return
	 */
	public NodeList<TreeNode> createNode(TreeNode node);
	
	/**
	 * Returns a tree node that is used as the parent for the given node. This is used to group xml nodes
	 * under user created nodes.
	 * @param groupName
	 * @param node
	 * @return
	 */
	public TreeNode createGroupingNode(String groupName, TreeNode node);
}
