package org.deft.artifacttypesupport.codefile.transform;

import java.util.ArrayList;
import java.util.List;


public class NodeList<T> {

	private List<T> list;

	private T parent;

	public NodeList() {
		this.list = new ArrayList<T>();
	}
	
	public NodeList(T node) {
		this();
		add(node);
	}

	public void add(T node) {
		boolean isParent = false;
		if (parent == null)
			isParent = true;
		add(node,isParent);
	}

	public void add(T node, boolean isParent) {
		if (node != null){
			list.add(node);
			if (isParent)
				this.parent = node;
		}
	}

	public T getParent() {
		return parent;
	}

	public List<T> getElements() {
		return list;
	}
	
	public int getSize(){
		return list.size();
	}

	public void addAll(NodeList<T> childNodeList) {
		if (childNodeList != null){
			for (T child : childNodeList.getElements()) {
				add(child);
			}
		}
		
	}
	
	@Override
	public String toString() {
		StringBuffer buffer = new StringBuffer("TreeNodeList [");
		int size = list.size();
		int i = 0;
		for (T child : list) {
			buffer.append(child.toString());
			if (i < size - 1) {
				buffer.append(", ");
			}
		}
		buffer.append("]");
		return buffer.toString();
	}
	
}
