package org.deft.artifacttypesupport.codefile.transform;

public class NullTransformerRuleSet implements TransformerRuleSet {

	private TransformerRule nullRule;
	private IOutlineNodeFactory factory;
	
	public NullTransformerRuleSet(IOutlineNodeFactory factory) {
		this.nullRule = new TransformerRule("getDefaultNode", "icons/default_icon.gif");
		this.factory = factory;
	}
	
	
	@Override
	public TransformerRule getRule(String elementName) {
		return nullRule;
	}

	@Override
	public TransformerRule getDefaultRule() {
		return nullRule;
	}

	@Override
	public boolean containsRule(String elementName) {
		return true;
	}

	@Override
	public IOutlineNodeFactory getOutlineNodeFactory() {
		return factory;
	}
	


}
