package org.deft.artifactviewer;

import org.deft.operation.OperationChain;
import org.deft.repository.datamodel.Artifact;
import org.deft.representationrenderer.RepresentationRenderer;
import org.eclipse.ui.IWorkbenchPage;

///**
// * Allows generic opening of an artifact in the right editor. (For artifacts,
// * we call the editor a viewer, because modifying the artifacts is not allowed).
// * For each viewer (sourcecode, ecore diagram, ...) 
// * there must be a corresponding connector. The connector
// * must be registered as an extension (extension point org.deft.artifactviewer).
// * Furthermore, there must be a mapping from Artifact type to ArtifactViewerConnector
// * (extension point org.deft.artifactviewermapping). From the type of the artifact
// * the right ArtifactViewerConnector will be retrieved. 
// */
public interface ArtifactViewerConnector {
	
	public void openInEditor(Artifact artifact, OperationChain chain, RepresentationRenderer renderer, IWorkbenchPage page);
	
	public String getIdOfEditorToBeOpened();

}
