package org.deft.artifactviewer;

import java.io.InputStream;

import org.deft.operation.OperationChain;
import org.deft.repository.datamodel.Artifact;
import org.deft.representationrenderer.RepresentationRenderer;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IPersistableElement;

public interface ArtifactViewerInput extends IEditorInput, IPersistableElement {
	
	public Artifact getArtifact();
	public OperationChain getChain();
	public RepresentationRenderer getRenderer();
	
	/**
	 * The content to be displayed by the viewer
	 */
	public Object getContent();

	/**
	 * The content to be displayed by the viewer,
	 * in stream format
	 */
	public InputStream getInputStream();
	
}
