package org.deft.editorintegrator.odftext;

import org.deft.representation.styleddocument.StyledCodeRepresentation;

/**
 * Integrates styled text (StyledDocument) into an ODFText document using the OpenOffice API.
 * 
 * The function is the same as StyledTextIntoODFTextIntegrator, but this integrator is called
 * for styledcode representations
 */
public class StyledCodeIntoODFTextIntegrator extends StyledTextIntoODFTextIntegrator {

	public static final String ID = "org.deft.editorintegrator.styledcode4odftext";


	@Override
	public String getInputRepresentationType() {
		return StyledCodeRepresentation.TYPE;
	}


	@Override
	public String getId() {
		return ID;
	}

	@Override
	public String getDescription() {
		return "Code";
	}


	
}
