package org.deft.emftext;

import org.deft.repository.artifacttype.ArtifactType;
import org.deft.repository.artifacttype.Validator;

public abstract class EmfTextArtifactType implements ArtifactType {

	private Validator validator;
	
	@Override
	public Validator getValidator() {
		if (validator == null) {
			validator = new EmfTextValidator(getEmfTextLanguageId());
		}
		return validator;
	}
	
	public abstract String getEmfTextLanguageId();
	
	@Override
	public String getArtifactTypeName() {
		return "EMFText \"" + getEmfTextLanguageId() + "\"";
	}

}
