package org.deft.exporter;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.deft.repository.datamodel.Chapter;
import org.deft.util.ImageHelper;
import org.eclipse.jface.wizard.IWizardPage;
import org.eclipse.jface.wizard.Wizard;
import org.eclipse.jface.wizard.WizardPage;



public class ExportWizard extends Wizard {

	private Chapter chapter;
	private Exporter exporter;
	private List<WizardPage> wizardPages;
	
	public ExportWizard(Chapter chapter, Exporter exporter, List<WizardPage> wizardPages) {
		this.chapter = chapter;
		this.exporter = exporter;
		this.wizardPages = wizardPages;
		this.setDefaultPageImageDescriptor(ImageHelper.getDeftIconDescriptor("export_big.png"));
	}

	@Override
	public void addPages() {
		for (WizardPage page : wizardPages) {
			addPage(page);
		}
	}

	@Override
	public boolean performFinish() {
		Map<String, Object> options = new HashMap<String, Object>();
		// Go through all pages of this Wizard and 
		// - collect all options of all pages
		// - store them in the dialog settings so the values
		//   are there again the next time the wizard is opened
		IWizardPage[] pages = this.getPages();
		for (IWizardPage page : pages) {
			ExportWizardPage exportPage = (ExportWizardPage)page;
			options.putAll(exportPage.getOptions());
			exportPage.saveDialogSettings();
		}
		
		exporter.exportWithProgress(chapter, options);
//		
//		// Start the actual export and pass all options
//		try {
//			OutputGenerator.getInstance().generate(this.fragment, options, configurationElement);
//		} catch (ExportException e) {
//			DeftLogger.log(Status.ERROR, "Failed to export.", e,
//					ExportWizard.class);
//		}

		return true;
	}
	
}
