package org.deft.exporter;

import java.util.Map;

import org.deft.repository.datamodel.Fragment;


/**
 * Interface for Exporters which export chapters and tutorials to
 * documents which can be read outside of DEFT. 
 */
public interface Exporter {

	/**
	 * Returns a descriptive name of the exporter. Used as menu item caption.
	 */
	public String getName();
	
	
	public void exportWithProgress(Fragment fragment, Map<String, Object> options);
	
}
