package org.deft.exporter;

import java.util.List;

import org.eclipse.jface.wizard.WizardPage;

/**
 * Registry of all registered Exporters. Exporters export chapters from the repository
 * to files which can be read outside of DEFT.
 */
public interface ExporterRegistry {

	public List<String> getExporterIds();
	
	public List<String> getExporterIds(String chapterTypId);

	public Exporter getExporter(String exporterId);
	
	/**
	 * Returns a list of WizardPages with which the user can set some export related options.
	 * If now WizardPages are configured, an empty list is returned. 
	 */
	public List<WizardPage> getWizardPages(String exporterId);
}
