package org.deft.exporter.latex;

import org.eclipse.core.runtime.IPath;
import org.eclipse.core.runtime.Path;
import org.eclipse.jface.dialogs.IInputValidator;

public class LatexExecutableInputValidator implements IInputValidator {

	private String inputName;
	private boolean canBeEmpty;
	
	public LatexExecutableInputValidator(boolean canBeEmpty, String inputName) {
		this.canBeEmpty = canBeEmpty;
		this.inputName = inputName;
	}
	
	
	@Override
	public String isValid(String text) {
		//can be empty and is indeed empty? -> no error
		if (canBeEmpty && (text == null || text.isEmpty())) {
			return null;
		}
		
		IPath path = new Path(text);
		if (!path.toFile().exists()) {
			return inputName + ": The given path does not exist!";
		}
		
		if (path.toFile().isDirectory()) {
			return inputName + ": The given path is a directory, not an executable file.";
		}
		return null;
	}
	
	
}
