package org.deft.exporter.odftext;

import java.io.File;
import java.util.Map;

import org.deft.exporter.AbstractExporter;
import org.deft.repository.datamodel.Chapter;
import org.deft.repository.datamodel.Tutorial;
import org.eclipse.core.runtime.IProgressMonitor;

public abstract class AbstractOdfTextExporter extends AbstractExporter {


	@Override
	protected void export(Chapter chapter, Map<String, Object> options,
			IProgressMonitor monitor) {
		monitor.beginTask("Exporting ODF Text document", 1);
		monitor.worked(1);
		saveChapter(chapter, options);
	}
	
	

	protected abstract void saveChapter(Chapter chapter, Map<String, Object> options);
	
	
	
	protected String getOutputDirPath(Map<String, Object> options) {
		String path = (String)options.get(OdfTextExporterConstants.OUPUT_DIRECTORY);
		return path;
	}
	
	

	protected String getFilePathOfChapter(Chapter chapter, Map<String, Object> options, String extension) {
		String chapterFileName = chapter.getName() + extension;
		String dir = getOutputDirPath(options);
		String filePath = new File(dir, chapterFileName).getAbsolutePath();
		return filePath;
	}
	
	
	@Override
	protected void export(Tutorial tutorial, Map<String, Object> options,
			IProgressMonitor monitor) {
		throw new UnsupportedOperationException("No tutorial export for ODF files");
	}

}
