package org.deft.exporter.odftext;

import org.eclipse.core.runtime.IPath;
import org.eclipse.core.runtime.Path;
import org.eclipse.jface.dialogs.IInputValidator;

public class DirectoryInputValidator implements IInputValidator {

	private String inputName;
	private boolean canBeEmpty;
	
	public DirectoryInputValidator(boolean canBeEmpty, String inputName) {
		this.canBeEmpty = canBeEmpty;
		this.inputName = inputName;
	}
	
	@Override
	public String isValid(String text) {
		//can be empty and is indeed empty? -> no error
		if (canBeEmpty && (text == null || text.isEmpty())) {
			return null;
		}
		
		//path does not exist
		IPath path = new Path(text);
		if (!path.toFile().exists()) {
			return inputName + ": The given path does not exist!";
		}
		
		//path is not a directory
		if (!path.toFile().isDirectory()) {
			return inputName + ": The given path is not a directory";
		}
		return null;
	}
	
	
}
