package org.deft.exporter.odftext.pdf;

import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.util.Map;

import org.deft.exporter.odftext.AbstractOdfTextExporter;
import org.deft.openoffice.OpenOfficeManager;
import org.deft.repository.datamodel.Chapter;

import ag.ion.bion.officelayer.application.IOfficeApplication;
import ag.ion.bion.officelayer.application.OfficeApplicationException;
import ag.ion.bion.officelayer.document.DocumentDescriptor;
import ag.ion.bion.officelayer.document.DocumentException;
import ag.ion.bion.officelayer.document.IDocument;
import ag.ion.bion.officelayer.filter.PDFFilter;

public class OdfTextToPdfExporter extends AbstractOdfTextExporter {

	@Override
	public String getName() {
		return "PDF";
	}

	protected void saveChapter(Chapter chapter, Map<String, Object> options) {
		String chapterPath = getFilePathOfChapter(chapter, options, ".pdf");
		try {
			OpenOfficeManager mgr = new OpenOfficeManager();
			mgr.activate();
			IOfficeApplication app = mgr.getOfficeApplication();
			InputStream is = new ByteArrayInputStream(chapter.getChapterContent());
			IDocument doc = app.getDocumentService().loadDocument(is, DocumentDescriptor.DEFAULT_HIDDEN);
			doc.getPersistenceService().export(chapterPath, PDFFilter.FILTER);
		} catch (DocumentException e) {
			e.printStackTrace();
		} catch (OfficeApplicationException e) {
			e.printStackTrace();
		}
	}
	

}
