package org.deft.fragmentsourcegui;

import java.util.List;

import org.deft.repository.fragmentsource.FragmentSource;
import org.deft.repository.fragmentsource.OriginalFragmentLocation;

public interface FragmentSourceGui {

	public String getName();

	/**
	 * Opens a GUI for the user to select data which should be imported as artifacts.
	 * Returns the locations of data to be imported.
	 */
	public List<OriginalFragmentLocation> getLocationsForImport();
	
	/**
	 * If multiple locations are returned by getLocationsForImport() this
	 * might be because a directory has been selected and traversed recursively.
	 * 
	 * This method returns that location (directory). If this method is not applicable,
	 * (e.g. for non file-based fragment sources) null is returned.
	 * 
	 * Note that this method must be called after getLocationsForImport()
	 */
	public OriginalFragmentLocation getCommonRootLocation();
	
	public FragmentSource getFragmentSource();
}
