package org.deft.fragmentsourcegui;

import java.util.List;

/**
 * Registry of all registered FragmentSourceGuis. FragmentSourceGuis are User Interfaces
 * to select data, which should be imported into the repository,
 * for FragmentSources, for example a file chooser dialog for a Filesystem fragment source.
 */
public interface FragmentSourceGuiRegistry {

	public List<String> getFragmentSourceGuiIds();
	
	public FragmentSourceGui getFragmentSourceGui(String deftEditorId);
	
}
