package org.deft.gui.artifactselect;

import org.deft.repository.datamodel.Artifact;
import org.deft.repository.datamodel.Folder;
import org.deft.repository.datamodel.Nameable;
import org.deft.util.ImageHelper;
import org.eclipse.jface.viewers.ILabelProvider;
import org.eclipse.jface.viewers.ILabelProviderListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.ISharedImages;
import org.eclipse.ui.PlatformUI;

/**
 *  LabelProvider for the TreeView of the artifact selection dialog.
 */
public class ArtifactLabelProvider implements ILabelProvider {
	
	@Override
	public Image getImage(Object element) {
		if (element instanceof Folder) {
			Image icon = ImageHelper.getDeftIcon("enabled/fragment-folder.png");
			return icon;
		} else if (element instanceof Artifact) {
			Image icon = PlatformUI.getWorkbench().getSharedImages().getImage(ISharedImages.IMG_OBJ_FILE);
			return icon;
		}
		return null;
	}

	@Override
	public String getText(Object element) {
		if (element instanceof Nameable) {
			Nameable nameable = (Nameable)element;
			String name = nameable.getName();
			return name;
		} 
		return element.toString();
	}



	@Override
	public void addListener(ILabelProviderListener listener) {
	}

	@Override
	public void dispose() {
	}

	@Override
	public boolean isLabelProperty(Object element, String property) {
		return false;
	}

	@Override
	public void removeListener(ILabelProviderListener listener) {
	}

}
