package org.deft.gui.artifactselect;

import java.util.List;

import org.deft.gui.widgets.SelectedItemContainer;
import org.deft.repository.datamodel.Artifact;
import org.deft.repository.datamodel.Fragment;
import org.deft.repository.datamodel.FragmentType;
import org.deft.repository.datamodel.PathFragmentFilter;
import org.deft.repository.datamodel.Project;


public class SelectedArtifactContainer extends SelectedItemContainer {

	private Project project;
	
	public SelectedArtifactContainer(Project project) {
		this.project = project;
	}
		
	@Override
	public Artifact getSelectedItem() {
		return (Artifact)super.getSelectedItem();
	}
	
	@Override
	public void setSelectedItem(Object item) {
		if (item instanceof Artifact) {
			super.setSelectedItem(item);
		}
	}
	
	@Override
	public String getSelectedItemAsString() {
		Artifact a = getSelectedItem();
		if (a != null) {
			String s = a.getProjectRelativePath();
			return s;
		} else {
			return "";
		}
	}

	@Override
	public Artifact getRepresentedItem(String text) {
		if (text != null) {
			PathFragmentFilter filter = new PathFragmentFilter(text, FragmentType.ARTIFACT);
			List<Fragment> fragments = project.getFragments(filter);
			if (!fragments.isEmpty()) {
				Artifact item = (Artifact)fragments.get(0);
				return item;
			}
		}
		return null;
	}

}
