package org.deft.gui.view.project;

import org.deft.gui.view.project.nodes.CategoryNode;
import org.deft.repository.datamodel.FragmentType;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerSorter;

/**
 * Sorter for the categories in the Project Explorer. The categories shall
 * be displayed in the following order: Chapters, Artifacts, Images, Tutorials
 * 
 * @author abartho
 */
public class ProjectViewCategorySorter extends ViewerSorter {
	
	@Override
	public int compare(Viewer viewer, Object e1, Object e2) {
	
		CategoryNode c1 = (CategoryNode)e1;
		CategoryNode c2 = (CategoryNode)e2;
		
		int rank1 = getRank(c1.getType());
		int rank2 = getRank(c2.getType());
		
		return rank1 - rank2;
	}
	
	
	private int getRank(FragmentType type) {
		switch(type) {
		case CHAPTER: return 0;
		case ARTIFACT: return 1;
		case TUTORIAL: return 3;
		default: return 4;
		}
	}
	

}
