package org.deft.gui.view.project;

import org.deft.gui.view.project.nodes.ProjectViewNode;
import org.eclipse.jface.viewers.ILabelProvider;
import org.eclipse.jface.viewers.ILabelProviderListener;
import org.eclipse.swt.graphics.Image;



public class ProjectViewLabelProvider implements ILabelProvider {

	
	@Override
	public Image getImage(Object element) {
		if (element instanceof ProjectViewNode) {
			ProjectViewNode node = (ProjectViewNode)element;
			return node.getIcon();
		}
		return null;
	}

	@Override
	public String getText(Object element) {
		if (element instanceof ProjectViewNode) {
			ProjectViewNode node = (ProjectViewNode)element;
			return node.getText();
		}
		return "<error: unknown node type>";
	}

	@Override
	public void addListener(ILabelProviderListener listener) {
	}

	@Override
	public void dispose() {
	}

	@Override
	public boolean isLabelProperty(Object element, String property) {
		return false;
	}

	@Override
	public void removeListener(ILabelProviderListener listener) {
	}


}
