package org.deft.gui.view.project.nodes;

import java.util.Collections;
import java.util.List;

import org.deft.repository.datamodel.Artifact;
import org.deft.repository.datamodel.ArtifactReference;
import org.deft.repository.datamodel.Chapter;
import org.eclipse.swt.graphics.Image;

public abstract class ArtifactReferenceNode extends ProjectViewNode {

	private ArtifactReference reference;
	//saving chapter and artifact explicitly, so we can access them even after
	//the reference has been deleted from the repository
	private Chapter chapter;
	private Artifact artifact;
	
	public ArtifactReferenceNode(ArtifactReference reference) {
		this.reference = reference;
		this.chapter = reference.getChapter();
		this.artifact = reference.getArtifact();
	}
	
	public ArtifactReference getReference() {
		return reference;
	}
	
	@Override
	public abstract String getText();

	@Override
	public abstract Image getIcon();

	@Override
	public String getId() {
		return reference.getId();
	}

	@Override
	public boolean deletionAllowed() {
		return true;
	}

	@Override
	protected List<? extends Object> getListOfChildContentToDisplay() {
		return Collections.emptyList();
	}

	@Override
	protected ArtifactReference getContent() {
		return reference;
	}

	@Override
	protected ProjectViewNode createNodeFor(Object childContent) {
		return null;
	}
	
	protected Chapter getChapter() {
		return chapter;
	}
	
	protected Artifact getArtifact() {
		return artifact;
	}

}
