package org.deft.gui.view.project.nodes;

import java.util.List;

import org.deft.repository.datamodel.ArtifactReference;
import org.deft.repository.datamodel.Chapter;

public class ChapterNode extends FragmentNode {

	public ChapterNode(Chapter chapter) {
		super(chapter);
	}
	
	public Chapter getChapter() {
		return (Chapter)getFragment();
	}

	@Override
	protected ProjectViewNode createNodeFor(Object content) {
		ProjectViewNode node = ProjectViewNodeFactory.createReferenceNodeForChapter((ArtifactReference)content);
		return node;
	}
	
	@Override
	protected List<? extends Object> getListOfChildContentToDisplay() {
		List<ArtifactReference> references = ((Chapter)getFragment()).getArtifactReferences();
		return references;
	}
	
	@Override
	public String getText() {
		return super.getText() + " (" + getChapter().getArtifactReferences().size() + ")";
	}
	
}
