package org.deft.gui.view.project.nodes;

import java.util.Collections;
import java.util.List;

import org.deft.repository.datamodel.Fragment;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.ISharedImages;
import org.eclipse.ui.PlatformUI;

public abstract class FragmentNode extends ProjectViewNode {

	private Fragment fragment;
	
	public FragmentNode(Fragment fragment) {
		this.fragment = fragment;
	}
	
	public Fragment getFragment() {
		return fragment;
	}
	
	public String getId() {
		return fragment.getId();
	}
	
	public String getName() {
		return fragment.getName();
	}
	
	@Override
	public boolean deletionAllowed() {
		return true;
	}


	@Override
	public Image getIcon() {
		Image icon = PlatformUI.getWorkbench().getSharedImages().getImage(ISharedImages.IMG_OBJ_FILE);
		return icon;
	}

	@Override
	public String getText() {
		return fragment.getName();
	}
	
	@Override
	protected ProjectViewNode createNodeFor(Object childContent) {
		return null;
	}

	@Override
	protected Object getContent() {
		return getFragment();
	}

	@Override
	protected List<? extends Object> getListOfChildContentToDisplay() {
		return Collections.emptyList();
	}
}
