package org.deft.guidance;
import java.net.URL;

import org.deft.resource.ResourceHandler;
import org.deft.resource.ResourceHandlerFactory;
import org.deft.resource.ResourceHandlerProvider;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.osgi.framework.BundleContext;

/**
 * The activator class controls the plug-in life cycle
 */
public class OWLPlugin extends AbstractUIPlugin {

	// The plug-in ID
	public static final String PLUGIN_ID = "org.deft.guidance";

	// The shared instance
	private static OWLPlugin plugin;
	
	private static ResourceHandlerProvider provider;

	
	/**
	 * The constructor
	 */
	public OWLPlugin() {				
		plugin = this;
		initResourceManagement();
		System.out.println("OWL-Guidance activated");
	}
	
	private void initResourceManagement() {
		ResourceHandler handler = ResourceHandlerFactory.createSimpleResourceHandler("org.deft.guidance", ResourceHandlerFactory.ECLIPSE);
		provider = new ResourceHandlerProvider();
		provider.registerResourceHandler(handler);
	}
	
	
	public static URL getEmptyOntologyUrl() {
		URL url = provider.getAbsoluteResourceUrl("org.deft.guidance", "INPUTOWL/default.owl");
		return url;
	}
	
	public static URL getFilledOntologyUrl() {
		URL url = provider.getAbsoluteResourceUrl("org.deft.guidance", "INPUTOWL/deft.owl");
		return url;
	}
	


	/*
	 * (non-Javadoc)
	 * @see org.eclipse.ui.plugin.AbstractUIPlugin#start(org.osgi.framework.BundleContext)
	 */
	public void start(BundleContext context) throws Exception {
		super.start(context);
		plugin = this;
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.ui.plugin.AbstractUIPlugin#stop(org.osgi.framework.BundleContext)
	 */
	public void stop(BundleContext context) throws Exception {
		plugin = null;
		super.stop(context);
	}

	/**
	 * Returns the shared instance
	 *
	 * @return the shared instance
	 */
	public static OWLPlugin getDefault() {
		return plugin;
	}


}
