package org.deft.guidance.tasks;

import java.util.LinkedList;
import java.util.List;
import java.util.Set;

import org.semanticweb.owl.model.OWLClass;

import uk.ac.abdn.csd.REL.CQA.model.Solution;

/**
 * Abstract implementation of the TaskFactory interface which implements
 * use-case independent methods.
 */
public abstract class AbstractTaskFactory implements TaskFactory {

	private GuidanceOntologyAccessor accessor;
	
	public AbstractTaskFactory(GuidanceOntologyAccessor accessor) {
		this.accessor = accessor;
	}
	
	public GuidanceOntologyAccessor getAccessor() {
		return accessor;
	}
	
	public List<Task> createTasks(OWLClass taskType, Set<Solution> solutions) {
		List<Task> tasks = new LinkedList<Task>();
		for (Solution solution : solutions) {
			Task task = createTask(taskType, solution);
			tasks.add(task);
		}
		return tasks;
	}
	
	
}
