package org.deft.guidance.tasks;

import org.deft.actions.NewChapterAction;
import org.deft.actions.OpenChapterAction;
import org.deft.repository.datamodel.Chapter;
import org.deft.repository.datamodel.Project;
import org.eclipse.ui.PlatformUI;

import uk.ac.abdn.csd.REL.CQA.model.Solution;


public class CreateChapterTask extends Task {

	public CreateChapterTask(Solution solution, GuidanceOntologyAccessor accessor) {
		super(solution, accessor);
	}
	
	public String getProjectName() {
		String projectName = getShortValueForVariable("?x");
		return projectName;
	}

	@Override
	public String getTaskMessage() {
		String projectName = getRepository().getProjectById(normalizeName(getProjectName())).getName();
		return "Create new Chapter in Project " + projectName; 
	}
	/**
	 * Create a new Chapter in the input project 
	 */
	@Override
	public void execute(Project p) {
		
		NewChapterAction newChapter = new NewChapterAction(PlatformUI.getWorkbench()
				.getActiveWorkbenchWindow());
		
		Chapter c = newChapter.createFragment(p);
		
		new OpenChapterAction(PlatformUI.getWorkbench()
				.getActiveWorkbenchWindow()).openChapter(c);
		
		
	}

}
