package org.deft.guidance.tasks;

import org.semanticweb.owl.model.OWLClass;

import uk.ac.abdn.csd.REL.CQA.model.Solution;

public class DocumentationTaskFactory extends AbstractTaskFactory {

	
	public DocumentationTaskFactory(GuidanceOntologyAccessor accessor) {
		super(accessor);
	}
	
	

	
	
	public Task createTask(OWLClass taskType, Solution solution) {
		String taskName = getAccessor().getSimpleName(taskType);
		if (taskName.equals("CreateProjectTask")) {
			return new CreateProjectTask(solution, getAccessor());
		} else if (taskName.equals("CreateChapterTask")) {
			return new CreateChapterTask(solution, getAccessor());
		} else if (taskName.equals("ImportArtifactTask")) {
			return new ImportArtifactTask(solution, getAccessor());
		} else if (taskName.equals("UpdateArtifactTask")) {
			return new UpdateArtifactTask(solution, getAccessor());
		} else if (taskName.equals("CheckUpdatedRepresentationTask")) {
			return new CheckUpdatedRepresentationTask(solution, getAccessor());
		} else if (taskName.equals("RemoveReferenceTask")) {
			return new RemoveReferenceTask(solution, getAccessor());
		} else if (taskName.equals("RepairReferenceTask")) {
			return new RepairReferenceTask(solution, getAccessor());
		} else if (taskName.equals("SetReferenceCheckedTask")) {
			return new SetReferenceCheckedTask(solution, getAccessor());
		} else {
			throw new RuntimeException("Unknown Task Type: " + taskName);
		}
	}
	




	
}
