package org.deft.guidance.tasks;

import org.deft.actions.ImportArtifactAction;
import org.deft.fragmentsourcegui.EclipseFragmentSourceGuiRegistry;
import org.deft.fragmentsourcegui.FragmentSourceGui;
import org.deft.fragmentsourcegui.FragmentSourceGuiRegistry;
import org.deft.repository.datamodel.Project;
import org.eclipse.ui.PlatformUI;

import uk.ac.abdn.csd.REL.CQA.model.Solution;


public class ImportArtifactTask extends Task {
	
	public ImportArtifactTask(Solution solution, GuidanceOntologyAccessor accessor) {
		super(solution, accessor);
	}

	public String getProjectName() {
		String projectName = getShortValueForVariable("?x");
		return projectName;
	}

	@Override
	public String getTaskMessage() {
//		String projectName = getProjectName();
		String projectName = getRepository().getProjectById(normalizeName(getProjectName())).getName();
		return "Import new Artifact into Project " + projectName; 
	}
	/**
	 * Open the import artifact-dialog for the input project 
	 */
	@Override
	public void execute(Project p) {
		
		FragmentSourceGuiRegistry registry = new EclipseFragmentSourceGuiRegistry();

		FragmentSourceGui fsg = registry
				.getFragmentSourceGui(registry
						.getFragmentSourceGuiIds().get(0));
		
		new ImportArtifactAction(PlatformUI.getWorkbench()
				.getActiveWorkbenchWindow(), fsg)
				.importArtifacts(p);
		
	}


}
