package org.deft.guidance.tasks;

import org.deft.actions.GoToReferencedRepresentationAction;
import org.deft.repository.datamodel.ArtifactReference;
import org.deft.repository.datamodel.Chapter;
import org.deft.repository.datamodel.Project;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.PlatformUI;

import uk.ac.abdn.csd.REL.CQA.model.Solution;


public class RemoveReferenceTask extends ReferenceSpecificTask {
	
	public RemoveReferenceTask(Solution solution, GuidanceOntologyAccessor accessor) {
		super(solution, accessor);
	}

	public String getReferenceId() {
		String referenceName = getShortValueForVariable("?x");
		return referenceName;
	}

	@Override
	public String getTaskMessage() {
		ArtifactReference reference = getDeftArtifactReference();
		Chapter chapter = reference.getChapter();
		String chapterName = chapter.getName();
		return "Remove reference to missing artifact from chapter \"" + chapterName + "\"";
	}

	@Override
	public void execute(Project p) {
		IWorkbenchWindow window = PlatformUI.getWorkbench().getActiveWorkbenchWindow();
		GoToReferencedRepresentationAction gotoAction = new GoToReferencedRepresentationAction(window);
		ArtifactReference reference = getDeftArtifactReference();
		gotoAction.goToReference(reference);	
	}

	@Override
	public String getProjectName() {
		return null;
	}
	
	@Override
	public ArtifactReference getDeftArtifactReference() {
		String referenceId = getReferenceId();
		ArtifactReference reference = getRepository().getArtifactReference(referenceId);
		return reference;
	}

}
