package org.deft.guidance.tasks;

import java.util.List;
import java.util.Set;

import org.semanticweb.owl.model.OWLClass;

import uk.ac.abdn.csd.REL.CQA.model.Solution;

/**
 * A TaskFactory creates tasks. For each task specified in the ontology, there should be 
 * a corresponding Java class inheriting from class Task. Those are created by the TaskFactory.
 * 
 * Each guidance use case needs its own implementation of the TaskFactory.
 */
public interface TaskFactory {

	public List<Task> createTasks(OWLClass taskType, Set<Solution> solutions);
	
	public Task createTask(OWLClass taskType, Solution solution);
	
	
}
