package org.deft.guidance.tasks;

import org.deft.actions.UpdateArtifactAction;
import org.deft.repository.datamodel.Artifact;
import org.deft.repository.datamodel.Project;
import org.eclipse.ui.PlatformUI;

import uk.ac.abdn.csd.REL.CQA.model.Solution;

public class UpdateArtifactTask extends Task {
	
	public UpdateArtifactTask(Solution solution, GuidanceOntologyAccessor accessor) {
		super(solution, accessor);
	}

	public String getArtifactName() {
		String artifactName = getShortValueForVariable("?x");
		return artifactName;
	}

	@Override
	public String getTaskMessage() {
		Artifact artifact = getDeftArtifact();
		Project project = artifact.getProject();
		String artifactPath = artifact.getProjectRelativePath();
		return "Update artifact \"" + artifactPath + "\" in project \"" + project.getName() + "\""; 
	}

	@Override
	public void execute(Project p) {
		Artifact artifact = getDeftArtifact();
		UpdateArtifactAction updateAction = new UpdateArtifactAction(
				PlatformUI.getWorkbench().getActiveWorkbenchWindow());
		updateAction.updateArtifact(artifact);
		
	}

	@Override
	public String getProjectName() {
		return null;
	}

	private Artifact getDeftArtifact() {
		String deftArtifactId = getArtifactName();
		Artifact artifact = (Artifact)getRepository().getFragment(deftArtifactId);
		return artifact;
	}

}
