package org.deft.guidance.views;

import org.deft.guidance.tasks.Task;

import org.deft.repository.RepositoryImpl;
import org.deft.repository.repositorymanager.ContentManagementService;
import org.eclipse.jface.viewers.DoubleClickEvent;
import org.eclipse.jface.viewers.IDoubleClickListener;
import org.eclipse.jface.viewers.TreeSelection;
/**
 * This Listener execute the tasks, if you double-click on them.
 * 
 * @author Marcel Gerlach
 *
 */
public class TaskViewDoubleClickListener implements IDoubleClickListener {

	private ContentManagementService cms = RepositoryImpl.instance()
			.getContentManagementService();

	/**
	 * Execute the selected task
	 */
	@Override
	public void doubleClick(DoubleClickEvent event) {

		TreeSelection selection = (TreeSelection) event.getSelection();

		Task task = (Task) selection.getFirstElement();

		String projectName = null;

		try {
			projectName = normalizeName(task.getProjectName());

		} catch (NullPointerException e) {

			
		}

		task.execute(cms.getProjectById(projectName));

	}

	/**
	 * This method removes the URL-suffix. This is necessary to identify the
	 * tasks in the repository.
	 * 
	 * @param input task name with prefix
	 * @return normalized task name
	 */
	private String normalizeName(String input) {

		return input.replaceAll("http://www.most-project.eu/guidanceSystem/",
				"");

	}

}
