package org.deft.integrator;

import org.deft.operation.EmptyOperationConfiguration;
import org.deft.operation.OperationConfiguration;
import org.deft.repository.integrator.IntegratorConfiguration;

public abstract class AbstractEditorIntegrator implements EditorIntegrator {

	private IntegratorConfiguration integratorConfig;

	@Override
	public OperationConfiguration createConfiguration() {
		return new EmptyOperationConfiguration();
	}

	@Override
	public IntegratorConfiguration getIntegratorConfiguration() {
		if (integratorConfig == null) {
			integratorConfig = new IntegratorConfiguration(this);
		}
		return integratorConfig;
	}
	
	@Override
	public void resetIntegratorConfiguration() {
		integratorConfig = null;
	}
	
	@Override
	public void cleanup(String referenceId) {
	}

}
