package org.deft.integrator;

import org.deft.repository.integrator.ArtifactReferencePosition;
import org.deft.repository.integrator.Integrator;

/**
 * An EditorIntegrator replaces an artifact reference in a document with a
 * concrete artifact representation in an opened ChapterEditor. 
 */
public interface EditorIntegrator extends Integrator {
		
	/**
	 * Undoes - i.e. removes - a specific integration.
	 * 
	 * The method returns position of the representation before it was removed.
	 * 
	 * @param document the document on which the original integration has been performed
	 * @param id of the reference/representation
	 *
	 * @return the position of the removed representation
	 */
	public ArtifactReferencePosition undoIntegration(EditorChapterDocument document, String referenceId);
	
	/**
	 * Returns a short description of the Integrator. Used for the GUI. 
	 */
	public String getDescription();
	
	
	public ArtifactReferencePosition getPositionForRepresentation(EditorChapterDocument chapterDocument, String referenceId);
}
