package org.deft.openoffice;

import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.osgi.framework.BundleContext;

/**
 * Bundle activator which is responsible to shut down the OpenOffice 
 * process when the bundle (along with DEFT) is closed. 
 */
public class Activator extends AbstractUIPlugin {

	public static final String PLUGIN_ID = "org.deft.openoffice";

	private OpenOfficeManager officeManager;
	
	public void start(BundleContext context) throws Exception {
		System.err.println("######### STARTING " + PLUGIN_ID + " #########");
		super.start(context);
		this.officeManager = new OpenOfficeManager();
	}

	
	public void stop(BundleContext context) throws Exception {
		System.err.println("######### STOPPING " + PLUGIN_ID + " #########");
		officeManager.deactivateOpenOfficeIfPossible();
		super.stop(context);
	}
	
}
