package org.deft.operation;

import java.net.URL;

import org.deft.resource.ResourceHandler;
import org.deft.resource.ResourceHandlerFactory;
import org.w3c.dom.Element;

public abstract class AbstractOperationConfiguration implements OperationConfiguration {

	private String runAs = ResourceHandlerFactory.ECLIPSE;
	private String bundleName;
	
	public AbstractOperationConfiguration() {
		this.bundleName = getId();
		ResourceHandlerFactory.createSimpleResourceHandler(bundleName, ResourceHandlerFactory.ECLIPSE);
	}
	
	public AbstractOperationConfiguration(String bundleName) {
		this.bundleName = bundleName;
		ResourceHandlerFactory.createSimpleResourceHandler(bundleName, ResourceHandlerFactory.ECLIPSE);
	}
	
	@Override
	public URL getSchemaUrl() {
		ResourceHandler handler = ResourceHandlerFactory.createSimpleResourceHandler(bundleName, runAs);
		String localLocation = getLocalSchemaFileLocation();
		URL locationUrl = handler.getResourceUrl(localLocation);
		return locationUrl;		
	}
	
	protected abstract String getLocalSchemaFileLocation();
	
	protected void setRunsAsEclipse() {
		runAs = ResourceHandlerFactory.ECLIPSE;
	}
	
	//used for debugging purposes
	protected void setRunAsSimpleJava() {
		runAs = ResourceHandlerFactory.JAVA;
	}
	
	public boolean isValid(Element element) {
		URL schemaUrl = getSchemaUrl();
		boolean valid = ConfigurationXmlValidator.isValid(element, schemaUrl);
		return valid;
	}

	
}
