package org.deft.operation;

import java.io.IOException;
import java.net.URL;

import javax.xml.XMLConstants;
import javax.xml.transform.dom.DOMSource;
import javax.xml.validation.Schema;
import javax.xml.validation.SchemaFactory;
import javax.xml.validation.Validator;

import org.w3c.dom.Element;
import org.xml.sax.SAXException;

public class ConfigurationXmlValidator {

	public static boolean isValid(Element element, URL schemaUrl) {
		String language = XMLConstants.W3C_XML_SCHEMA_NS_URI;
    	SchemaFactory factory = SchemaFactory.newInstance(language);
    	try {
			Schema schema = factory.newSchema(schemaUrl);
			Validator validator = schema.newValidator();
			validator.validate(new DOMSource(element));
			return true;
		} catch (SAXException saxe) {
			saxe.printStackTrace();
		} catch (IOException ioe) {
			ioe.printStackTrace();
		}
		return false;
	}
	
}

