package org.deft.operation;

import org.deft.repository.artifacttype.ArtifactType;
import org.deft.repository.datamodel.Artifact;
import org.deft.repository.datamodel.ArtifactRepresentation;

public interface OperationChain extends Iterable<Operation> {

	public void addOperation(Operation operation);

	public Operation getOperation(int index);
	
	public int getOperationCount();
	
	public OperationChainConfiguration getChainConfigurations();
	
	public void resetChainConfigurations();
	
	public ArtifactRepresentation executeOperations(Artifact artifact);
	
	public ArtifactRepresentation executeOperations(Artifact artifact, int steps);
	
	public ArtifactRepresentation executeOperationsOnRevision(Artifact artifact, int revision);
	
	public void initBeforeExecution(Artifact artifact);
	public void cleanUpAfterExecution();
	
	public boolean isValidInputArtifactType(ArtifactType artifactType);
	
	public ArtifactRepresentation getInitialArtifactRepresentation(Artifact artifact, int revision);
	
	public String getFinalRepresentationType();
	
	public String getId();
	
	public String getDescription();
		
}
