package org.deft.operation.astmodifier.gui;

import org.deft.artifacttypesupport.codefile.transform.OutlineNode;
import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.Viewer;

public class AstModifierTreeContentProvider implements ITreeContentProvider {

	
	
	public Object[] getChildren(Object parentElement) {
		if (parentElement instanceof OutlineTreeWithReplacements) {
			OutlineNode root =  ((OutlineTreeWithReplacements)parentElement).getOutlineRoot();
			Object[] rootChildren = root.getChildren().toArray();
			return rootChildren;
		} else if (parentElement instanceof OutlineNode) {
			OutlineNode node = (OutlineNode)parentElement;
			Object[] children = node.getChildren().toArray();
			return children;
		}
		return new Object[0];
	}

	public Object getParent(Object element) {
		if (element instanceof OutlineNode) {
			return ((OutlineNode) element).getParent();
		}
		return null;
	}

	public boolean hasChildren(Object element) {
		if (element instanceof OutlineNode) {
			return ((OutlineNode) element).hasChildren();
		}
		return false;
	}

	public Object[] getElements(Object inputElement) {
		if (inputElement instanceof OutlineTreeWithReplacements) {
			OutlineNode root =  ((OutlineTreeWithReplacements)inputElement).getOutlineRoot();
			Object[] rootChildren = root.getChildren().toArray();
			return rootChildren;
		}
		System.out.println("Displaying for " + inputElement);
		return new Object[0];
	}


	@Override
	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {

	}

	@Override
	public void dispose() {
	}


}
