package org.deft.operation.astmodifier.gui;

import org.deft.artifacttypesupport.codefile.transform.OutlineNode;
import org.deft.util.ImageHelper;
import org.eclipse.jface.viewers.ILabelProviderListener;
import org.eclipse.jface.viewers.ITableLabelProvider;
import org.eclipse.swt.graphics.Image;

public class AstModifierTreeLabelProvider implements ITableLabelProvider {

	public OutlineTreeWithReplacements data;
	
	public AstModifierTreeLabelProvider(OutlineTreeWithReplacements data) {
		this.data = data;
	}

	public Image getColumnImage(Object obj, int columnIndex) {
		if (obj instanceof OutlineNode) {
			OutlineNode node = (OutlineNode) obj;
			if (columnIndex == 0) {
				String imagePath = node.getImagePath();
				String pluginId = node.getPluginId();
				return ImageHelper.getImage(imagePath, pluginId);
			}
			if (data.hasReplacement(node)) {
//				return ResourceHelper.getImage("rename.gif");
			}
		}
		return null;
	}

	public String getColumnText(Object obj, int columnIndex) {
		if (obj instanceof OutlineNode) {
			OutlineNode node = (OutlineNode) obj;
			if (columnIndex == 0) {
				return node.getLabel();
			}
			if (data.hasReplacement(node)) {
				return data.getReplacement(node);
			}
			return null;
		}
		return obj.toString();
	}

	public void addListener(ILabelProviderListener listener) {
	}

	public void dispose() {
	}

	public boolean isLabelProperty(Object element, String property) {
		return true;
	}

	public void removeListener(ILabelProviderListener listener) {
	}

}
