package org.deft.operation.bytearray2ecoreinstance;

import java.io.ByteArrayInputStream;
import java.io.InputStream;

import org.deft.operation.EmptyOperationConfiguration;
import org.deft.operation.OperationConfiguration;
import org.deft.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;


/**
 * An operation that takes the content of an xmi-file as byte array 
 * and returns an EObject, representing an Ecore instance.
 */
public class XmiAsByteArray2EcoreInstanceOperation extends ByteArray2EcoreInstanceOperation {

	@Override
	protected EObject getEcoreInstance(byte[] byteContent) {
		InputStream is = new ByteArrayInputStream(byteContent);
		EObject root = EcoreUtil.loadRegisteredEcoreInstance(is);
		return root;
	}
	
	@Override
	public OperationConfiguration createConfiguration() {
		return new EmptyOperationConfiguration();
	}


}



