package org.deft.operation.coolsoftware.gui;

import java.util.List;

import org.deft.util.ImageHelper;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.jface.viewers.ILabelProvider;
import org.eclipse.jface.viewers.ILabelProviderListener;
import org.eclipse.swt.graphics.Image;

public class EcoreClassAndPackageLabelProvider implements ILabelProvider {

	@Override
	public Image getImage(Object element) {
		if (element instanceof EPackage) {
			Image image = ImageHelper.getImage("icons/epackage.gif", "org.deft.representation.ecore");
			return image;
		} else if (element instanceof EClass) {
			Image image = ImageHelper.getImage("icons/eclass.gif", "org.deft.representation.ecore");
			return image;
		} else if (element instanceof Resource) {
			Image image = ImageHelper.getImage("icons/resource.png", "org.deft.representation.ecore");
			return image;
		}
		return null;
	}

	@Override
	public String getText(Object element) {
		if (element instanceof EPackage) {
			EPackage ep = (EPackage)element;
			return ep.getName();
		} else if (element instanceof EClass) {
			EClass ec = (EClass)element;
			return ec.getName();
		} else if (element instanceof Resource) {
			Resource resource = (Resource)element;
			List<EObject> contents = resource.getContents();
			if (contents != null && !contents.isEmpty() && contents.get(0) instanceof EPackage) {
				EPackage ep = (EPackage)contents.get(0);
				return "<resource:" + ep.getName() + ">";
			}
			return "<resource>";
		}
		return null;
	}

	
	@Override
	public void addListener(ILabelProviderListener listener) {
	}

	@Override
	public void dispose() {
	}

	@Override
	public boolean isLabelProperty(Object element, String property) {
		return false;
	}

	@Override
	public void removeListener(ILabelProviderListener listener) {
	}


}
