package org.deft.operation.coolsoftware.textcompute;

import javax.swing.text.StyleContext;

import org.deft.representation.styleddocument.data.ContentSequence;
import org.deft.representation.styleddocument.data.StyleEnum;
import org.deft.representation.styleddocument.data.TokenizedStyledDocument;
import org.deft.util.StyledDocumentUtil;

public class LatexTextBuilder {
	
	protected void addHeading(ContentSequence contentSequence, String string) {
		StyleContext context = new LocalStyle().getStyleContext();
		TokenizedStyledDocument tsd = new TokenizedStyledDocument(context);
		StyledDocumentUtil.add(tsd, string, StyleEnum.PARAGRAPH_HEADING.getName());
		contentSequence.addDocumentContent(tsd);
	}
	
	protected void addLineBreak(ContentSequence contentSequence) {
		TokenizedStyledDocument doc = new TokenizedStyledDocument();
		StyledDocumentUtil.add(doc, "\n");
		contentSequence.addDocumentContent(doc);
	}
	
	protected String getBoundString(int lower, int upper) {
		if (lower == upper) {
			if (lower == -1) {
				return "[*]";
			} else {
				return "[" + lower + "]";
			}
		} else {
			if (upper == -1) { 
				return "[" + lower + "..*]";
			} else {
				return "[" + lower + ".." + upper + "]";
			}
		}
	}

}
