package org.deft.operation.decoratedtreetooutputxml;

import java.net.URL;

import org.deft.operation.OperationConfiguration;
import org.deft.repository.ast.decoration.DecoratorSelection;
import org.deft.repository.ast.decoration.selected.SelectedDecorator;
import org.w3c.dom.Element;

public class DecoratedTreeToOutputXmlConfiguration implements OperationConfiguration {

	public static String ID = "org.deft.operation.decoratedtreetooutputxml";
	
	private DecoratorSelection decorators;
	
	public DecoratedTreeToOutputXmlConfiguration() {
		this.decorators = new DecoratorSelection();
		decorators.addDecorator(new SelectedDecorator());
	}
	
	@Override
	public String getId() {
		return ID;
	}

	
	public DecoratorSelection getDecorators() {
		return decorators;
	}
	
	@Override
	public void loadFromXml(Element element) {
		//decorator selection will not be serialized
	}
	

	@Override
	public void addToXml(Element root) {
		//decorator selection will not be serialized
	}
	

	@Override
	public URL getSchemaUrl() {
		return null;
	}
	
}
