package org.deft.operation.ecorediag2image;

import org.deft.operation.AbstractOperationConfiguration;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class EcoreDiag2ImageConfiguration extends AbstractOperationConfiguration {

	public static String ID = "org.deft.operation.ecorediag2image";
	
	private String diagramId;
	
	@Override
	public String getId() {
		return ID;
	}

	public void setDiagramId(String diagramId) {
		this.diagramId = diagramId;
	}
	
	public String getDiagramId() {
		return diagramId;
	}

	@Override
	public void loadFromXml(Element element) {
		if (isValid(element)) {
			Element eDiagramId = (Element)element.getElementsByTagName("diagramid").item(0);
			this.diagramId = eDiagramId.getTextContent();
		}
	}
	
	@Override
	public void addToXml(Element root) {
		Document doc = root.getOwnerDocument();
		Element eDiagramId = doc.createElement("diagramid");
		root.appendChild(eDiagramId);
		eDiagramId.setTextContent(this.diagramId);
	}

	@Override
	protected String getLocalSchemaFileLocation() {
		return "resources/schema.xsd";
	}


}
