package org.deft.operation.idents2styledrunningtext.gui;

import org.deft.configuration.OperationGui;
import org.deft.gui.widgets.SelectedItemContainerEvent;
import org.deft.gui.widgets.SelectedItemContainerListener;
import org.deft.operation.OperationConfiguration;
import org.deft.operation.idents2styledrunningtext.Idents2StyledRunningTextConfiguration;
import org.deft.operation.idents2styledrunningtext.gui.data.ScopeSelectionComposite;
import org.deft.repository.datamodel.Artifact;
import org.deft.repository.datamodel.ArtifactRepresentation;
import org.deft.representation.identifiers.IdentifiersRepresentation;
import org.deft.representation.identifiers.data.Scope;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Composite;

public class Idents2StyledRunningTextOperationGui implements OperationGui {

	private ScopeSelectionComposite ssComposite;
	private Idents2StyledRunningTextConfiguration identConfig;
	
	@Override
	public Composite createGuiComposite(Composite parent) {
		Composite composite = new Composite(parent, SWT.NONE);

		// Define layout of the children of this composite
		composite.setLayout(new FillLayout());
		ssComposite = new ScopeSelectionComposite(composite, SWT.FILL);
		ssComposite.getTreeViewer().setAutoExpandLevel(2);
		ssComposite.getText().setFocus();

		return composite;
	}
	
	

	
	
	
	@Override
	public void initializeGui(OperationConfiguration config,	
			Artifact artifact, ArtifactRepresentation artifactRepr) {
		identConfig = (Idents2StyledRunningTextConfiguration)config;
		Scope scope = ((IdentifiersRepresentation)artifactRepr).getRoot();
		ssComposite.setRootScope(scope);
		ssComposite.setGuiData();
		ssComposite.addSelectedItemContainerListener(new SelectedScopeListener());
	}
	
	
	private class SelectedScopeListener implements SelectedItemContainerListener {

		@Override
		public void selectionChanged(SelectedItemContainerEvent e) {
			Scope currentScope = ssComposite.getSelectedItemContainer().getSelectedItem();
			String scopeId = currentScope.getAsIdString();
			identConfig.setScopeId(scopeId);
		}
		
	}
}