package org.deft.operation.idents2styledrunningtext.gui.data;

import org.deft.representation.identifiers.data.Scope;
import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.Viewer;

public class ScopesContentProvider implements ITreeContentProvider {

	private Scope root;
	private static final Object[] NO_CHILDREN = new Object[0];
	
	@Override
	public void dispose() {
		this.root = null;
	}

	@Override
	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
		if (newInput instanceof Scope[]) {
			Scope[] scopes = (Scope[])newInput;
			this.root = scopes[0];
		}
	}

	@Override
	public Object[] getElements(Object inputElement) {
		Object[] rootElements = getRootElements();
		return rootElements;
	}
	
	
	private Object[] getRootElements() {
		Object[] rootElements = new Object[] {root};
		return rootElements;
	}

	@Override
	public Object[] getChildren(Object parentElement) {
		if (parentElement instanceof Scope) {
			Scope g = (Scope)parentElement;
			Object[] children = g.getChildScopes().toArray(); 
			return children;
		}
		return NO_CHILDREN;
	}
	


	@Override
	public Object getParent(Object element) {
		Scope scope = (Scope)element;
		Scope parent = scope.getParentScope();
		return parent;
	}

	@Override
	public boolean hasChildren(Object element) {
		return getChildren(element).length > 0;
	}
	
	
}
