package org.deft.operation.idents2styledrunningtext.gui.data;

import org.deft.gui.widgets.SelectedItemContainer;
import org.deft.representation.identifiers.data.Scope;


public class SelectedScopeContainer extends SelectedItemContainer {

	private Scope root;
	
	public SelectedScopeContainer(Scope root) {
		this.root = root;
	}
		
	@Override
	public Scope getSelectedItem() {
		return (Scope)super.getSelectedItem();
	}
	
	@Override
	public void setSelectedItem(Object item) {
		if (item instanceof Scope) {
			super.setSelectedItem(item);
		}
	}
	
	@Override
	public String getSelectedItemAsString() {
		Scope s = getSelectedItem();
		if (s != null) {
			String str = s.getFullyQualifiedName();
			return str;
		} else {
			return "";
		}
	}

	@Override
	public Scope getRepresentedItem(String text) {
		if (text != null) {
			Scope s = root.findScope(text);
			return s;
		}
		return null;
	}

}
