package org.deft.operation.linebreak.wrapper.options;

/**
 * Default values for the <code>LineWrapperOptions</code>.
 * 
 * @author Christoph Seidl
 * 
 * @see LineWrapperOptions
 */
public interface LineWrapperOptionsDefaults
{
	/**
	 * Default value for whether blank lines should be consumed.
	 */
	public static final boolean CONSUME_EXISTING_BLANK_LINES = false;
	
	/**
	 * Default value for how many blank lines should be preserved when consuming others.
	 */
	public static final int PRESERVE_BLANK_LINES_COUNT = 0;
		
	
	/**
	 * Default value for a token.
	 */
	public static final String TOKEN = "";
		
	/**
	 * Default value for the context of a token.
	 */
	public static final String CONTEXT = "";
	
	
	/**
	 * Default value for the binding strength.
	 */
	public static final int BINDING_STRENGTH = 0;
	
	/**
	 * Symbolic name of the default anchor.
	 */
	public static final String ANCHOR_NAME = "originalLine";
	
	/**
	 * Default value for the indentation.
	 */
	public static final int INDENTATION = 4;
}
