package org.deft.operation.linebreak.wrapper.util;

/**
 * Helper class that encodes "dangerous" characters in strings so that they can be used 
 * safely within HTML code. This is by no means complete but takes care of the essential
 * cases. For a more complete approach use JTidy or an equivalent library.
 * 
 * @author Christoph Seidl
 */
public class HtmlEncoder
{
	/**
	 * Encodes "dangerous" characters in strings so that they can be used safely 
	 * within HTML code.
	 * 
	 * @param input The string that is to be HTML encoded.
	 * @return The HTML encoded equivalent string.
	 */
	public static String encodeHtml(String input)
	{
		String output = input;
		
		//NOTE: The first argument is a regular expression, hence backslashes
		//have to be double escaped as \\\\.
		output = output.replaceAll("&", "&amp;");
		output = output.replaceAll(">", "&gt;");
		output = output.replaceAll("<", "&lt;");
		output = output.replaceAll("\"", "&quot;");
		output = output.replaceAll("'", "&#039;");
		output = output.replaceAll("\\\\", "&#092;");
		 
		return output;
	}
}
