package org.deft.operation.tempfile2ecorediag;

import java.io.File;

import org.deft.operation.EmptyOperationConfiguration;
import org.deft.operation.Operation;
import org.deft.operation.OperationConfiguration;
import org.deft.operation.exception.DeftInvalidOperationChainException;
import org.deft.repository.artifacttype.ArtifactType;
import org.deft.repository.artifacttype.ecore.EcoreTempFileRepresentation;
import org.deft.repository.datamodel.ArtifactRepresentation;
import org.deft.representation.ecore.EcoreRepresentation;
import org.deft.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;

public class TempFile2EcoreOperation implements Operation {


	@Override
	public ArtifactRepresentation executeOperation(ArtifactRepresentation representation, 
			ArtifactType type, OperationConfiguration config) {
		String tempFileName = checkAndUnwrap(representation);
		File tempFile = new File(tempFileName);
		EObject root = EcoreUtil.loadEcoreModel(tempFile);
		EcoreRepresentation er = new EcoreRepresentation(root);
		return er;
	}
	
	
	private String checkAndUnwrap(ArtifactRepresentation rep) {
		if (rep.getType().equals(EcoreTempFileRepresentation.TYPE)) {
			EcoreTempFileRepresentation tfr = (EcoreTempFileRepresentation)rep;
			return tfr.getPath();
		} else {
			throw new DeftInvalidOperationChainException();
		}
	}

	
	@Override
	public OperationConfiguration createConfiguration() {
		return new EmptyOperationConfiguration();
	}


	@Override
	public String getInputRepresentationType() {
		return EcoreTempFileRepresentation.TYPE;
	}


	@Override
	public String getResultingRepresentationType() {
		return EcoreRepresentation.TYPE;
	}

}



