package org.deft.operationchain.ecoreuml2attributeslisting.textcompute;

import javax.swing.text.StyledDocument;

import org.deft.util.StyledDocumentUtil;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EAttribute;

public class AttributesExplanationBuilder {
	
	public void addAttributesExplanation(EAttribute attribute, StyledDocument doc) {
		addDocumentationText(attribute, doc);
		StyledDocumentUtil.add(doc, " ");
	}

	
	private void addDocumentationText(EAttribute attribute, StyledDocument doc) {
		EAnnotation genmodel = attribute.getEAnnotation("http://www.eclipse.org/emf/2002/GenModel");
		String documentation = genmodel.getDetails().get("documentation");
		String linebreak = System.getProperty("line.separator");
		documentation = documentation.replaceAll(linebreak, " ");
		StyledDocumentUtil.add(doc, documentation);
	}
	
	
}
