package org.deft.operationchain.ecoreuml2generalizationslisting;

import org.deft.operation.AbstractOperationConfiguration;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class EcoreUml2GeneralizationsListingConfiguration extends AbstractOperationConfiguration {

	public static String ID = "org.deft.operation.ecoreuml2generalizationslisting";
	
	private String className;
	
	public EcoreUml2GeneralizationsListingConfiguration() {
		super("org.deft.operationchain.ecoreuml2generalizationslisting"); //pass bundle id in constructor!
	}
	
	@Override
	public String getId() {
		return ID;
	}
	
	
	public void setClassName(String className) {
		this.className = className;
	}
	
	
	public String getClassName() {
		return className;
	}
	

	@Override
	public void loadFromXml(Element element) {
		if (isValid(element)) {
			Element eIndividual = (Element)element.getElementsByTagName("class").item(0);
			this.className = eIndividual.getAttribute("name");
		}
	}
	

	@Override
	public void addToXml(Element root) {
		Document doc = root.getOwnerDocument();
		Element eIndividual = doc.createElement("class");
		eIndividual.setAttribute("name", className);
		root.appendChild(eIndividual);
	}
	

	@Override
	protected String getLocalSchemaFileLocation() {
		return "resources/uml2generalizationsschema.xsd";
	}
	


}
