package org.deft.projecttype.texlipse;

import net.sourceforge.texlipse.bibeditor.BibEditor;

import org.deft.chaptereditor.ChapterEditorInput;
import org.deft.chaptereditor.ChapterEditorPart;
import org.deft.repository.datamodel.Chapter;
import org.deft.repository.workspaceresources.WorkspaceManager;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.jface.text.IDocument;

public class TexlipseBibtexChapterEditorPart extends BibEditor implements ChapterEditorPart {

	public static final String ID = "org.deft.chaptereditor.texlipse.bibtex"; //$NON-NLS-1$
	
	private WorkspaceManager workspaceManager = WorkspaceManager.instance();
	private BibtexEditorChapterDocument chapterDocument;
	
	
	@Override
	public void doSave(IProgressMonitor monitor) {
		getChapterDocument().removeNonexistingReferencesFromRepository();
		performActualSave(monitor);
	}
	
	private void performActualSave(IProgressMonitor monitor) {
		super.doSave(monitor);
		Chapter chapter = getChapter();
		workspaceManager.saveWorkspaceCopyToRepository(chapter);
	}
	
	@Override
	public Chapter getChapter() {
		ChapterEditorInput input = (ChapterEditorInput)getEditorInput();
		Chapter chapter = input.getChapter();
		return chapter;
	}

	@Override
	public BibtexEditorChapterDocument getChapterDocument() {
		if (chapterDocumentDoesNotYetExist()) {
			instantiateChapterDocument();
		}
		return chapterDocument;
	}
	
	private boolean chapterDocumentDoesNotYetExist() {
		return chapterDocument == null;
	}
	
	private void instantiateChapterDocument() {
		Chapter chapter = getChapter();
		IDocument document = null;
		chapterDocument = new BibtexEditorChapterDocument(chapter, document);
	}

}
