package org.deft.repository.artifacttype;

import java.util.List;

/**
 * When a file is about to be imported into the repository it is necessary
 * to determine its type. This is done by inspecting the file extension.
 * 
 * This registry returns all known file extensions for a given artifact type
 * and all known artifact type ids for a file extension.
 * 
 * @author abartho
 */
public interface FileExtensionToArtifactTypeMappingRegistry {

	public List<String> getFileExtensions(String artifactTypeId);
	
	public List<String> getArtifactTypeIds(String fileExtension);

}
