package org.deft.repository.artifacttype.codefile.java;

import org.deft.artifacttypesupport.codefile.LanguageSpecifics;
import org.deft.artifacttypesupport.codefile.PlainCodeFileArtifactType;
import org.deft.artifacttypesupport.codefile.java.JavaLanguageSpecifics;
import org.deft.artifacttypesupport.codefile.java.parser.JavaParser;
import org.deft.repository.artifacttype.Validator;

public class JavaCodeFileArtifactType extends PlainCodeFileArtifactType {

	//must be same as in plugin.xml
	private static final String id = "org.deft.repository.artifacttype.codefile.java";
	private static Validator validator = new JavaParser();
	private JavaLanguageSpecifics languageSpecifics = new JavaLanguageSpecifics();
	
	public JavaCodeFileArtifactType() {
		super("java");
	}

	@Override
	public String getTypeId() {
		return id;
	}
	
	@Override
	public Validator getValidator() {
		return validator;
	}

	@Override
	public LanguageSpecifics getLanguageSpecifics() {
		return languageSpecifics;
	}
	
	@Override
	public String getArtifactTypeName() {
		return "Java";
	}
	
	

}
