package org.deft.repository.artifacttype.ecore;

import java.io.InputStream;
import java.util.List;

import org.deft.repository.artifacttype.MultiArtifactDependencies;
import org.deft.repository.artifacttype.Validator;
import org.deft.repository.fragmentsource.FileBasedFragmentLocation;
import org.deft.repository.fragmentsource.FragmentSource;
import org.deft.repository.fragmentsource.OriginalFragmentLocation;
import org.deft.util.EcoreUtil;
import org.eclipse.emf.ecore.EPackage;

public class EcoreValidator implements Validator {

	private EcoreCrossReferenceResolver resolver = new EcoreCrossReferenceResolver();
	
	@Override
	public void validate(InputStream is) {
	}

	@Override
	public List<OriginalFragmentLocation> getDependencyLocations(
			FragmentSource source, OriginalFragmentLocation location) {
		InputStream is = source.getInputStream(location);
		EPackage ePackage = EcoreUtil.loadEcoreModel(is);
		List<OriginalFragmentLocation> locations = resolver.getReferencedLocations(ePackage, 
				(FileBasedFragmentLocation)location);
		return locations;
	}
	
	@Override
	public MultiArtifactDependencies getMultiArtifactDependencies(FragmentSource source, OriginalFragmentLocation location) {
		MultiArtifactDependencies dependencies = new MultiArtifactDependencies(location);
		addDependencies(dependencies, source, location);
		return dependencies;
	}
	
	private void addDependencies(MultiArtifactDependencies dependencies,
			FragmentSource source, OriginalFragmentLocation location) {
		List<OriginalFragmentLocation> dependencyLocations = getDependencyLocations(source, location);
		dependencies.addDependentLocations(location, dependencyLocations);
		for (OriginalFragmentLocation dl : dependencyLocations) {
			addDependencies(dependencies, source, dl);
		}
	}
		

}
