package org.deft.repository.ast.decoration.replace;

import org.deft.repository.ast.annotation.Ident;
import org.deft.repository.ast.annotation.NodeInformation;
import org.deft.repository.ast.decoration.ReplaceGroup;
import org.deft.repository.ast.decoration.Templates;

public class ReplaceInformation extends NodeInformation {

	private ReplaceGroup replaceGroup;
	
	public ReplaceInformation(ReplaceGroup replaceGroup) {
		this.replaceGroup = replaceGroup;
	}
	
	public ReplaceGroup getReplaceGroup() {
		return replaceGroup;
	}
	
	@Override
	public Ident getIdent() {
		return Templates.REPLACE;
	}

	@Override
	public NodeInformation copy() {
		ReplaceInformation ni = new ReplaceInformation(replaceGroup);
		return ni;
	}
	
    public void addContentFromOtherNodeInformation(NodeInformation newInformation) {
		if (newInformation instanceof ReplaceInformation) {
			ReplaceInformation newReplaceInfo = (ReplaceInformation)newInformation;
			replaceGroup = newReplaceInfo.replaceGroup;
		}
    }

}
