package org.deft.repository.ast.decoration.selected;

import java.util.LinkedList;
import java.util.List;

import org.deft.repository.ast.annotation.Ident;
import org.deft.repository.ast.annotation.NodeInformation;
import org.deft.repository.ast.decoration.Templates;
import org.deft.repository.ast.jxpath.XPath;



public class SelectedInformation extends NodeInformation {
	
	private class SelectedData {
		private XPath xpath;
		private String artifactRefId;
		
		public SelectedData(XPath xpath, String artifactRefId) {
			this.xpath = xpath;
			this.artifactRefId = artifactRefId;
		}
	}
	
	private List<SelectedData> selectedList = new LinkedList<SelectedData>();

	@Override
	public Ident getIdent() {
		return Templates.SELECTED;
	}
	
	public void addSelectedData(XPath xpath, String artifactRefId) {
		SelectedData sd = new SelectedData(xpath, artifactRefId);
		selectedList.add(sd);
	}
	
	public XPath getXpath(int index) {
		return selectedList.get(index).xpath;
	}
	
	public String getArtifactReferenceId(int index) {
		return selectedList.get(index).artifactRefId;
	}	
	
	public int getNrOfSelectedData() {
		return selectedList.size();
	}
	
	@Override
	public void addContentFromOtherNodeInformation(NodeInformation newInformation) {
		if (newInformation instanceof SelectedInformation) {
			SelectedInformation newSelectedInfo = (SelectedInformation)newInformation;
			selectedList.addAll(newSelectedInfo.selectedList);
		}
	}
	
	@Override
	public NodeInformation copy() {
		SelectedInformation si = new SelectedInformation();
		si.addContentFromOtherNodeInformation(this);
		return si;
	}

}
