package org.deft.repository.chaptertype;

import org.deft.resource.ResourceHandler;
import org.deft.resource.ResourceHandlerFactory;
import org.deft.resource.impl.EclipsePluginResourceHandler;
import org.deft.resource.impl.SimpleJavaResourceHandler;

public abstract class ChapterAwareResourceHandlerFactory extends ResourceHandlerFactory {
	
	

	public static ChapterTypeResourceHandler createChapterTypeResourceHandler(ChapterType type, 
			String handlerKind) {
		if (handlerKind.equals(JAVA)) {
			ChapterTypeResourceHandler handler = createSimpleJavaChapterTypeResourceHandler(type);
			return handler;
		} else if (handlerKind.equals(ECLIPSE)) {
			ChapterTypeResourceHandler handler = createEclipseChapterTypeResourceHandler(type);
			return handler;
		}
		return null;
	}
	
	private static ChapterTypeResourceHandler 
			createSimpleJavaChapterTypeResourceHandler(ChapterType type) {
		ResourceHandler handler = new SimpleJavaResourceHandler(type.getNamespaceId());
		ChapterTypeResourceHandler typeHandler = new ChapterTypeResourceHandler(type, handler);
		return typeHandler;
	}
	
	private static ChapterTypeResourceHandler 
			createEclipseChapterTypeResourceHandler(ChapterType type) {
		ResourceHandler handler = new EclipsePluginResourceHandler(type.getNamespaceId());
		ChapterTypeResourceHandler typeHandler = new ChapterTypeResourceHandler(type, handler);
		return typeHandler;
	}
	
}
