package org.deft.repository.chaptertype;

import java.util.HashMap;
import java.util.Map;

import org.deft.resource.ResourceHandler;
import org.deft.resource.ResourceHandlerProvider;

public class ChapterAwareResourceHandlerProvider extends ResourceHandlerProvider {
	
	
	private Map<String, ChapterTypeResourceHandler> chapterTypeHandlerMap 
			= new HashMap<String, ChapterTypeResourceHandler>();
	
	public void registerResourceHandler(ResourceHandler handler) {
		super.registerResourceHandler(handler);
		if (handler instanceof ChapterTypeResourceHandler) {
			registerChapterTypeResourceHandler((ChapterTypeResourceHandler)handler);
		}
	}
	
	private void registerChapterTypeResourceHandler(ChapterTypeResourceHandler handler) {
		String typeId = handler.getProjectType().getId();
		chapterTypeHandlerMap.put(typeId, handler);
	}
	
	
	public ChapterTypeResourceHandler getChapterTypeResourceHandler(String chapterType) {
		ChapterTypeResourceHandler handler = chapterTypeHandlerMap.get(chapterType);
		return handler;
	}
	

}
