package org.deft.repository.chaptertype;

import java.util.List;

public interface ChapterType2IntegratorIdMappingRegistry {

	/**
	 * Returns the ids of all integrators which can operate on
	 * the given chapter type. This can be the ids of FileIntegrators or
	 * EditorIntegrators.
	 */
	public List<String> getIntegratorIds(String chapterTypeId);
	
	/**
	 * Returns the ids all chapter types on which a given integrator
	 * (represented by its id) can be applied. Usually there will be
	 * only one result, but it is possible that an integrator works
	 * for multiple chapter types (e.g. the OpenOffice document family)  
	 */
	public List<String> getChapterTypeIds(String integratorId);
	
}
