package org.deft.repository.check;

import org.deft.repository.exception.DeftParseException;
import org.deft.repository.fragmentsource.OriginalFragmentLocation;

public class InvalidArtifactError extends DeftError {

	private String artifactTypeId;
	private OriginalFragmentLocation location;
	private DeftParseException parseException;
	
	public InvalidArtifactError(String artifactTypeId, OriginalFragmentLocation location, DeftParseException parseException) {
		this.artifactTypeId = artifactTypeId;
		this.location = location;
		this.parseException = parseException;
	}
	
	@Override
	public String getErrorMessage() {
		return "Fragment at location " + location.getFullLocation() + " is not a valid artifact of type " + artifactTypeId;
	}
	
	public DeftParseException getParseException() {
		return parseException;
	}
	
	

}
