package org.deft.repository.check;

import java.util.LinkedList;
import java.util.List;

import org.deft.repository.fragmentsource.OriginalFragmentLocation;

public class MissingDependencyError extends DeftError {

	private OriginalFragmentLocation location;
	private List<OriginalFragmentLocation> missingLocations;
	
	public MissingDependencyError(OriginalFragmentLocation location, List<OriginalFragmentLocation> missingLocations) {
		this.location = location;
		this.missingLocations = missingLocations;
	}
	
	
	public List<OriginalFragmentLocation> getMissingLocations() {
		return new LinkedList<OriginalFragmentLocation>(missingLocations);
	}
	
	@Override
	public String getErrorMessage() {
		StringBuilder sb = new StringBuilder();
		sb.append("Fragment on location " + location.getFullLocation() + " has unsatisfied dependencies:\n");
		for (OriginalFragmentLocation location : missingLocations) {
			sb.append(location.getFullLocation() + "\n");
		}
		return sb.toString();
	}
}
