package org.deft.repository.datamodel;

import java.util.List;

import org.deft.repository.artifacttype.ArtifactType;


public interface Artifact extends Fragment {
	
	public String getFragmentSourceId();
	
	public String getOriginalLocation();
	
	public String getOriginalLocation(int revision);
	
	public String getOriginalLocation(String dependentFileId);
	
	public String getOriginalLocation(String dependentFileId, int revision);
	
	public String getArtifactTypeId();
	
	public ArtifactType getArtifactType();
	
	public List<Integer> getRevisions();
	
	public int getLatestRevision();
	
	public byte[] getArtifactContent();
	
	public byte[] getArtifactContent(int revision);
	
	public byte[] getContent(String dependentFileId);
	
	public byte[] getContent(String dependentFileId, int revision);
	
	public List<String> getDependentFileIds();
	
	public List<String> getDependentFileIds(int revision);
	
	public List<ArtifactReference> getArtifactReferences();
	
}
