package org.deft.repository.datamodel;


public enum ArtifactReferenceUpdateType {

	NOUPDATE(0, "noupdate", "NOUPDATE"),
	NORMALUPDATE(1, "normalupdate", "NORMALUPDATE"),
	UNCOMPUTABLEUPDATE(2, "uncomputableupdate", "UNCOMPUTABLEUPDATE"),
	MISSINGARTIFACT(3, "missingartifact", "MISSINGARTIFACT");

	public static final int NOUPDATE_VALUE = 0;
	public static final int NORMALUPDATE_VALUE = 1;
	public static final int UNCOMPUTABLEUPDATE_VALUE = 2;
	public static final int MISSINGARTIFACT_VALUE = 3;

	private static final ArtifactReferenceUpdateType[] VALUES_ARRAY =
		new ArtifactReferenceUpdateType[] {
			NOUPDATE,
			NORMALUPDATE,
			UNCOMPUTABLEUPDATE,
			MISSINGARTIFACT
		};

	public static ArtifactReferenceUpdateType get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			ArtifactReferenceUpdateType result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}


	public static ArtifactReferenceUpdateType getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			ArtifactReferenceUpdateType result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}


	public static ArtifactReferenceUpdateType get(int value) {
		switch (value) {
			case NOUPDATE_VALUE: return NOUPDATE;
			case NORMALUPDATE_VALUE: return NORMALUPDATE;
			case UNCOMPUTABLEUPDATE_VALUE: return UNCOMPUTABLEUPDATE;
			case MISSINGARTIFACT_VALUE: return MISSINGARTIFACT;
		}
		return null;
	}


	private final int value;


	private final String name;


	private final String literal;


	private ArtifactReferenceUpdateType(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}


	public int getValue() {
	  return value;
	}


	public String getName() {
	  return name;
	}


	public String getLiteral() {
	  return literal;
	}


	@Override
	public String toString() {
		return literal;
	}
	
} 
