package org.deft.repository.datamodel;

public interface FragmentFilter {

	public boolean accept(Fragment fragment);

	public static FragmentFilter CHAPTERFILTER = new FragmentFilter() {
		@Override
		public boolean accept(Fragment fragment) {
			return fragment instanceof Chapter;
		}		
	};
	
	public static FragmentFilter ARTIFACTFILTER = new FragmentFilter() {
		@Override
		public boolean accept(Fragment fragment) {
			return fragment instanceof Artifact;
		}		
	};
	
	
	public static FragmentFilter TUTORIALFILTER = new FragmentFilter() {
		@Override
		public boolean accept(Fragment fragment) {
			return fragment instanceof Tutorial;
		}		
	};
	
	public static FragmentFilter FOLDERFILTER = new FragmentFilter() {
		@Override
		public boolean accept(Fragment fragment) {
			return fragment instanceof Folder;
		}		
	};
	
}
