package org.deft.repository.datamodel;


public enum FragmentType {

	FRAGMENT(0, "fragment", "FRAGMENT"),
	CHAPTER(1, "chapter", "CHAPTER"),
	ARTIFACT(2, "artifact", "ARTIFACT"),
	TUTORIAL(3, "tutorial", "TUTORIAL"),
	FOLDER(4, "folder", "FOLDER");

	public static final int FRAGMENT_VALUE = 0;
	public static final int CHAPTER_VALUE = 1;
	public static final int ARTIFACT_VALUE = 2;
	public static final int TUTORIAL_VALUE = 3;
	public static final int FOLDER_VALUE = 4;

	private static final FragmentType[] VALUES_ARRAY =
		new FragmentType[] {
			FRAGMENT,
			CHAPTER,
			ARTIFACT,
			TUTORIAL,
			FOLDER,
		};

	public static FragmentType get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			FragmentType result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}


	public static FragmentType getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			FragmentType result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}


	public static FragmentType get(int value) {
		switch (value) {
			case FRAGMENT_VALUE: return FRAGMENT;
			case CHAPTER_VALUE: return CHAPTER;
			case ARTIFACT_VALUE: return ARTIFACT;
			case TUTORIAL_VALUE: return TUTORIAL;
			case FOLDER_VALUE: return FOLDER;
		}
		return null;
	}


	private final int value;


	private final String name;


	private final String literal;


	private FragmentType(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}


	public int getValue() {
	  return value;
	}


	public String getName() {
	  return name;
	}


	public String getLiteral() {
	  return literal;
	}


	@Override
	public String toString() {
		return literal;
	}
	
} 
