package org.deft.repository.datamodel.adapter.ecore;

import java.util.List;

import org.deft.repository.datamodel.ArtifactReference;
import org.deft.repository.datamodel.ecoredatamodel.Chapter;
import org.deft.repository.repositorymanager.ContentManagementService;

public class DeftChapterImpl extends DeftFragmentImpl implements org.deft.repository.datamodel.Chapter {

	public DeftChapterImpl(Chapter ecoreChapter, ContentManagementService cms) {
		super(ecoreChapter, cms);
	}
	
	@Override
	public String getTypeId() {
		Chapter ecoreChapter = (Chapter)getEcoreFragment();
		String typeId = ecoreChapter.getChapterType();
		return typeId;
	}
	
	public org.deft.repository.datamodel.FragmentType getFragmentType() {
		return org.deft.repository.datamodel.FragmentType.CHAPTER;
	}

	@Override
	public byte[] getChapterContent() {
		ContentManagementService cms = getContentManagementService();
		byte[] content = cms.getChapterContent(this);
		return content;
	}

	@Override
	public List<ArtifactReference> getArtifactReferences() {
		ContentManagementService cms = getContentManagementService();
		List<ArtifactReference> references = cms.getArtifactReferences(this);
		return references;
	}
	
	
	@Override
	public List<ArtifactReference> getUncheckedArtifactReferences() {
		ContentManagementService cms = getContentManagementService();
		List<ArtifactReference> references = cms.getUncheckedReferences(this);
		return references;
	}

	
	

}
