/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package org.deft.repository.datamodel.ecoredatamodel;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.deft.repository.datamodel.ecoredatamodel.DatamodelFactory
 * @model kind="package"
 * @generated
 */
public interface DatamodelPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "ecoredatamodel";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://deftproject.org";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "ecoredatamodel";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	DatamodelPackage eINSTANCE = org.deft.repository.datamodel.ecoredatamodel.impl.DatamodelPackageImpl.init();

	/**
	 * The meta object id for the '{@link org.deft.repository.datamodel.ecoredatamodel.impl.ProjectsContainerImpl <em>Projects Container</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.deft.repository.datamodel.ecoredatamodel.impl.ProjectsContainerImpl
	 * @see org.deft.repository.datamodel.ecoredatamodel.impl.DatamodelPackageImpl#getProjectsContainer()
	 * @generated
	 */
	int PROJECTS_CONTAINER = 0;

	/**
	 * The feature id for the '<em><b>Projects</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROJECTS_CONTAINER__PROJECTS = 0;

	/**
	 * The number of structural features of the '<em>Projects Container</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROJECTS_CONTAINER_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link org.deft.repository.datamodel.ecoredatamodel.impl.NameableImpl <em>Nameable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.deft.repository.datamodel.ecoredatamodel.impl.NameableImpl
	 * @see org.deft.repository.datamodel.ecoredatamodel.impl.DatamodelPackageImpl#getNameable()
	 * @generated
	 */
	int NAMEABLE = 1;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMEABLE__NAME = 0;

	/**
	 * The number of structural features of the '<em>Nameable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMEABLE_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link org.deft.repository.datamodel.ecoredatamodel.impl.IdentifiableImpl <em>Identifiable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.deft.repository.datamodel.ecoredatamodel.impl.IdentifiableImpl
	 * @see org.deft.repository.datamodel.ecoredatamodel.impl.DatamodelPackageImpl#getIdentifiable()
	 * @generated
	 */
	int IDENTIFIABLE = 2;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IDENTIFIABLE__ID = 0;

	/**
	 * The number of structural features of the '<em>Identifiable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IDENTIFIABLE_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link org.deft.repository.datamodel.ecoredatamodel.impl.ProjectImpl <em>Project</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.deft.repository.datamodel.ecoredatamodel.impl.ProjectImpl
	 * @see org.deft.repository.datamodel.ecoredatamodel.impl.DatamodelPackageImpl#getProject()
	 * @generated
	 */
	int PROJECT = 3;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROJECT__NAME = NAMEABLE__NAME;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROJECT__ID = NAMEABLE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Chapters</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROJECT__CHAPTERS = NAMEABLE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Artifacts</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROJECT__ARTIFACTS = NAMEABLE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Tutorials</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROJECT__TUTORIALS = NAMEABLE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Folders</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROJECT__FOLDERS = NAMEABLE_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Project Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROJECT__PROJECT_TYPE = NAMEABLE_FEATURE_COUNT + 5;

	/**
	 * The number of structural features of the '<em>Project</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROJECT_FEATURE_COUNT = NAMEABLE_FEATURE_COUNT + 6;

	/**
	 * The meta object id for the '{@link org.deft.repository.datamodel.ecoredatamodel.impl.FragmentImpl <em>Fragment</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.deft.repository.datamodel.ecoredatamodel.impl.FragmentImpl
	 * @see org.deft.repository.datamodel.ecoredatamodel.impl.DatamodelPackageImpl#getFragment()
	 * @generated
	 */
	int FRAGMENT = 4;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FRAGMENT__NAME = NAMEABLE__NAME;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FRAGMENT__ID = NAMEABLE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Parent Project</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FRAGMENT__PARENT_PROJECT = NAMEABLE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Parent</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FRAGMENT__PARENT = NAMEABLE_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Fragment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FRAGMENT_FEATURE_COUNT = NAMEABLE_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link org.deft.repository.datamodel.ecoredatamodel.impl.ChapterImpl <em>Chapter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.deft.repository.datamodel.ecoredatamodel.impl.ChapterImpl
	 * @see org.deft.repository.datamodel.ecoredatamodel.impl.DatamodelPackageImpl#getChapter()
	 * @generated
	 */
	int CHAPTER = 5;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CHAPTER__NAME = FRAGMENT__NAME;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CHAPTER__ID = FRAGMENT__ID;

	/**
	 * The feature id for the '<em><b>Parent Project</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CHAPTER__PARENT_PROJECT = FRAGMENT__PARENT_PROJECT;

	/**
	 * The feature id for the '<em><b>Parent</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CHAPTER__PARENT = FRAGMENT__PARENT;

	/**
	 * The feature id for the '<em><b>In Tutorials</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CHAPTER__IN_TUTORIALS = FRAGMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Artifact References</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CHAPTER__ARTIFACT_REFERENCES = FRAGMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Chapter Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CHAPTER__CHAPTER_TYPE = FRAGMENT_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Chapter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CHAPTER_FEATURE_COUNT = FRAGMENT_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link org.deft.repository.datamodel.ecoredatamodel.impl.ArtifactImpl <em>Artifact</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.deft.repository.datamodel.ecoredatamodel.impl.ArtifactImpl
	 * @see org.deft.repository.datamodel.ecoredatamodel.impl.DatamodelPackageImpl#getArtifact()
	 * @generated
	 */
	int ARTIFACT = 6;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARTIFACT__NAME = FRAGMENT__NAME;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARTIFACT__ID = FRAGMENT__ID;

	/**
	 * The feature id for the '<em><b>Parent Project</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARTIFACT__PARENT_PROJECT = FRAGMENT__PARENT_PROJECT;

	/**
	 * The feature id for the '<em><b>Parent</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARTIFACT__PARENT = FRAGMENT__PARENT;

	/**
	 * The feature id for the '<em><b>Source Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARTIFACT__SOURCE_ID = FRAGMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Artifact Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARTIFACT__ARTIFACT_TYPE = FRAGMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Artifact References</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARTIFACT__ARTIFACT_REFERENCES = FRAGMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Revisions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARTIFACT__REVISIONS = FRAGMENT_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Artifact</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_FEATURE_COUNT = FRAGMENT_FEATURE_COUNT + 4;

	/**
	 * The meta object id for the '{@link org.deft.repository.datamodel.ecoredatamodel.impl.TutorialImpl <em>Tutorial</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.deft.repository.datamodel.ecoredatamodel.impl.TutorialImpl
	 * @see org.deft.repository.datamodel.ecoredatamodel.impl.DatamodelPackageImpl#getTutorial()
	 * @generated
	 */
	int TUTORIAL = 7;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TUTORIAL__NAME = FRAGMENT__NAME;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TUTORIAL__ID = FRAGMENT__ID;

	/**
	 * The feature id for the '<em><b>Parent Project</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TUTORIAL__PARENT_PROJECT = FRAGMENT__PARENT_PROJECT;

	/**
	 * The feature id for the '<em><b>Parent</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TUTORIAL__PARENT = FRAGMENT__PARENT;

	/**
	 * The feature id for the '<em><b>Chapters</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TUTORIAL__CHAPTERS = FRAGMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Tutorial</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TUTORIAL_FEATURE_COUNT = FRAGMENT_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link org.deft.repository.datamodel.ecoredatamodel.impl.FolderImpl <em>Folder</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.deft.repository.datamodel.ecoredatamodel.impl.FolderImpl
	 * @see org.deft.repository.datamodel.ecoredatamodel.impl.DatamodelPackageImpl#getFolder()
	 * @generated
	 */
	int FOLDER = 8;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FOLDER__NAME = FRAGMENT__NAME;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FOLDER__ID = FRAGMENT__ID;

	/**
	 * The feature id for the '<em><b>Parent Project</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FOLDER__PARENT_PROJECT = FRAGMENT__PARENT_PROJECT;

	/**
	 * The feature id for the '<em><b>Parent</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FOLDER__PARENT = FRAGMENT__PARENT;

	/**
	 * The feature id for the '<em><b>Fragment Type Affiliation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FOLDER__FRAGMENT_TYPE_AFFILIATION = FRAGMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Children</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FOLDER__CHILDREN = FRAGMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Folder</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FOLDER_FEATURE_COUNT = FRAGMENT_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link org.deft.repository.datamodel.ecoredatamodel.impl.ReferableImpl <em>Referable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.deft.repository.datamodel.ecoredatamodel.impl.ReferableImpl
	 * @see org.deft.repository.datamodel.ecoredatamodel.impl.DatamodelPackageImpl#getReferable()
	 * @generated
	 */
	int REFERABLE = 9;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REFERABLE__NAME = NAMEABLE__NAME;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REFERABLE__ID = NAMEABLE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Occurrences</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REFERABLE__OCCURRENCES = NAMEABLE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Referable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REFERABLE_FEATURE_COUNT = NAMEABLE_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link org.deft.repository.datamodel.ecoredatamodel.impl.ArtifactReferenceImpl <em>Artifact Reference</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.deft.repository.datamodel.ecoredatamodel.impl.ArtifactReferenceImpl
	 * @see org.deft.repository.datamodel.ecoredatamodel.impl.DatamodelPackageImpl#getArtifactReference()
	 * @generated
	 */
	int ARTIFACT_REFERENCE = 10;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_REFERENCE__ID = IDENTIFIABLE__ID;

	/**
	 * The feature id for the '<em><b>Chapter</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_REFERENCE__CHAPTER = IDENTIFIABLE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Artifact</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_REFERENCE__ARTIFACT = IDENTIFIABLE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Integrator Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_REFERENCE__INTEGRATOR_ID = IDENTIFIABLE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Operation Chain Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_REFERENCE__OPERATION_CHAIN_ID = IDENTIFIABLE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Latest Checked Revision</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_REFERENCE__LATEST_CHECKED_REVISION = IDENTIFIABLE_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Update Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_REFERENCE__UPDATE_TYPE = IDENTIFIABLE_FEATURE_COUNT + 5;

	/**
	 * The number of structural features of the '<em>Artifact Reference</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_REFERENCE_FEATURE_COUNT = IDENTIFIABLE_FEATURE_COUNT + 6;

	/**
	 * The meta object id for the '{@link org.deft.repository.datamodel.ecoredatamodel.impl.DependencyImpl <em>Dependency</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.deft.repository.datamodel.ecoredatamodel.impl.DependencyImpl
	 * @see org.deft.repository.datamodel.ecoredatamodel.impl.DatamodelPackageImpl#getDependency()
	 * @generated
	 */
	int DEPENDENCY = 11;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY__ID = 0;

	/**
	 * The feature id for the '<em><b>Original Location</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY__ORIGINAL_LOCATION = 1;

	/**
	 * The feature id for the '<em><b>Dependencies</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY__DEPENDENCIES = 2;

	/**
	 * The number of structural features of the '<em>Dependency</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link org.deft.repository.datamodel.ecoredatamodel.impl.RevisionImpl <em>Revision</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.deft.repository.datamodel.ecoredatamodel.impl.RevisionImpl
	 * @see org.deft.repository.datamodel.ecoredatamodel.impl.DatamodelPackageImpl#getRevision()
	 * @generated
	 */
	int REVISION = 12;

	/**
	 * The feature id for the '<em><b>Revision Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REVISION__REVISION_NUMBER = 0;

	/**
	 * The feature id for the '<em><b>Dependencies</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REVISION__DEPENDENCIES = 1;

	/**
	 * The feature id for the '<em><b>Original Location</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REVISION__ORIGINAL_LOCATION = 2;

	/**
	 * The number of structural features of the '<em>Revision</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REVISION_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link org.deft.repository.datamodel.ecoredatamodel.FragmentType <em>Fragment Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.deft.repository.datamodel.ecoredatamodel.FragmentType
	 * @see org.deft.repository.datamodel.ecoredatamodel.impl.DatamodelPackageImpl#getFragmentType()
	 * @generated
	 */
	int FRAGMENT_TYPE = 13;


	/**
	 * The meta object id for the '{@link org.deft.repository.datamodel.ecoredatamodel.ArtifactReferenceUpdateType <em>Artifact Reference Update Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.deft.repository.datamodel.ecoredatamodel.ArtifactReferenceUpdateType
	 * @see org.deft.repository.datamodel.ecoredatamodel.impl.DatamodelPackageImpl#getArtifactReferenceUpdateType()
	 * @generated
	 */
	int ARTIFACT_REFERENCE_UPDATE_TYPE = 14;


	/**
	 * Returns the meta object for class '{@link org.deft.repository.datamodel.ecoredatamodel.ProjectsContainer <em>Projects Container</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Projects Container</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.ProjectsContainer
	 * @generated
	 */
	EClass getProjectsContainer();

	/**
	 * Returns the meta object for the containment reference list '{@link org.deft.repository.datamodel.ecoredatamodel.ProjectsContainer#getProjects <em>Projects</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Projects</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.ProjectsContainer#getProjects()
	 * @see #getProjectsContainer()
	 * @generated
	 */
	EReference getProjectsContainer_Projects();

	/**
	 * Returns the meta object for class '{@link org.deft.repository.datamodel.ecoredatamodel.Nameable <em>Nameable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Nameable</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.Nameable
	 * @generated
	 */
	EClass getNameable();

	/**
	 * Returns the meta object for the attribute '{@link org.deft.repository.datamodel.ecoredatamodel.Nameable#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.Nameable#getName()
	 * @see #getNameable()
	 * @generated
	 */
	EAttribute getNameable_Name();

	/**
	 * Returns the meta object for class '{@link org.deft.repository.datamodel.ecoredatamodel.Identifiable <em>Identifiable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Identifiable</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.Identifiable
	 * @generated
	 */
	EClass getIdentifiable();

	/**
	 * Returns the meta object for the attribute '{@link org.deft.repository.datamodel.ecoredatamodel.Identifiable#getId <em>Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Id</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.Identifiable#getId()
	 * @see #getIdentifiable()
	 * @generated
	 */
	EAttribute getIdentifiable_Id();

	/**
	 * Returns the meta object for class '{@link org.deft.repository.datamodel.ecoredatamodel.Project <em>Project</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Project</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.Project
	 * @generated
	 */
	EClass getProject();

	/**
	 * Returns the meta object for the containment reference list '{@link org.deft.repository.datamodel.ecoredatamodel.Project#getChapters <em>Chapters</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Chapters</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.Project#getChapters()
	 * @see #getProject()
	 * @generated
	 */
	EReference getProject_Chapters();

	/**
	 * Returns the meta object for the containment reference list '{@link org.deft.repository.datamodel.ecoredatamodel.Project#getArtifacts <em>Artifacts</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Artifacts</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.Project#getArtifacts()
	 * @see #getProject()
	 * @generated
	 */
	EReference getProject_Artifacts();

	/**
	 * Returns the meta object for the containment reference list '{@link org.deft.repository.datamodel.ecoredatamodel.Project#getTutorials <em>Tutorials</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Tutorials</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.Project#getTutorials()
	 * @see #getProject()
	 * @generated
	 */
	EReference getProject_Tutorials();

	/**
	 * Returns the meta object for the containment reference list '{@link org.deft.repository.datamodel.ecoredatamodel.Project#getFolders <em>Folders</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Folders</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.Project#getFolders()
	 * @see #getProject()
	 * @generated
	 */
	EReference getProject_Folders();

	/**
	 * Returns the meta object for the attribute '{@link org.deft.repository.datamodel.ecoredatamodel.Project#getProjectType <em>Project Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Project Type</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.Project#getProjectType()
	 * @see #getProject()
	 * @generated
	 */
	EAttribute getProject_ProjectType();

	/**
	 * Returns the meta object for class '{@link org.deft.repository.datamodel.ecoredatamodel.Fragment <em>Fragment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Fragment</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.Fragment
	 * @generated
	 */
	EClass getFragment();

	/**
	 * Returns the meta object for the reference '{@link org.deft.repository.datamodel.ecoredatamodel.Fragment#getParentProject <em>Parent Project</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Parent Project</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.Fragment#getParentProject()
	 * @see #getFragment()
	 * @generated
	 */
	EReference getFragment_ParentProject();

	/**
	 * Returns the meta object for the container reference '{@link org.deft.repository.datamodel.ecoredatamodel.Fragment#getParent <em>Parent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Parent</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.Fragment#getParent()
	 * @see #getFragment()
	 * @generated
	 */
	EReference getFragment_Parent();

	/**
	 * Returns the meta object for class '{@link org.deft.repository.datamodel.ecoredatamodel.Chapter <em>Chapter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Chapter</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.Chapter
	 * @generated
	 */
	EClass getChapter();

	/**
	 * Returns the meta object for the reference list '{@link org.deft.repository.datamodel.ecoredatamodel.Chapter#getInTutorials <em>In Tutorials</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>In Tutorials</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.Chapter#getInTutorials()
	 * @see #getChapter()
	 * @generated
	 */
	EReference getChapter_InTutorials();

	/**
	 * Returns the meta object for the containment reference list '{@link org.deft.repository.datamodel.ecoredatamodel.Chapter#getArtifactReferences <em>Artifact References</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Artifact References</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.Chapter#getArtifactReferences()
	 * @see #getChapter()
	 * @generated
	 */
	EReference getChapter_ArtifactReferences();

	/**
	 * Returns the meta object for the attribute '{@link org.deft.repository.datamodel.ecoredatamodel.Chapter#getChapterType <em>Chapter Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Chapter Type</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.Chapter#getChapterType()
	 * @see #getChapter()
	 * @generated
	 */
	EAttribute getChapter_ChapterType();

	/**
	 * Returns the meta object for class '{@link org.deft.repository.datamodel.ecoredatamodel.Artifact <em>Artifact</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Artifact</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.Artifact
	 * @generated
	 */
	EClass getArtifact();

	/**
	 * Returns the meta object for the attribute '{@link org.deft.repository.datamodel.ecoredatamodel.Artifact#getSourceId <em>Source Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Source Id</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.Artifact#getSourceId()
	 * @see #getArtifact()
	 * @generated
	 */
	EAttribute getArtifact_SourceId();

	/**
	 * Returns the meta object for the attribute '{@link org.deft.repository.datamodel.ecoredatamodel.Artifact#getArtifactType <em>Artifact Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Artifact Type</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.Artifact#getArtifactType()
	 * @see #getArtifact()
	 * @generated
	 */
	EAttribute getArtifact_ArtifactType();

	/**
	 * Returns the meta object for the reference list '{@link org.deft.repository.datamodel.ecoredatamodel.Artifact#getArtifactReferences <em>Artifact References</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Artifact References</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.Artifact#getArtifactReferences()
	 * @see #getArtifact()
	 * @generated
	 */
	EReference getArtifact_ArtifactReferences();

	/**
	 * Returns the meta object for the containment reference list '{@link org.deft.repository.datamodel.ecoredatamodel.Artifact#getRevisions <em>Revisions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Revisions</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.Artifact#getRevisions()
	 * @see #getArtifact()
	 * @generated
	 */
	EReference getArtifact_Revisions();

	/**
	 * Returns the meta object for class '{@link org.deft.repository.datamodel.ecoredatamodel.Tutorial <em>Tutorial</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Tutorial</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.Tutorial
	 * @generated
	 */
	EClass getTutorial();

	/**
	 * Returns the meta object for the reference list '{@link org.deft.repository.datamodel.ecoredatamodel.Tutorial#getChapters <em>Chapters</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Chapters</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.Tutorial#getChapters()
	 * @see #getTutorial()
	 * @generated
	 */
	EReference getTutorial_Chapters();

	/**
	 * Returns the meta object for class '{@link org.deft.repository.datamodel.ecoredatamodel.Folder <em>Folder</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Folder</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.Folder
	 * @generated
	 */
	EClass getFolder();

	/**
	 * Returns the meta object for the attribute '{@link org.deft.repository.datamodel.ecoredatamodel.Folder#getFragmentTypeAffiliation <em>Fragment Type Affiliation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Fragment Type Affiliation</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.Folder#getFragmentTypeAffiliation()
	 * @see #getFolder()
	 * @generated
	 */
	EAttribute getFolder_FragmentTypeAffiliation();

	/**
	 * Returns the meta object for the containment reference list '{@link org.deft.repository.datamodel.ecoredatamodel.Folder#getChildren <em>Children</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Children</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.Folder#getChildren()
	 * @see #getFolder()
	 * @generated
	 */
	EReference getFolder_Children();

	/**
	 * Returns the meta object for class '{@link org.deft.repository.datamodel.ecoredatamodel.Referable <em>Referable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Referable</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.Referable
	 * @generated
	 */
	EClass getReferable();

	/**
	 * Returns the meta object for the reference list '{@link org.deft.repository.datamodel.ecoredatamodel.Referable#getOccurrences <em>Occurrences</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Occurrences</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.Referable#getOccurrences()
	 * @see #getReferable()
	 * @generated
	 */
	EReference getReferable_Occurrences();

	/**
	 * Returns the meta object for class '{@link org.deft.repository.datamodel.ecoredatamodel.ArtifactReference <em>Artifact Reference</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Artifact Reference</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.ArtifactReference
	 * @generated
	 */
	EClass getArtifactReference();

	/**
	 * Returns the meta object for the reference '{@link org.deft.repository.datamodel.ecoredatamodel.ArtifactReference#getChapter <em>Chapter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Chapter</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.ArtifactReference#getChapter()
	 * @see #getArtifactReference()
	 * @generated
	 */
	EReference getArtifactReference_Chapter();

	/**
	 * Returns the meta object for the reference '{@link org.deft.repository.datamodel.ecoredatamodel.ArtifactReference#getArtifact <em>Artifact</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Artifact</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.ArtifactReference#getArtifact()
	 * @see #getArtifactReference()
	 * @generated
	 */
	EReference getArtifactReference_Artifact();

	/**
	 * Returns the meta object for the attribute '{@link org.deft.repository.datamodel.ecoredatamodel.ArtifactReference#getIntegratorId <em>Integrator Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Integrator Id</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.ArtifactReference#getIntegratorId()
	 * @see #getArtifactReference()
	 * @generated
	 */
	EAttribute getArtifactReference_IntegratorId();

	/**
	 * Returns the meta object for the attribute '{@link org.deft.repository.datamodel.ecoredatamodel.ArtifactReference#getOperationChainId <em>Operation Chain Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Operation Chain Id</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.ArtifactReference#getOperationChainId()
	 * @see #getArtifactReference()
	 * @generated
	 */
	EAttribute getArtifactReference_OperationChainId();

	/**
	 * Returns the meta object for the attribute '{@link org.deft.repository.datamodel.ecoredatamodel.ArtifactReference#getLatestCheckedRevision <em>Latest Checked Revision</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Latest Checked Revision</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.ArtifactReference#getLatestCheckedRevision()
	 * @see #getArtifactReference()
	 * @generated
	 */
	EAttribute getArtifactReference_LatestCheckedRevision();

	/**
	 * Returns the meta object for the attribute '{@link org.deft.repository.datamodel.ecoredatamodel.ArtifactReference#getUpdateType <em>Update Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Update Type</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.ArtifactReference#getUpdateType()
	 * @see #getArtifactReference()
	 * @generated
	 */
	EAttribute getArtifactReference_UpdateType();

	/**
	 * Returns the meta object for class '{@link org.deft.repository.datamodel.ecoredatamodel.Dependency <em>Dependency</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Dependency</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.Dependency
	 * @generated
	 */
	EClass getDependency();

	/**
	 * Returns the meta object for the attribute '{@link org.deft.repository.datamodel.ecoredatamodel.Dependency#getId <em>Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Id</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.Dependency#getId()
	 * @see #getDependency()
	 * @generated
	 */
	EAttribute getDependency_Id();

	/**
	 * Returns the meta object for the attribute '{@link org.deft.repository.datamodel.ecoredatamodel.Dependency#getOriginalLocation <em>Original Location</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Original Location</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.Dependency#getOriginalLocation()
	 * @see #getDependency()
	 * @generated
	 */
	EAttribute getDependency_OriginalLocation();

	/**
	 * Returns the meta object for the containment reference list '{@link org.deft.repository.datamodel.ecoredatamodel.Dependency#getDependencies <em>Dependencies</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Dependencies</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.Dependency#getDependencies()
	 * @see #getDependency()
	 * @generated
	 */
	EReference getDependency_Dependencies();

	/**
	 * Returns the meta object for class '{@link org.deft.repository.datamodel.ecoredatamodel.Revision <em>Revision</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Revision</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.Revision
	 * @generated
	 */
	EClass getRevision();

	/**
	 * Returns the meta object for the attribute '{@link org.deft.repository.datamodel.ecoredatamodel.Revision#getRevisionNumber <em>Revision Number</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Revision Number</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.Revision#getRevisionNumber()
	 * @see #getRevision()
	 * @generated
	 */
	EAttribute getRevision_RevisionNumber();

	/**
	 * Returns the meta object for the containment reference list '{@link org.deft.repository.datamodel.ecoredatamodel.Revision#getDependencies <em>Dependencies</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Dependencies</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.Revision#getDependencies()
	 * @see #getRevision()
	 * @generated
	 */
	EReference getRevision_Dependencies();

	/**
	 * Returns the meta object for the attribute '{@link org.deft.repository.datamodel.ecoredatamodel.Revision#getOriginalLocation <em>Original Location</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Original Location</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.Revision#getOriginalLocation()
	 * @see #getRevision()
	 * @generated
	 */
	EAttribute getRevision_OriginalLocation();

	/**
	 * Returns the meta object for enum '{@link org.deft.repository.datamodel.ecoredatamodel.FragmentType <em>Fragment Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Fragment Type</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.FragmentType
	 * @generated
	 */
	EEnum getFragmentType();

	/**
	 * Returns the meta object for enum '{@link org.deft.repository.datamodel.ecoredatamodel.ArtifactReferenceUpdateType <em>Artifact Reference Update Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Artifact Reference Update Type</em>'.
	 * @see org.deft.repository.datamodel.ecoredatamodel.ArtifactReferenceUpdateType
	 * @generated
	 */
	EEnum getArtifactReferenceUpdateType();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	DatamodelFactory getDatamodelFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link org.deft.repository.datamodel.ecoredatamodel.impl.ProjectsContainerImpl <em>Projects Container</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.deft.repository.datamodel.ecoredatamodel.impl.ProjectsContainerImpl
		 * @see org.deft.repository.datamodel.ecoredatamodel.impl.DatamodelPackageImpl#getProjectsContainer()
		 * @generated
		 */
		EClass PROJECTS_CONTAINER = eINSTANCE.getProjectsContainer();

		/**
		 * The meta object literal for the '<em><b>Projects</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROJECTS_CONTAINER__PROJECTS = eINSTANCE.getProjectsContainer_Projects();

		/**
		 * The meta object literal for the '{@link org.deft.repository.datamodel.ecoredatamodel.impl.NameableImpl <em>Nameable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.deft.repository.datamodel.ecoredatamodel.impl.NameableImpl
		 * @see org.deft.repository.datamodel.ecoredatamodel.impl.DatamodelPackageImpl#getNameable()
		 * @generated
		 */
		EClass NAMEABLE = eINSTANCE.getNameable();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute NAMEABLE__NAME = eINSTANCE.getNameable_Name();

		/**
		 * The meta object literal for the '{@link org.deft.repository.datamodel.ecoredatamodel.impl.IdentifiableImpl <em>Identifiable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.deft.repository.datamodel.ecoredatamodel.impl.IdentifiableImpl
		 * @see org.deft.repository.datamodel.ecoredatamodel.impl.DatamodelPackageImpl#getIdentifiable()
		 * @generated
		 */
		EClass IDENTIFIABLE = eINSTANCE.getIdentifiable();

		/**
		 * The meta object literal for the '<em><b>Id</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute IDENTIFIABLE__ID = eINSTANCE.getIdentifiable_Id();

		/**
		 * The meta object literal for the '{@link org.deft.repository.datamodel.ecoredatamodel.impl.ProjectImpl <em>Project</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.deft.repository.datamodel.ecoredatamodel.impl.ProjectImpl
		 * @see org.deft.repository.datamodel.ecoredatamodel.impl.DatamodelPackageImpl#getProject()
		 * @generated
		 */
		EClass PROJECT = eINSTANCE.getProject();

		/**
		 * The meta object literal for the '<em><b>Chapters</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROJECT__CHAPTERS = eINSTANCE.getProject_Chapters();

		/**
		 * The meta object literal for the '<em><b>Artifacts</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROJECT__ARTIFACTS = eINSTANCE.getProject_Artifacts();

		/**
		 * The meta object literal for the '<em><b>Tutorials</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROJECT__TUTORIALS = eINSTANCE.getProject_Tutorials();

		/**
		 * The meta object literal for the '<em><b>Folders</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROJECT__FOLDERS = eINSTANCE.getProject_Folders();

		/**
		 * The meta object literal for the '<em><b>Project Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PROJECT__PROJECT_TYPE = eINSTANCE.getProject_ProjectType();

		/**
		 * The meta object literal for the '{@link org.deft.repository.datamodel.ecoredatamodel.impl.FragmentImpl <em>Fragment</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.deft.repository.datamodel.ecoredatamodel.impl.FragmentImpl
		 * @see org.deft.repository.datamodel.ecoredatamodel.impl.DatamodelPackageImpl#getFragment()
		 * @generated
		 */
		EClass FRAGMENT = eINSTANCE.getFragment();

		/**
		 * The meta object literal for the '<em><b>Parent Project</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FRAGMENT__PARENT_PROJECT = eINSTANCE.getFragment_ParentProject();

		/**
		 * The meta object literal for the '<em><b>Parent</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FRAGMENT__PARENT = eINSTANCE.getFragment_Parent();

		/**
		 * The meta object literal for the '{@link org.deft.repository.datamodel.ecoredatamodel.impl.ChapterImpl <em>Chapter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.deft.repository.datamodel.ecoredatamodel.impl.ChapterImpl
		 * @see org.deft.repository.datamodel.ecoredatamodel.impl.DatamodelPackageImpl#getChapter()
		 * @generated
		 */
		EClass CHAPTER = eINSTANCE.getChapter();

		/**
		 * The meta object literal for the '<em><b>In Tutorials</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CHAPTER__IN_TUTORIALS = eINSTANCE.getChapter_InTutorials();

		/**
		 * The meta object literal for the '<em><b>Artifact References</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CHAPTER__ARTIFACT_REFERENCES = eINSTANCE.getChapter_ArtifactReferences();

		/**
		 * The meta object literal for the '<em><b>Chapter Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CHAPTER__CHAPTER_TYPE = eINSTANCE.getChapter_ChapterType();

		/**
		 * The meta object literal for the '{@link org.deft.repository.datamodel.ecoredatamodel.impl.ArtifactImpl <em>Artifact</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.deft.repository.datamodel.ecoredatamodel.impl.ArtifactImpl
		 * @see org.deft.repository.datamodel.ecoredatamodel.impl.DatamodelPackageImpl#getArtifact()
		 * @generated
		 */
		EClass ARTIFACT = eINSTANCE.getArtifact();

		/**
		 * The meta object literal for the '<em><b>Source Id</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ARTIFACT__SOURCE_ID = eINSTANCE.getArtifact_SourceId();

		/**
		 * The meta object literal for the '<em><b>Artifact Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ARTIFACT__ARTIFACT_TYPE = eINSTANCE.getArtifact_ArtifactType();

		/**
		 * The meta object literal for the '<em><b>Artifact References</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ARTIFACT__ARTIFACT_REFERENCES = eINSTANCE.getArtifact_ArtifactReferences();

		/**
		 * The meta object literal for the '<em><b>Revisions</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ARTIFACT__REVISIONS = eINSTANCE.getArtifact_Revisions();

		/**
		 * The meta object literal for the '{@link org.deft.repository.datamodel.ecoredatamodel.impl.TutorialImpl <em>Tutorial</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.deft.repository.datamodel.ecoredatamodel.impl.TutorialImpl
		 * @see org.deft.repository.datamodel.ecoredatamodel.impl.DatamodelPackageImpl#getTutorial()
		 * @generated
		 */
		EClass TUTORIAL = eINSTANCE.getTutorial();

		/**
		 * The meta object literal for the '<em><b>Chapters</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference TUTORIAL__CHAPTERS = eINSTANCE.getTutorial_Chapters();

		/**
		 * The meta object literal for the '{@link org.deft.repository.datamodel.ecoredatamodel.impl.FolderImpl <em>Folder</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.deft.repository.datamodel.ecoredatamodel.impl.FolderImpl
		 * @see org.deft.repository.datamodel.ecoredatamodel.impl.DatamodelPackageImpl#getFolder()
		 * @generated
		 */
		EClass FOLDER = eINSTANCE.getFolder();

		/**
		 * The meta object literal for the '<em><b>Fragment Type Affiliation</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FOLDER__FRAGMENT_TYPE_AFFILIATION = eINSTANCE.getFolder_FragmentTypeAffiliation();

		/**
		 * The meta object literal for the '<em><b>Children</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FOLDER__CHILDREN = eINSTANCE.getFolder_Children();

		/**
		 * The meta object literal for the '{@link org.deft.repository.datamodel.ecoredatamodel.impl.ReferableImpl <em>Referable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.deft.repository.datamodel.ecoredatamodel.impl.ReferableImpl
		 * @see org.deft.repository.datamodel.ecoredatamodel.impl.DatamodelPackageImpl#getReferable()
		 * @generated
		 */
		EClass REFERABLE = eINSTANCE.getReferable();

		/**
		 * The meta object literal for the '<em><b>Occurrences</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference REFERABLE__OCCURRENCES = eINSTANCE.getReferable_Occurrences();

		/**
		 * The meta object literal for the '{@link org.deft.repository.datamodel.ecoredatamodel.impl.ArtifactReferenceImpl <em>Artifact Reference</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.deft.repository.datamodel.ecoredatamodel.impl.ArtifactReferenceImpl
		 * @see org.deft.repository.datamodel.ecoredatamodel.impl.DatamodelPackageImpl#getArtifactReference()
		 * @generated
		 */
		EClass ARTIFACT_REFERENCE = eINSTANCE.getArtifactReference();

		/**
		 * The meta object literal for the '<em><b>Chapter</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ARTIFACT_REFERENCE__CHAPTER = eINSTANCE.getArtifactReference_Chapter();

		/**
		 * The meta object literal for the '<em><b>Artifact</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ARTIFACT_REFERENCE__ARTIFACT = eINSTANCE.getArtifactReference_Artifact();

		/**
		 * The meta object literal for the '<em><b>Integrator Id</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ARTIFACT_REFERENCE__INTEGRATOR_ID = eINSTANCE.getArtifactReference_IntegratorId();

		/**
		 * The meta object literal for the '<em><b>Operation Chain Id</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ARTIFACT_REFERENCE__OPERATION_CHAIN_ID = eINSTANCE.getArtifactReference_OperationChainId();

		/**
		 * The meta object literal for the '<em><b>Latest Checked Revision</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ARTIFACT_REFERENCE__LATEST_CHECKED_REVISION = eINSTANCE.getArtifactReference_LatestCheckedRevision();

		/**
		 * The meta object literal for the '<em><b>Update Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ARTIFACT_REFERENCE__UPDATE_TYPE = eINSTANCE.getArtifactReference_UpdateType();

		/**
		 * The meta object literal for the '{@link org.deft.repository.datamodel.ecoredatamodel.impl.DependencyImpl <em>Dependency</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.deft.repository.datamodel.ecoredatamodel.impl.DependencyImpl
		 * @see org.deft.repository.datamodel.ecoredatamodel.impl.DatamodelPackageImpl#getDependency()
		 * @generated
		 */
		EClass DEPENDENCY = eINSTANCE.getDependency();

		/**
		 * The meta object literal for the '<em><b>Id</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DEPENDENCY__ID = eINSTANCE.getDependency_Id();

		/**
		 * The meta object literal for the '<em><b>Original Location</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DEPENDENCY__ORIGINAL_LOCATION = eINSTANCE.getDependency_OriginalLocation();

		/**
		 * The meta object literal for the '<em><b>Dependencies</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DEPENDENCY__DEPENDENCIES = eINSTANCE.getDependency_Dependencies();

		/**
		 * The meta object literal for the '{@link org.deft.repository.datamodel.ecoredatamodel.impl.RevisionImpl <em>Revision</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.deft.repository.datamodel.ecoredatamodel.impl.RevisionImpl
		 * @see org.deft.repository.datamodel.ecoredatamodel.impl.DatamodelPackageImpl#getRevision()
		 * @generated
		 */
		EClass REVISION = eINSTANCE.getRevision();

		/**
		 * The meta object literal for the '<em><b>Revision Number</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute REVISION__REVISION_NUMBER = eINSTANCE.getRevision_RevisionNumber();

		/**
		 * The meta object literal for the '<em><b>Dependencies</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference REVISION__DEPENDENCIES = eINSTANCE.getRevision_Dependencies();

		/**
		 * The meta object literal for the '<em><b>Original Location</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute REVISION__ORIGINAL_LOCATION = eINSTANCE.getRevision_OriginalLocation();

		/**
		 * The meta object literal for the '{@link org.deft.repository.datamodel.ecoredatamodel.FragmentType <em>Fragment Type</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.deft.repository.datamodel.ecoredatamodel.FragmentType
		 * @see org.deft.repository.datamodel.ecoredatamodel.impl.DatamodelPackageImpl#getFragmentType()
		 * @generated
		 */
		EEnum FRAGMENT_TYPE = eINSTANCE.getFragmentType();

		/**
		 * The meta object literal for the '{@link org.deft.repository.datamodel.ecoredatamodel.ArtifactReferenceUpdateType <em>Artifact Reference Update Type</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.deft.repository.datamodel.ecoredatamodel.ArtifactReferenceUpdateType
		 * @see org.deft.repository.datamodel.ecoredatamodel.impl.DatamodelPackageImpl#getArtifactReferenceUpdateType()
		 * @generated
		 */
		EEnum ARTIFACT_REFERENCE_UPDATE_TYPE = eINSTANCE.getArtifactReferenceUpdateType();

	}

} //DatamodelPackage
