/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package org.deft.repository.datamodel.ecoredatamodel;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Fragment Type</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see org.deft.repository.datamodel.ecoredatamodel.DatamodelPackage#getFragmentType()
 * @model
 * @generated
 */
public enum FragmentType implements Enumerator {
	/**
	 * The '<em><b>Fragment</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #FRAGMENT_VALUE
	 * @generated
	 * @ordered
	 */
	FRAGMENT(0, "fragment", "FRAGMENT"),

	/**
	 * The '<em><b>Chapter</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #CHAPTER_VALUE
	 * @generated
	 * @ordered
	 */
	CHAPTER(1, "chapter", "CHAPTER"),

	/**
	 * The '<em><b>Artifact</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #ARTIFACT_VALUE
	 * @generated
	 * @ordered
	 */
	ARTIFACT(2, "artifact", "ARTIFACT"),

	/**
	 * The '<em><b>Tutorial</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #TUTORIAL_VALUE
	 * @generated
	 * @ordered
	 */
	TUTORIAL(3, "tutorial", "TUTORIAL"),

	/**
	 * The '<em><b>Folder</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #FOLDER_VALUE
	 * @generated
	 * @ordered
	 */
	FOLDER(4, "folder", "FOLDER");

	/**
	 * The '<em><b>Fragment</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Fragment</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #FRAGMENT
	 * @model name="fragment" literal="FRAGMENT"
	 * @generated
	 * @ordered
	 */
	public static final int FRAGMENT_VALUE = 0;

	/**
	 * The '<em><b>Chapter</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Chapter</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #CHAPTER
	 * @model name="chapter" literal="CHAPTER"
	 * @generated
	 * @ordered
	 */
	public static final int CHAPTER_VALUE = 1;

	/**
	 * The '<em><b>Artifact</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Artifact</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #ARTIFACT
	 * @model name="artifact" literal="ARTIFACT"
	 * @generated
	 * @ordered
	 */
	public static final int ARTIFACT_VALUE = 2;

	/**
	 * The '<em><b>Tutorial</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Tutorial</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #TUTORIAL
	 * @model name="tutorial" literal="TUTORIAL"
	 * @generated
	 * @ordered
	 */
	public static final int TUTORIAL_VALUE = 3;

	/**
	 * The '<em><b>Folder</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Folder</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #FOLDER
	 * @model name="folder" literal="FOLDER"
	 * @generated
	 * @ordered
	 */
	public static final int FOLDER_VALUE = 4;

	/**
	 * An array of all the '<em><b>Fragment Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final FragmentType[] VALUES_ARRAY =
		new FragmentType[] {
			FRAGMENT,
			CHAPTER,
			ARTIFACT,
			TUTORIAL,
			FOLDER,
		};

	/**
	 * A public read-only list of all the '<em><b>Fragment Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<FragmentType> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Fragment Type</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static FragmentType get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			FragmentType result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Fragment Type</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static FragmentType getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			FragmentType result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Fragment Type</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static FragmentType get(int value) {
		switch (value) {
			case FRAGMENT_VALUE: return FRAGMENT;
			case CHAPTER_VALUE: return CHAPTER;
			case ARTIFACT_VALUE: return ARTIFACT;
			case TUTORIAL_VALUE: return TUTORIAL;
			case FOLDER_VALUE: return FOLDER;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private FragmentType(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getValue() {
	  return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
	  return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLiteral() {
	  return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} //FragmentType
