package org.deft.repository.event;

import org.deft.repository.datamodel.Artifact;
import org.deft.repository.datamodel.ArtifactReference;
import org.deft.repository.datamodel.Chapter;

public class ArtifactReferenceUpdateEvent extends RepositoryUpdateEvent {
	
	private ArtifactReference reference;
	//Explicitly store chapter and artifact, because reference.getChapter() and reference.getArtifact()
	//will not work later if the chapter or the artifact have been deleted from the repository.
	//Besides, unit tests will fail for reference.getChapter() and reference.getArtifact() if the
	//MockRepository is used
	private Chapter chapter;
	private Artifact artifact;
	
	public ArtifactReferenceUpdateEvent(ArtifactReference reference, Chapter chapter, Artifact artifact, 
			UpdateType updateType, boolean direct) {
		super(updateType, direct);
		this.reference = reference;
		this.chapter = chapter;
		this.artifact = artifact;
	}
	
	public ArtifactReference getReference() {
		return reference;
	}
	
	public Chapter getChapter() {
		return chapter;
	}
	
	public Artifact getArtifact() {
		return artifact;
	}
	

}
