package org.deft.repository.event;

/**
 * Used to find out when there are changes in the ContentManager. It is used to inform
 * ConstraintsManagerLogicBasedImpl when an update of its logic fact base is necessary.
 * If at some point in the future performance issues should arise, the IContentChangeListener 
 * can be updated to deliver more fine-grained results and allow a better control of the fact 
 * base update, but right now it works just fine.
 * 
 * @author Andreas Bartho
 */
public interface IContentChangeListener {

	public void contentChanged();
	
}
