package org.deft.repository.event;

import org.deft.repository.datamodel.Project;


public class ProjectUpdateEvent extends RepositoryUpdateEvent {

	private Project project;
	private String oldName;
	

	public ProjectUpdateEvent(Project project, UpdateType updateType, boolean direct) {
		super(updateType, direct);
		this.project = project;
	}
	
	
	public ProjectUpdateEvent(Project project, String oldName) {
		super(UpdateType.RENAMED, true);
		this.project = project;
		this.oldName = oldName;
	}
	
	
	public Project getProject() {
		return project;
	}
	
	
	public String getOldName() {
		return oldName;
	}
	
	public String toString() {
		return getUpdateType() + " Project \"" + project.getName() + "\" " + (isDirectlyAffected() ? "directly" : "indirectly");
	}
	
}
