package org.deft.repository.event;

public abstract class RepositoryUpdateEvent {

	
	public static enum UpdateType {
		CREATED,
		REMOVED,
		RENAMED,
		MOVED,
		UPDATED;
	}
	
	private UpdateType updateType;
	private boolean direct = true;
	
	public RepositoryUpdateEvent(UpdateType updateType, boolean direct) {
		this.updateType = updateType;
		this.direct = direct;
	}
	
	public boolean isDirectlyAffected() {
		return direct;
	}
	
	public UpdateType getUpdateType() {
		return updateType;
	}
	
}
