package org.deft.repository.event;

public interface RepositoryUpdateListener {

	public void contentLoaded();
	
	public void projectCreated(ProjectUpdateEvent event);
	public void projectRemoved(ProjectUpdateEvent event);
	public void projectRenamed(ProjectUpdateEvent event);
	
	public void fragmentCreated(FragmentUpdateEvent event);
	public void fragmentRemoved(FragmentUpdateEvent event);
	public void fragmentMoved(FragmentUpdateEvent event);
	public void fragmentRenamed(FragmentUpdateEvent event);
	public void artifactUpdated(FragmentUpdateEvent event);
	
	public void artifactReferenceCreated(ArtifactReferenceUpdateEvent event);
	public void artifactReferenceRemoved(ArtifactReferenceUpdateEvent event);
	public void artifactReferenceUpdated(ArtifactReferenceUpdateEvent event);
	public void artifactReferenceChecked(ArtifactReferenceUpdateEvent event);
	public void artifactReferenceUnchecked(ArtifactReferenceUpdateEvent event);
	
	public void chapterAddedToTutorial(RepositoryRelationUpdateEvent event);
	public void chapterRemovedFromTutorial(RepositoryRelationUpdateEvent event);
	public void chapterPositionChanged(RepositoryRelationUpdateEvent event);
}