package org.deft.repository.exception;

import org.deft.repository.datamodel.Fragment;
import org.deft.repository.datamodel.Project;
import org.deft.repository.datamodel.Tutorial;

public class DeftFragmentAlreadyExistsException extends DeftException {
    
	private static final long serialVersionUID = 1L;

	public DeftFragmentAlreadyExistsException(String fragType, String fragName) {
    	super("The " + fragType + " " + fragName + " already exists.");
    }
	
	public DeftFragmentAlreadyExistsException(Fragment fragment) {
        super("Fragment " + fragment.getName() + " already exists.");
    }
    
    public DeftFragmentAlreadyExistsException(Project project, String fragmentType, String name) {
    	super("The " + fragmentType + " " + name 
    			+ " already exists in project " + project.getName() + ".");
    }    
    
    public DeftFragmentAlreadyExistsException(Project project, Tutorial tutorial, String name) {
    	super("The chapter " + name + " already exists in tutorial " 
    			+ tutorial.getName() + " of project " + project.getName() + ".");
    }

    
}
