package org.deft.repository.exception;

import org.deft.repository.datamodel.Fragment;
import org.deft.repository.datamodel.FragmentType;
import org.deft.repository.datamodel.Project;

public class DeftIncompatibleNameException extends DeftException {
	

	private static final long serialVersionUID = 1L;

	public DeftIncompatibleNameException(Project project, String type, String name) {
		super("The " + type + " \"" + name + "\" is not allowed at the root of project " + project.getName() + "." +
				" Maybe there is already a " + type + " with that name.");
	}
	
	public DeftIncompatibleNameException(Project project, FragmentType type, String name) {
		super("The " + type.getName() + " \"" + name + "\" is not allowed at the root of project " + project.getName() + "." +
				" Maybe there is already a " + type + " with that name.");
	}

	
	public DeftIncompatibleNameException(Fragment fragment, String name) {
		super("Fragment " + fragment.getName() + " cannot be renamed to \"" + name + "\"." + 
				" Maybe there is already a fragment with that name.");
	}


}
