package org.deft.repository.fragmentsource;

import java.util.List;

public interface FileBasedFragmentLocation extends OriginalFragmentLocation {
	
	/**
	 * Appends a relative path to the current location.
	 * 
	 * This method does not modify the location, but it 
	 * creates and returns a new location object.
	 * 
	 * If the path is absolute, it completely replaces the 
	 * path currently stored in the location. Again, a new
	 * location object is created, the old one is not overwritten.
	 */
	public FileBasedFragmentLocation appendOrReplace(String path);
	
	public FileBasedFragmentLocation getParent();
	
	public List<FileBasedFragmentLocation> listFilesAndDirectories();
	
	public List<FileBasedFragmentLocation> listDirectories();
	
	public List<FileBasedFragmentLocation> listFiles();
	
	public boolean isFile();
	
	public boolean isDirectory();
	
	public boolean exists();

}
