package org.deft.repository.projecttype;

import java.util.List;

import org.deft.repository.chaptertype.ChapterType;

public class ProjectType {
	
	private String projectTypeId;
	private String description;
	private List<ChapterType> allowedChapterTypes;
	
	public ProjectType(String id, String description, List<ChapterType> allowedChapterTypes) {
		this.projectTypeId = id;
		this.description = description;
		this.allowedChapterTypes = allowedChapterTypes;
	}

	public String getProjectTypeId() {
		return projectTypeId;
	}
	
	public String getDescription() {
		return description;
	}
	
	/**
	 * Returns a list of ids of allowed chapter types, e.g. "latex" and "bibtex" for a latex project.
	 * @return the allowed chapter types of the project type
	 */
	public List<ChapterType> getAllowedChapterTypes() {
		return allowedChapterTypes;
	}
	

}
