package org.deft.repository.repositorymanager.actions;

import org.deft.repository.datamodel.Chapter;
import org.deft.repository.datamodel.Tutorial;
import org.deft.repository.event.RepositoryRelationUpdateEvent;
import org.deft.repository.event.RepositoryUpdateEvent.UpdateType;
import org.deft.repository.repositorymanager.ContentManager;




public class AddChapterToTutorialAction extends AbstractRepositoryAction {
	
	private ContentManager contentManager;
	private Tutorial tutorial;
	private Chapter chapter;

	public AddChapterToTutorialAction(ContentManager cm, Tutorial tutorial, Chapter chapter) {
		this.contentManager = cm;
		this.tutorial = tutorial;
		this.chapter = chapter;
	}
	
	
	@Override
	public void execute() {
		contentManager.addChapterToTutorial(tutorial, chapter);
		executeSuccessful = true;
	}


	@Override
	public RepositoryRelationUpdateEvent createEvent(boolean direct) {
		RepositoryRelationUpdateEvent event = new RepositoryRelationUpdateEvent(tutorial,
				chapter, UpdateType.CREATED, direct);
		return event;
	}

}
