package org.deft.repository.repositorymanager.actions;

import org.deft.repository.datamodel.Project;
import org.deft.repository.event.ProjectUpdateEvent;
import org.deft.repository.event.RepositoryUpdateEvent.UpdateType;
import org.deft.repository.repositorymanager.ContentManager;
import org.deft.repository.repositorymanager.DataStorageManager;

public class CreateProjectAction extends AbstractRepositoryAction {

	private ContentManager contentManager;
	private DataStorageManager dataStorageManager;
	private String name;
	private String chapterType;
	
	public CreateProjectAction(ContentManager cm, DataStorageManager dsm, 
			String name, String chapterType) {
		this.contentManager = cm;
		this.dataStorageManager = dsm;
		this.name = name;
		this.chapterType = chapterType;
	}
	
	@Override
	public void execute() {
		Project project = contentManager.createProject(name, chapterType);
		executeSuccessful = dataStorageManager.createProject(project);
		if (executeSuccessful) {
			createdObject = project;
		} else {
			contentManager.remove(project);
		}
	}

	@Override
	public ProjectUpdateEvent createEvent(boolean direct) {
		Project project = (Project)createdObject;
		ProjectUpdateEvent event = new ProjectUpdateEvent(project, UpdateType.CREATED, direct);
		return event;
	}
	
}
