package org.deft.repository.repositorymanager.actions;

import org.deft.repository.datamodel.Folder;
import org.deft.repository.datamodel.Fragment;
import org.deft.repository.datamodel.Project;
import org.deft.repository.datamodel.Tutorial;
import org.deft.repository.event.FragmentUpdateEvent;
import org.deft.repository.event.RepositoryUpdateEvent.UpdateType;
import org.deft.repository.repositorymanager.ContentManager;




public class CreateTutorialAction extends AbstractRepositoryAction {
	
	private ContentManager contentManager;
	private Project project;
	private Folder parentFolder;
	private String name;

	public CreateTutorialAction(ContentManager cm, Project project, String name) {
		this.contentManager = cm;
		this.project = project;
		this.name = name;
	}
	
	public CreateTutorialAction(ContentManager cm, Folder parent, String name) {
		this.contentManager = cm;
		this.parentFolder = parent;
		this.name = name;
		this.project = contentManager.getProjectOf(parent);
	}
	
	
	@Override
	public void execute() {
		Tutorial tutorial = contentManager.createTutorial(project, name);
		if (parentFolder != null) {
			contentManager.setParentFolder(tutorial, parentFolder);
		}
		executeSuccessful = true;
		createdObject = tutorial;
	}
	
	@Override
	public FragmentUpdateEvent createEvent(boolean direct) {
		Fragment fragment = (Fragment)createdObject;
		FragmentUpdateEvent event = new FragmentUpdateEvent(fragment, UpdateType.CREATED, direct);
		return event;
	}
}
