package org.deft.repository.repositorymanager.actions;

import org.deft.repository.datamodel.Folder;
import org.deft.repository.datamodel.Fragment;
import org.deft.repository.event.FragmentUpdateEvent;
import org.deft.repository.event.RepositoryUpdateEvent.UpdateType;
import org.deft.repository.repositorymanager.ContentManager;

public class MoveToFolderAction extends AbstractRepositoryAction {

	private ContentManager contentManager;
	private Fragment fragment;
	private Folder oldParent;
	private Folder target;

	public MoveToFolderAction(ContentManager cm, Fragment fragment, Folder target) {
		this.contentManager = cm;
		this.fragment = fragment;
		this.target = target;
		this.oldParent = contentManager.getParentFolder(fragment);
	}
	
	
	@Override
	public void execute() {
		contentManager.setParentFolder(fragment, target);
		executeSuccessful = true;
	}


	@Override
	public FragmentUpdateEvent createEvent(boolean direct) {
		FragmentUpdateEvent event = new FragmentUpdateEvent(fragment, 
				oldParent, contentManager.getProjectOf(fragment), UpdateType.MOVED, direct);
		return event;
	}


}
