package org.deft.repository.repositorymanager.actions;

import org.deft.repository.datamodel.Fragment;
import org.deft.repository.event.FragmentUpdateEvent;
import org.deft.repository.repositorymanager.ContentManager;

public class RenameFragmentAction extends AbstractRepositoryAction {

	private ContentManager contentManager;
	private Fragment fragment;
	private String newName, oldName;

	public RenameFragmentAction(ContentManager cm, Fragment fragment, String newName) {
		this.contentManager = cm;
		this.fragment = fragment;
		this.newName = newName;
		this.oldName = fragment.getName();
	}
	
	
	@Override
	public void execute() {
		contentManager.rename(fragment, newName);
		executeSuccessful = true;
	}
	
	

	@Override
	public FragmentUpdateEvent createEvent(boolean direct) {
		FragmentUpdateEvent event = new FragmentUpdateEvent(fragment, oldName);
		return event;
	}
	

}
