package org.deft.repository.repositorymanager.actions;

import org.deft.repository.datamodel.Project;
import org.deft.repository.event.ProjectUpdateEvent;
import org.deft.repository.repositorymanager.ContentManager;

public class RenameProjectAction extends AbstractRepositoryAction {

	private ContentManager contentManager;
	private Project project;
	private String newName, oldName;

	public RenameProjectAction(ContentManager cm, Project project, String newName) {
		this.contentManager = cm;
		this.project = project;
		this.newName = newName;
		this.oldName = project.getName();
	}
	
	
	@Override
	public void execute() {
		contentManager.rename(project, newName);
		executeSuccessful = true;
	}
	
	

	@Override
	public ProjectUpdateEvent createEvent(boolean direct) {	
		ProjectUpdateEvent event = new ProjectUpdateEvent(project, oldName);
		return event;
	}	
	

}
