package org.deft.repository.repositorymanager.actions;

import org.deft.repository.datamodel.Chapter;
import org.deft.repository.datamodel.Tutorial;
import org.deft.repository.event.RepositoryRelationUpdateEvent;
import org.deft.repository.event.RepositoryUpdateEvent.UpdateType;
import org.deft.repository.repositorymanager.ContentManager;


public class SetChapterPositionAction extends AbstractRepositoryAction {
	
	private ContentManager contentManager;
	private Tutorial tutorial;
	private Chapter chapter;
	private int oldPos, newPos;

	public SetChapterPositionAction(ContentManager cm, Tutorial tutorial, Chapter chapter, int newPos) {
		this.contentManager = cm;
		this.tutorial = tutorial;
		this.chapter = chapter;
		this.newPos = newPos;
		this.oldPos = contentManager.getChapterPosition(tutorial, chapter);
	}
	
	
	@Override
	public void execute() {
		contentManager.setChapterPosition(tutorial, chapter, newPos);
		executeSuccessful = true;
	}


	@Override
	public RepositoryRelationUpdateEvent createEvent(boolean direct) {
		RepositoryRelationUpdateEvent event = new RepositoryRelationUpdateEvent(tutorial,
				chapter, oldPos, UpdateType.MOVED, direct);
		return event;
	}

}
