package org.deft.repository.repositorymanager.actions;

import org.deft.operation.OperationChain;
import org.deft.repository.datamodel.Artifact;
import org.deft.repository.datamodel.ArtifactReference;
import org.deft.repository.datamodel.Chapter;
import org.deft.repository.event.ArtifactReferenceUpdateEvent;
import org.deft.repository.event.RepositoryUpdateEvent.UpdateType;
import org.deft.repository.integrator.Integrator;
import org.deft.repository.repositorymanager.ContentManager;
import org.deft.repository.repositorymanager.DataStorageManager;

public class UpdateArtifactReferenceAction extends AbstractRepositoryAction {

	private ContentManager contentManager;
	private DataStorageManager dataStorageManager;
	private ArtifactReference reference;
	private OperationChain chain;
	private Integrator integrator;
	
	public UpdateArtifactReferenceAction(ContentManager cm, DataStorageManager dsm,  
			ArtifactReference reference, OperationChain chain, Integrator integrator) {
		this.contentManager = cm;
		this.dataStorageManager = dsm;
		this.reference = reference;
		this.chain = chain;
		this.integrator = integrator;
	}
	
	@Override
	public void execute() {
		executeSuccessful = dataStorageManager.createArtifactReferenceContent(reference, chain, integrator);
	}

	@Override
	public ArtifactReferenceUpdateEvent createEvent(boolean direct) {
		Chapter chapter = contentManager.getChapter(reference);
		Artifact artifact = contentManager.getArtifact(reference);
		ArtifactReferenceUpdateEvent event = new ArtifactReferenceUpdateEvent(reference, chapter, artifact, UpdateType.UPDATED, direct);
		return event;
	}
	
}
