package org.deft.repository.repositorymanager.impl;

import java.util.LinkedList;
import java.util.List;

import org.deft.repository.datamodel.ecoredatamodel.DatamodelFactory;
import org.deft.repository.datamodel.ecoredatamodel.ProjectsContainer;
import org.deft.repository.event.IContentChangeListener;

public class EcoreDataModelImplCore {
	
	private ProjectsContainer projects;
	protected DatamodelFactory factory = DatamodelFactory.eINSTANCE;
	private List<IContentChangeListener> contentChangeListeners 
			= new LinkedList<IContentChangeListener>();

	
	public EcoreDataModelImplCore() {
		initialize();
	}
	
	public void initialize() {
		this.projects = factory.createProjectsContainer();
		fireContentChanged();
	}
	
	public void clear() {
		this.projects = factory.createProjectsContainer();
	}
	
	public ProjectsContainer getRootContainer() {
		return projects;
	}
	
	public void setRootContainer(ProjectsContainer projects) {
		this.projects = projects;
		fireContentChanged();
	}
	
	public void addContentChangeListener(IContentChangeListener listener) {
		contentChangeListeners.add(listener);
	}


	public void removeContentChangeListener(IContentChangeListener listener) {
		contentChangeListeners.remove(listener);
	}

	private void fireContentChanged() {
		for (IContentChangeListener listener : contentChangeListeners) {
			listener.contentChanged();
		}
	}


}
