package org.deft.repository.repositorymanager.impl;

import java.util.Set;

import org.eclipse.emf.ecore.util.EcoreUtil;

public class IdGenerator {
	
	
	public static String generateId() {
		String id = EcoreUtil.generateUUID();
		id = replaceUnwantedCharacters(id);
		return id;
	}
	
	public static String generateId(String prefix) {
		String id = prefix + EcoreUtil.generateUUID();
		id = replaceUnwantedCharacters(id);
		return id;
	}
	
	public static String generateId(Set<String> existingIds) {
		String id = generateId();
		while (existingIds.contains(id)) {
			id = generateId();
		}
		return id;
	}
	
	
	public static String generateId(String prefix, Set<String> existingIds) {
		String id = generateId(prefix);
		while (existingIds.contains(id)) {
			id = generateId(prefix);
		}
		return id;
	}
	
	
	private static String replaceUnwantedCharacters(String id) {
		String newId = id.replaceAll("_", "-");
		newId = newId.replaceAll("--+", "-");
		return newId;
	}
	
}
