package org.deft.repository.repositorymanager.impl;

import java.util.LinkedList;
import java.util.List;

import org.deft.repository.event.RepositoryOptionsChangeListener;
import org.deft.repository.repositorymanager.OptionsService;

public class OptionsServiceImpl implements OptionsService {

	private String repositoryLocation = "";
	private List<RepositoryOptionsChangeListener> listeners = new LinkedList<RepositoryOptionsChangeListener>();
	
	@Override
    public void setRepositoryLocation(String repositoryLocation) {
		fireRepositoryLocationAboutToChange();
    	this.repositoryLocation = repositoryLocation;
    	fireRepositoryLocationChanged();
    }
    
	@Override
    public String getRepositoryLocation() {
    	return repositoryLocation;
    }

	@Override
	public void addRepositoryOptionsChangeListener(RepositoryOptionsChangeListener listener) {
		listeners.add(listener);
	}

	@Override
	public void removeRepositoryOptionsChangeListener(RepositoryOptionsChangeListener listener) {
		listeners.remove(listener);
	}
	
	private void fireRepositoryLocationAboutToChange() {
		for (RepositoryOptionsChangeListener listener : listeners) {
			listener.repositoryLocationAboutToChange();
		}
	}
	
	private void fireRepositoryLocationChanged() {
		for (RepositoryOptionsChangeListener listener : listeners) {
			listener.repositoryLocationChanged();
		}
	}
	

}
