package org.deft.repository.service;

import java.util.List;

import org.deft.operation.OperationChain;
import org.deft.repository.artifacttype.ArtifactType;
import org.deft.repository.fragmentsource.FragmentSource;
import org.deft.repository.integrator.FileIntegrator;
import org.deft.repository.projecttype.ProjectType;

public interface ExtensionService {

	public FragmentSource getFragmentSource(String fragmentSourceId);
	
	public List<String> getArtifactTypeIds();
	public List<ArtifactType> getArtifactTypes();
	public ArtifactType getArtifactType(String artifactTypeId);
		
	public List<String> getProjectTypeIds();
	public List<ProjectType> getProjectTypes();
	public ProjectType getProjectType(String id);
	

	public List<String> getFileIntegratorIds();
	public List<FileIntegrator> getFileIntegrators();
	public FileIntegrator getFileIntegrator(String id);
	public List<FileIntegrator> getFileIntegratorsForChapterType(String chapterTypeId);
	
	public List<String> getFileExtensionsForArtifactTypeId(String artifactTypeId);
	public List<String> getArtifactTypeIdsForFileExtension(String fileExtension);
	public List<String> getChapterTypeIdsForFileIntegrator(String integratorId);
	
	public List<String> getOperationChainIds();
	public List<OperationChain> getOperationChains();
	public OperationChain getOperationChain(String id);
	public List<OperationChain> getCompatibleOperationChainsForFileIntegration(String artifactTypeId, String chapterTypeId);
	
	public List<String> getOperationChainIdsForArtifactType(String artifactTypeId);
	public List<String> getFileIntegratorIdsForOperationChain(String operationChainId);
	
	
}
