package org.deft.representation.ecore;

import java.util.LinkedList;
import java.util.List;

import org.deft.repository.datamodel.ArtifactRepresentation;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;



public class EcoreRepresentation implements ArtifactRepresentation {

	private List<EObject> roots = new LinkedList<EObject>();
	
	public static final String TYPE = "org.deft.representation.ecore";

	
	public EcoreRepresentation(EObject modelRoot) {
		this.roots.add(modelRoot);
		addToCommonResourceSet(roots);
	}
	
	public EcoreRepresentation(List<EObject> modelRoots) {
		roots.addAll(modelRoots);
		addToCommonResourceSet(roots);
	}
	

	public EObject getModelRoot() {
		return roots.get(0);
	}

	
	@Override
	public String getType() {
		return TYPE;
	}
	
	private void addToCommonResourceSet(List<EObject> modelRoots) {
		ResourceSet rs = new ResourceSetImpl();
		for (EObject root : modelRoots) {
			Resource resource = root.eResource();
			rs.getResources().add(resource);
		}
	}

}

