package org.deft.representation.ecorediag;


import java.util.LinkedList;
import java.util.List;

import org.deft.repository.datamodel.ArtifactRepresentation;
import org.eclipse.gmf.runtime.notation.Diagram;

public class EcoreDiagRepresentation implements ArtifactRepresentation {

	private List<Diagram> diagrams;
	
	public static final String TYPE = "org.deft.representation.ecorediag";
	
	
	public EcoreDiagRepresentation(List<Diagram> diagrams) {
		this.diagrams = diagrams;
	}
	
	public EcoreDiagRepresentation(Diagram diagram) {
		this.diagrams = new LinkedList<Diagram>();
		this.diagrams.add(diagram);
	}
	
	
	public List<Diagram> getDiagrams() {
		return diagrams;
	}
	
	/**
	 * Returns the first (or only) diagram
	 */
	public Diagram getDiagram() {
		return diagrams.get(0);
	}
	
	@Override
	public String getType() {
		return TYPE;
	}

}

