package org.deft.representation.identifiers.ecore;

import java.util.List;

import org.deft.representation.identifiers.data.Scope;

public abstract class AbstractEcoreIdentifier extends Scope {

	private String id;
	
	public AbstractEcoreIdentifier(String name, String id) {
		super(name);
		this.id = id;
	}
	
	@Override
	public String getAsIdString() {
		if (id != null) {
			return "id:" + id;
		} else {
			return "path:" + getFullyQualifiedName();
		}
	}
	
	@Override
	public char getDelimiter() {
		return '.';
	}
	
	@Override
	public AbstractEcoreIdentifier getDescendantScopeById(String id) {
		List<Scope> descendants = this.getThisAndDescendentScopesAsList();
		for (Scope descendant : descendants) {
			String descId = descendant.getAsIdString();
			if (descId.equals(id)) {
				return (AbstractEcoreIdentifier)descendant;
			}
		}
		return null;
	}
	
	public String getIconPluginId() {
		return "org.deft.representation.ecore";
	}

}
