package org.deft.representation.identifiers.ecore;


public class EcoreAnnotationIdentifier extends AbstractEcoreIdentifier {

	public EcoreAnnotationIdentifier(String name, String id) {
		super(name, id);
	}
	
	
	@Override
	public String getIconPath() {
		return "icons/eannotation.gif";
	}
	
	/**
	 * Returns the URL annotation name in the form of "http://some/url"
	 * as "@url" by discarding everything before the last slash. If there
	 * is no slash in the name, the whole name will be returned with an "@" prepended.
	 */
	public String getFullLocalName() {
		String n = getName();
		if (n != null) {
			if (n.contains("/")) {
				int idx = n.lastIndexOf("/");
				String shortName = n.substring(idx + 1);
				return "@" + shortName;
			} else {
				return "@" + n;
			}
		} else {
			return "@<noname>";
		}
	}
}
	
