package org.deft.representation.identifiers.java;

import java.util.List;

import org.deft.representation.identifiers.data.Scope;

public abstract class AbstractJavaIdentifier extends Scope {

	public AbstractJavaIdentifier(String name) {
		super(name);
	}
	
	@Override
	public String getAsIdString() {
		return "path:" + getFullyQualifiedName();
	}
	
	@Override
	public char getDelimiter() {
		return ':';
	}
	
	@Override
	public AbstractJavaIdentifier getDescendantScopeById(String id) {
		List<Scope> descendants = this.getThisAndDescendentScopesAsList();
		for (Scope descendant : descendants) {
			String descId = descendant.getAsIdString();
			if (descId.equals(id)) {
				return (AbstractJavaIdentifier)descendant;
			}
		}
		return null;
	}
	
	public String getIconPluginId() {
		return "org.deft.artifacttypesupport.codefile.java";
	}

}
