package org.deft.representation.styleddocument;

import org.deft.representation.styleddocument.data.DocumentContentContainer;
import org.deft.representation.styleddocument.data.TokenizedStyledDocument;

public class StyledTextRepresentation extends DocumentContentContainerRepresentation {

	public static final String TYPE = "org.deft.representation.styledtext";
	
	public StyledTextRepresentation(TokenizedStyledDocument doc) {
		super(createStyledDoc(doc));
	}
	
	private static DocumentContentContainer createStyledDoc(TokenizedStyledDocument tsd) {
		DocumentContentContainer doc = new DocumentContentContainer();
		doc.addDocumentContent(tsd);
		return doc;
	}
	
	public TokenizedStyledDocument getStyledDocument() {
		return (TokenizedStyledDocument)super.getDocumentContentContainer().getContents().get(0);
	}
	
	@Override
	public String getType() {
		return TYPE;
	}
	
	
	public boolean equals(Object o) {
		if (o instanceof StyledTextRepresentation) {
			StyledTextRepresentation srtr = (StyledTextRepresentation)o;
			TokenizedStyledDocument doc2 = srtr.getStyledDocument();
			TokenizedStyledDocument doc1 = this.getStyledDocument();
			boolean equals = doc1.equals(doc2);
			return equals;
		} else {
			return false;
		}
	}

}
