package org.deft.representation.styleddocument.conversion;



/**
 * The HtmlSourceCodeMapping creates an HTML-string from plain text (source code)
 * and additionally provided formatting information.
 * 
 * The created HTML string has <pre> as opening and closing tag.
 * The individual code tokens can either be marked up with explicit
 * style information (<span style="...">) or with classes
 * (<span class="...">)
 */
public class HtmlSourceCodeMapping extends HtmlTextMapping {

	public HtmlSourceCodeMapping(boolean useNamedStyles) {
		super(useNamedStyles);
	}

	@Override
	public void init() {
		super.init();
		htmlText = "<pre>";
	}
	
	@Override
	public void finish() {
		htmlText += "</pre>";
	}
	
	
}
