package org.deft.representation.styleddocument.conversion;

import org.deft.representation.styleddocument.conversion.PlainText2StyledTextMapping;
import org.deft.representation.styleddocument.data.StyleEnum;
import org.deft.representation.styleddocument.data.StyledToken;

public class LatexMapping implements PlainText2StyledTextMapping {

	String latexText = "";
	private String currentString = "";
	
	@Override
	public void init() {
		latexText = "";
		currentString = "";
	}

	@Override
	public void finish() {
	}

	@Override
	public String getStyledText() {
		return latexText;
	}

	@Override
	public void nextToken(StyledToken token) {
		nextString(token.getText());
		String styleName = token.getStyle().getName();
		setNamedStyle(styleName);
	}
	
	private void setNamedStyle(String styleName) {
		if (styleName.equals(StyleEnum.PARAGRAPH_HEADING.getName())) {
			currentString = "\\paragraph{" + currentString + "}";
		} else if (styleName.equals(StyleEnum.CODE.getName())) {
			currentString = "\\texttt{" + currentString + "}";
		}
	}


	@Override
	public void nextString(String nextString) {
		if (currentString != null) {
			latexText += currentString;
		}
		String stringToAppend = nextString;
		currentString = stringToAppend;
	}

	@Override
	public void setForeground(int r, int g, int b) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void setBold() {
		// TODO Auto-generated method stub
	}

	@Override
	public void setItalic() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void setUnderline() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void setStrikeThrough() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void setMonospace() {
		// TODO Auto-generated method stub
		
	}

	
}
