package org.deft.representation.styleddocument.data;

/**
 * A ConditionalCrossReference is a CrossReference for which the target might or
 * might not exist. Depending on whether the target exists, the ConditionalCrossReference
 * can be rendered differently. 
 */
public class ConditionalCrossReference extends CrossReference {

	private String alternativeText;
	
	public ConditionalCrossReference(String target, String targetType, String alternativeText) {
		super(target, targetType);
		this.alternativeText = alternativeText;
	}
	
	public String getAlternativeText() {
		return alternativeText;
	}
	
	

}
