package org.deft.representation.table.data;

import java.util.LinkedList;
import java.util.List;

public class TableRow {

	private List<TableCell> cells = new LinkedList<TableCell>();
	
	public void addCell(TableCell cell) {
		cells.add(cell);
	}
	
	
	public List<TableCell> getCells() {
		return new LinkedList<TableCell>(cells);
	}
	

	public boolean equals(Object o) {
		if (o instanceof TableRow) {
			TableRow row = (TableRow)o;
			if (this.cells.size() == row.cells.size()) {
				for (int i = 0; i < this.cells.size(); i++) {
					TableCell c1 = this.cells.get(i);
					TableCell c2 = row.cells.get(i);
					boolean equals = equals(c1, c2);
					if (!equals) {
						return false;
					}
				}
			}
			return true;
		} else {
			return false;
		}
	}
	
	public boolean equals(TableCell cell1, TableCell cell2) {
		boolean equals = (cell1.getText().equals(cell2.getText())
				&& cell1.getColSpan() == cell2.getColSpan()
				&& cell1.getRowSpan() == cell2.getRowSpan());
		return equals;
	}
	
}
