package org.deft.representationrenderer.standard;

import org.deft.representation.styleddocument.StyledCodeRepresentation;
import org.deft.representation.styleddocument.conversion.HtmlSourceCodeMapping;

/**
 * A RepresentationRenderer that converts a StyledDocumentRepresentation into
 * a plain string with markup. 
 * 
 * Currently HTML is used as markup. The string is embedded into pre-Tags. The
 * actual styling is done by span-tags with style attributes. 
 */
public class StyledCodeRepresentationRenderer extends StyledTextRepresentationRenderer {

	public static final String ID = "org.deft.representationrenderer.styledcode";
	
	public StyledCodeRepresentationRenderer() {
		mapping = new HtmlSourceCodeMapping(false);
	}

	
	@Override
	public String getId() {
		return ID;
	}
	
	public String getDescription() {
		return "Styled Code";
	}

	@Override
	public boolean canRender(String representationType) {
		boolean canRender = StyledCodeRepresentation.TYPE.equals(representationType);
		return canRender;
	}

}
