package org.deft.representationrenderer.standard;

import java.io.InputStream;

import org.deft.repository.datamodel.ArtifactRepresentation;
import org.deft.representation.table.TableRepresentation;
import org.deft.representation.table.data.Table;
import org.deft.representationrenderer.RepresentationRenderer;


/**
 * A RepresentationRenderer that converts a TableRepresentation into
 * a Table. 
 * 
 * Actually, there is no real conversion going on here, the Table is just
 * retrieved from the TableRepresentation.
 */
public class TableRepresentationRenderer implements RepresentationRenderer {

	public static final String ID = "org.deft.representationrenderer.table";
	
	@Override
	public String getId() {
		return ID;
	}
	
	public String getDescription() {
		return "Table";
	}

	@Override
	public boolean canRender(String representationType) {
		boolean canRender = TableRepresentation.TYPE.equals(representationType);
		return canRender;
	}

	@Override
	public Table render(ArtifactRepresentation representation) {
		Table table = ((TableRepresentation)representation).getTable();
		return table;
	}

	@Override
	public InputStream getInputStream(ArtifactRepresentation representation) {
		throw new UnsupportedOperationException("No input stream available");
	}

}
