package org.deft.requirementsontology;

import org.semanticweb.owl.model.OWLConstant;

public class DataProperty
{
	/**
	 * contains the owl constant of the data property
	 */
	private OWLConstant dataPropertyConstant;
	/**
	 * contains the simple name of the data property
	 */
	private String dataPropertyName;

////////// contstructors
	
	/**
	 * creates a data property object
	 */
	public DataProperty(String dataPropertyName, OWLConstant constant)
	{
		this.dataPropertyName = dataPropertyName;
		this.dataPropertyConstant = constant;
	}
	// end constructor

////////// end constructors

////////// accessing the data property
	
	public OWLConstant getDataPropertyConstant()
	{
		return this.dataPropertyConstant;
	}
	// end getDataPropertyConstant
	
	public String getDataValue()
	{
		return this.dataPropertyConstant.getLiteral();
	}
	// end getDataValue
	
	public String getSimpleName()
	{
		return this.dataPropertyName;
	}
	// end getSimpleName
	
	public String toString()
	{
		return (this.dataPropertyName + " : " + this.dataPropertyConstant.toString());
	}
	// end toString

////////// end accessing the data property
}
// end class DataProperty