package org.deft.requirementsontology;

import java.awt.Font;

import org.apache.commons.collections15.Transformer;

public class EdgeFontTransformer<T1,T2> implements Transformer<ObjectPropertyEdge,Font>
{
	/**
	 * defines the font of an edge label in the graph 
	 */
	@Override
	public Font transform(ObjectPropertyEdge edge)
	{
		String edgeName = edge.getSimpleName();
		Font edgeFontText = new Font(Font.MONOSPACED,Font.ITALIC,11);
		Font edgeFontSymbol = new Font(Font.MONOSPACED,Font.ITALIC+Font.BOLD,20);
		
		if (edgeName.equals("isInConflictWith"))
		{
			return edgeFontSymbol;
		}
		else if (edgeName.equals("isPositiveContributionTo"))
		{
			return edgeFontSymbol;
		}
		else if (edgeName.equals("isNegativeContributionTo"))
		{
			return edgeFontSymbol;
		}
		else if (edgeName.equals("hasRisk"))
		{
			return edgeFontSymbol;
		}
		else if (edgeName.equals("hasObstacle"))
		{
			return edgeFontSymbol;
		}
		else
		{
			return edgeFontText;
		}
		// end if else
	}
	// end transform
}
// end class EdgeFontTransformer
