package org.deft.requirementsontology;

import org.apache.commons.collections15.Transformer;

public class EdgeLabelTransformer<T1,T2> implements	Transformer<ObjectPropertyEdge,String>
{
	/**
	 * defines the label of an edge in the graph
	 */
	@Override
	public String transform(ObjectPropertyEdge edge)
	{
		String edgeName = edge.getSimpleName();
		
		if (edgeName.equals("isInConflictWith"))
		{
			return "X";
		}
		else if (edgeName.equals("isPositiveContributionTo"))
		{
			return "+";
		}
		else if (edgeName.equals("isNegativeContributionTo"))
		{
			return "-";
		}
		else if (edgeName.equals("hasRisk"))
		{
			return "!";
		}
		else if (edgeName.equals("hasObstacle"))
		{
			return "!";
		}
		else
		{
			return edgeName;
		}
		// end if else
	}
	// end transform
}
// end class EdgeLabelTransformer