package org.deft.requirementsontology;

import java.awt.BasicStroke;
import java.awt.Stroke;

import org.apache.commons.collections15.Transformer;

public class EdgeStrokeTransformer<T1,T2> implements Transformer<ObjectPropertyEdge,Stroke>
{
	/**
	 * defines the stroke of an edge in the graph
	 */
	@Override
	public Stroke transform(ObjectPropertyEdge edge)
	{
		float dash1[] = {6.0f};
		float dash2[] = {2.0f};
		final Stroke edgeStroke1 = new BasicStroke(1.5f, BasicStroke.CAP_BUTT,BasicStroke.JOIN_BEVEL);
		final Stroke edgeStroke2 = new BasicStroke(1.2f, BasicStroke.CAP_BUTT,BasicStroke.JOIN_BEVEL, 10.0f, dash1, 0.0f);
		final Stroke edgeStroke3 = new BasicStroke(1.2f, BasicStroke.CAP_BUTT,BasicStroke.JOIN_BEVEL, 10.0f, dash2, 0.0f);
		String edgeName = edge.getSimpleName();

		if (edgeName.equals("isInConflictWith"))
		{
			return edgeStroke2;
		}
		else if (edgeName.equals("describesRequirement"))
		{
			return edgeStroke3;
		}
		else if (edgeName.equals("isDescribedByUseCase"))
		{
			return edgeStroke3;
		}
		else if (edgeName.equals("isConnectedToUseCase"))
		{
			return edgeStroke3;
		}
		else
		{
			return edgeStroke1;
		}
		// end if else
	}
	// end transform
}
// end class EdgeStrokeTransformer



