package org.deft.requirementsontology;

public class ObjectPropertyEdge
{
	/**
	 * contains the source individual vertex of the object property edge
	 */
	private IndividualVertex sourceIndividual;
	/**
	 * contains the target individual vertex of the object property edge
	 */
	private IndividualVertex targetIndividual;
	/**
	 * contains the simple name of the object property
	 */
	private String objectPropertyName;

////////// constructors
	
	/**
	 * creating an object property edge object
	 */
	public ObjectPropertyEdge(String objectPropertyName, IndividualVertex source, IndividualVertex target)
	{
		this.objectPropertyName = objectPropertyName;
		this.sourceIndividual = source;
		this.targetIndividual = target;
	}
	// end constructor

////////// end constructors

////////// accessing the object property edge
	
	public IndividualVertex getSourceIndividual()
	{
		return this.sourceIndividual;
	}
	// end getSourceIndividual

	public IndividualVertex getTargetIndividual()
	{
		return this.targetIndividual;
	}
	// end getTargetIndividual
	
	public String getSimpleName()
	{
		return this.objectPropertyName;
	}
	// end getSimpleName
	
	public String toString()
	{
		return this.objectPropertyName;
	}
	// end toString
	
////////// end accessing the object property edge
}
// end class ObjectPropertyEdge
