package org.deft.requirementsontology;

import java.awt.Dimension;

import org.deft.representation.table.data.Table;


public class RequirementsOntologyProject
{
	/**
	 * @param args
	 */
	@SuppressWarnings("unused")
	public static void main(String[] args)
	{
		OntologyAccessor oA = new OntologyAccessor("RO_version_1_4_1_social_network_consistent.owl");
		ROModel roModel = new ROModel(oA);
		DirectedROModel dRoModel = new DirectedROModel(oA);

		roModel.removeIndividuals("Stakeholder");

		dRoModel.createRefinementForest();
		dRoModel.insertObjectPropertyWithIndividuals("hasScenario");
		dRoModel.insertObjectPropertyWithIndividuals("belongsToUseCase");
		dRoModel.insertObjectPropertyWithIndividuals("isInConflictWith");
		dRoModel.insertObjectPropertyWithIndividuals("hasRisk");

		
		GoalModelVisualizer gmVisualizer1 = new GoalModelVisualizer(roModel);
		GoalModelVisualizer gmVisualizer2 = new GoalModelVisualizer(dRoModel);
		IndividualDataVisualizer idVisualizer = new IndividualDataVisualizer(roModel);
		
		Dimension graphicSize1 = new Dimension(1000,1000);
		Dimension graphicSize2 = new Dimension(1800,1000);
		
//		gmVisualizer1.createImage("ro_zielmodellgraph_1.png","png",graphicSize,VisualizationLayoutType.GRAPH);
//		gmVisualizer2.createImage("ro_zielmodellgraph_2.png","png",graphicSize,VisualizationLayoutType.GRAPH);
//		gmVisualizer2.createImage("ro_zielmodellwald.png","png",graphicSize,VisualizationLayoutType.TREE);
		
		gmVisualizer1.createJFrame(graphicSize1,VisualizationLayoutType.GRAPH);
		gmVisualizer2.createJFrame(graphicSize2,VisualizationLayoutType.TREE);
		
		Table table = idVisualizer.getIndividualDataSurvey("UserHasPhotoAlbum");
		
	
		// beide matrizen
		// evtl. noch bei image -> layout kleiner machen
	

//ArrayList<String> set = new ArrayList<String>();
//ArrayList<String> set2 = new ArrayList<String>();
//		Collection<IndividualVertex> sourceIndividualSet = roModel.getIndividuals();
//		for (IndividualVertex i : sourceIndividualSet)
//		{
//			if (i.getMainType().equals("Goal"))
//			set.add(i.getSimpleName());
//			if (i.getMainType().equals("Requirement") )
//				set2.add(i.getSimpleName());
//		}
//		
//		GeneralTraceabilityMatrix gtm = new GeneralTraceabilityMatrix(set, set2, roModel);

		

			

	}
	// end main
}
// end class main


