package org.deft.requirementsontology;

import java.awt.Color;
import java.awt.Paint;

import org.apache.commons.collections15.Transformer;

public class VertexFillPaintTransformer<T1,T2> implements Transformer<IndividualVertex,Paint>
{
	/**
	 * defines the color of a vertex in the graph
	 */
	@Override
	public Paint transform(IndividualVertex individual)
	{
		String mainType = individual.getMainType();
		Color colorRed = new Color(192,0,0);
		Color colorLightBlue = new Color(200,230,238);
		Color colorBlue =  new Color(88,128,179);
		Color colorOrange = new Color(234,112,13);
		Color colorGreen = new Color(120,148,64);
		Color colorRedBrown = new Color(97,38,33);
		Color colorRose = new Color(229,185,181);
		Color colorYellow = new Color(255,255,0);
		Color colorPurple = new Color(126,100,158);
		Color colorBlack = new Color(0,0,0);
		Color colorGray = new Color(216,216,216);
		Color colorWhite = new Color(255,255,255);
		
		if (mainType.equals("Problem"))
		{
			return colorRed;
		}
		else if (mainType.equals("Challenge"))
		{
			return colorLightBlue;
		}
		else if (mainType.equals("Goal"))
		{
			return colorBlue;
		}
		else if (mainType.equals("Requirement"))
		{
			return colorOrange;
		}
		else if (mainType.equals("Story"))
		{
			return colorGreen;
		}
		else if (mainType.equals("SoftMetric"))
		{
			return colorRedBrown;
		}
		else if (mainType.equals("TestCase"))
		{
			return colorRose;
		}
		else if (mainType.equals("Exception"))
		{
			return colorYellow;
		}
		else if (mainType.equals("Refinement"))
		{
			return colorPurple;
		}
		else if (mainType.equals("Source"))
		{
			return colorBlack;
		}
		else if (mainType.equals("Stakeholder"))
		{
			return colorGray;
		}
		else
		{
			return colorWhite;
		}
		// end if else
	}
	// end transform
}
// end class VertexTransformer