package org.deft.requirementsontology;

import org.apache.commons.collections15.Transformer;

public class VertexLabelTransformer<T1,T2> implements Transformer<IndividualVertex,String>
{
	/**
	 * defines the label of a vertex in the graph 
	 */
	@Override
	public String transform(IndividualVertex individual)
	{
		StringBuffer vertexLabel = new StringBuffer();
		StringBuffer individualName = new StringBuffer(individual.getSimpleName());
		int lastStringPosition = 0;
		vertexLabel.append("<html>");
		
		for (int index = 0; index < individualName.length(); index++)
		{
			if (Character.isUpperCase(individualName.charAt(index)))
			{
				vertexLabel.append(individualName.substring(lastStringPosition,index));
				vertexLabel.append("<br/>");
				lastStringPosition = index;
			}
			// end if
		}
		// end for
		
		vertexLabel.append(individualName.substring(lastStringPosition, individualName.length()));
		vertexLabel.append("</html>");
		
//		String essentialType = individual.getEssentialType();
//		vertexLabel.append("<html>" + essentialType + ":<br/>");	
//		vertexLabel.append(individual.getSimpleName() + "</html>");
//		vertexLabel.append(individual.getSimpleName());
		
		return vertexLabel.toString();
	}
	// end transform
}
// end class VertexLabeller