package org.deft.requirementsontology;

import java.awt.Polygon;
import java.awt.Rectangle;
import java.awt.Shape;
import java.awt.geom.Ellipse2D;
import java.awt.geom.RoundRectangle2D;

import org.apache.commons.collections15.Transformer;

public class VertexShapeTransformer<T1,T2> implements Transformer<IndividualVertex,Shape>
{
	/**
	 * defines the shape of a vertex in the graph
	 */
	@Override
	public Shape transform(IndividualVertex individual)
	{
		String mainType = individual.getMainType();
		Shape circle = new Ellipse2D.Double(-13,-13,26,26);
		Shape rectangle = new Rectangle(-13,-13,26,26);
		Shape roundRectangle = new RoundRectangle2D.Double(-10,-10,20,20,13,13);
		Shape triangle = new Polygon();
		((Polygon) triangle).addPoint(-13,13);
		((Polygon) triangle).addPoint(13,13);
		((Polygon) triangle).addPoint(0,-13);
		
		if (mainType.equals("Problem"))
		{
			return triangle;
		}
		else if (mainType.equals("Challenge"))
		{
			return circle;
		}
		else if (mainType.equals("Goal"))
		{
			return circle;
		}
		else if (mainType.equals("Requirement"))
		{
			return rectangle;
		}
		else if (mainType.equals("Story"))
		{
			return roundRectangle;
		}
		else if (mainType.equals("SoftMetric"))
		{
			return roundRectangle;
		}
		else if (mainType.equals("TestCase"))
		{
			return roundRectangle;
		}
		else if (mainType.equals("Exception"))
		{
			return triangle;
		}
		else if (mainType.equals("Refinement"))
		{
			return roundRectangle;
		}
		else if (mainType.equals("Source"))
		{
			return roundRectangle;
		}
		else if (mainType.equals("Stakeholder"))
		{
			return circle;
		}
		else
		{
			return circle;
		}
		// end if else
	}
	// end transform
}
// end class VertexShapeTransformer