package org.deft.resource;

import org.deft.resource.ResourceHandler;
import org.deft.resource.impl.EclipsePluginResourceHandler;
import org.deft.resource.impl.SimpleJavaResourceHandler;

public abstract class ResourceHandlerFactory {
	
	public static final String JAVA = "java";
	public static final String ECLIPSE = "eclipse";
	
	public static ResourceHandler createSimpleResourceHandler(String id, String handlerKind) {
		if (handlerKind.equals(JAVA)) {
			ResourceHandler handler = createSimpleJavaResourceHandler(id);
			return handler;
		} else if (handlerKind.equals(ECLIPSE)) {
			ResourceHandler handler = createEclipseResourceHandler(id);
			return handler;
		}
		return null;
	}
	
	private static ResourceHandler createSimpleJavaResourceHandler(String id) {
		ResourceHandler handler = new SimpleJavaResourceHandler(id);
		return handler;
	}
	
	private static ResourceHandler createEclipseResourceHandler(String id) {
		ResourceHandler handler = new EclipsePluginResourceHandler(id);
		return handler;
	}
	
	
}
