package org.deft.resource;

import java.net.URL;
import java.util.HashMap;
import java.util.Map;

public class ResourceHandlerProvider {
	
	
	private Map<String, ResourceHandler> handlerMap = new HashMap<String, ResourceHandler>();
	
	public void registerResourceHandler(ResourceHandler handler) {
		handlerMap.put(handler.getResourceHandlerId(), handler);
	}
	
	public ResourceHandler getResourceHandler(String id) {
		ResourceHandler handler = handlerMap.get(id);
		return handler;
	}
	
	public URL getAbsoluteResourceUrl(String resourceHandlerId, String relativeResourcePath) {
		ResourceHandler handler = getResourceHandler(resourceHandlerId);
		URL url = handler.getResourceUrl(relativeResourcePath);
		return url;
	}
	
	
	

}
