package org.deft.util;

import java.awt.image.BufferedImage;
import java.io.BufferedInputStream;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;

import javax.imageio.ImageIO;

public class ImageUtil {

	/**
	 * Creates a BufferedImage from an array of bytes
	 */
	public static BufferedImage createImage(byte[] byteContent) {
		try {
			InputStream is = new ByteArrayInputStream(byteContent);
			BufferedImage image = ImageIO.read(is);
			return image;
		} catch (IOException e) {
			e.printStackTrace();
		}
		return null;
	}
	
	/**
	 * Converts a BufferedImage to an array of bytes
	 */
	public static byte[] convertToByteArray(BufferedImage image) {
		try {
			ByteArrayOutputStream baos = new ByteArrayOutputStream();
			ImageIO.write(image, "png", baos);
			byte[] bytes = baos.toByteArray();
			return bytes;
		} catch (IOException e) {
			e.printStackTrace();
		}
		return null;
	}

	
	/**
	 * Gets an InputStream from a BufferedImage
	 */
	public static InputStream getInputStream(BufferedImage image) {
		byte[] bytes = convertToByteArray(image);
		InputStream is = convertToInputStream(bytes);
		return is;
	}
	
	
	private static InputStream convertToInputStream(byte[] bytes) {
		InputStream is = new ByteArrayInputStream(bytes);
		BufferedInputStream bis = new BufferedInputStream(is);
		return bis;
	}

	
	
}
