package org.deft.util;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.Arrays;

public class StreamUtil {
	
	public static String readContent(InputStream stream){
		StringBuffer buffer = new StringBuffer(512);
		try {
			BufferedReader br = new BufferedReader(new InputStreamReader(
					stream, "UTF-8"));
			char[] readBuffer = new char[512];
			int n = br.read(readBuffer);
			while (n > 0) {
				buffer.append(readBuffer, 0, n);
				n = br.read(readBuffer);
			}

			br.close();
			stream.close();
		} catch (Exception e) {
			return null;
		}
		return buffer.toString();
	}
	
	
	public static byte[] readByteContent(InputStream stream) {
		try {
			byte[] contents = new byte[stream.available()];
			stream.read(contents, 0, contents.length);
			stream.close();
			return contents;
		} catch (IOException e) {
			e.printStackTrace();
		}
		return null;
	}
	
	
	public static boolean isContentIdentical(InputStream s1, InputStream s2) {
		if (s1 == null || s2 == null) {
			throw new IllegalArgumentException("InputStream must not be null.");
		}
		try {
			byte[] buffer1 = new byte[512];
			byte[] buffer2 = new byte[512];
			int read1 = s1.read(buffer1);
			int read2 = s2.read(buffer2);
			boolean identical = true;
			while (read1 == read2 && read1 > 0 && identical) {
				identical = identical && Arrays.equals(buffer1, buffer2);
				read1 = s1.read(buffer1);
				read2 = s2.read(buffer2);
			}
			s1.close();
			s2.close();
			//return true if identical flag is true and the same number of bytes has been read
			return (identical && read1 == read2);
		} catch (IOException ioe) {
			try {
				s1.close();
				s2.close();
			} catch (IOException e) {
			}
			return false;
		}
	}


}
