package org.deft.util;

import javax.swing.text.BadLocationException;
import javax.swing.text.Style;
import javax.swing.text.StyleContext;
import javax.swing.text.StyledDocument;

public class StyledDocumentUtil {
	
	
	public static void add(StyledDocument doc, String text) {
		add(doc, text, "");
	}
	
	public static void add(StyledDocument doc, String text, String styleName) {
		Style style = doc.getStyle(styleName);
		if (style == null) {
			style = doc.getStyle(StyleContext.DEFAULT_STYLE);
		}
		try {
			doc.insertString(doc.getLength(), text, style);
		} catch (BadLocationException e) {
			e.printStackTrace();
		}
	}

	
	public static String asString(StyledDocument doc) {
		try {
			String s = doc.getText(0, doc.getLength());
			return s;
		} catch (BadLocationException e) {
			e.printStackTrace();
		}
		return null;
	}
	
}
