/**
 * <copyright>
 * </copyright>
 *
 * 
 */
package org.emftext.language.office.resource.office.mopp;

public class OfficeReferenceResolverSwitch implements org.emftext.language.office.resource.office.IOfficeReferenceResolverSwitch {
	
	protected org.emftext.language.office.resource.office.analysis.EmployeeWorksInReferenceResolver employeeWorksInReferenceResolver = new org.emftext.language.office.resource.office.analysis.EmployeeWorksInReferenceResolver();
	protected org.emftext.language.office.resource.office.analysis.EmployeeWorksWithReferenceResolver employeeWorksWithReferenceResolver = new org.emftext.language.office.resource.office.analysis.EmployeeWorksWithReferenceResolver();
	
	public org.emftext.language.office.resource.office.analysis.EmployeeWorksInReferenceResolver getEmployeeWorksInReferenceResolver() {
		return employeeWorksInReferenceResolver;
	}
	
	public org.emftext.language.office.resource.office.analysis.EmployeeWorksWithReferenceResolver getEmployeeWorksWithReferenceResolver() {
		return employeeWorksWithReferenceResolver;
	}
	
	public void setOptions(java.util.Map<?, ?> options) {
		employeeWorksInReferenceResolver.setOptions(options);
		employeeWorksWithReferenceResolver.setOptions(options);
	}
	
	public void resolveFuzzy(String identifier, org.eclipse.emf.ecore.EObject container, org.eclipse.emf.ecore.EReference reference, int position, org.emftext.language.office.resource.office.IOfficeReferenceResolveResult<org.eclipse.emf.ecore.EObject> result) {
		if (container == null) {
			return;
		}
		if (org.emftext.language.office.OfficePackage.eINSTANCE.getEmployee().isInstance(container)) {
			OfficeFuzzyResolveResult<org.emftext.language.office.Office> frr = new OfficeFuzzyResolveResult<org.emftext.language.office.Office>(result);
			String referenceName = reference.getName();
			org.eclipse.emf.ecore.EStructuralFeature feature = container.eClass().getEStructuralFeature(referenceName);
			if (feature != null && feature instanceof org.eclipse.emf.ecore.EReference && referenceName != null && referenceName.equals("worksIn")) {
				employeeWorksInReferenceResolver.resolve(identifier, (org.emftext.language.office.Employee) container, (org.eclipse.emf.ecore.EReference) feature, position, true, frr);
			}
		}
		if (org.emftext.language.office.OfficePackage.eINSTANCE.getEmployee().isInstance(container)) {
			OfficeFuzzyResolveResult<org.emftext.language.office.Employee> frr = new OfficeFuzzyResolveResult<org.emftext.language.office.Employee>(result);
			String referenceName = reference.getName();
			org.eclipse.emf.ecore.EStructuralFeature feature = container.eClass().getEStructuralFeature(referenceName);
			if (feature != null && feature instanceof org.eclipse.emf.ecore.EReference && referenceName != null && referenceName.equals("worksWith")) {
				employeeWorksWithReferenceResolver.resolve(identifier, (org.emftext.language.office.Employee) container, (org.eclipse.emf.ecore.EReference) feature, position, true, frr);
			}
		}
	}
	
	public org.emftext.language.office.resource.office.IOfficeReferenceResolver<? extends org.eclipse.emf.ecore.EObject, ? extends org.eclipse.emf.ecore.EObject> getResolver(org.eclipse.emf.ecore.EStructuralFeature reference) {
		if (reference == org.emftext.language.office.OfficePackage.eINSTANCE.getEmployee_WorksIn()) {
			return employeeWorksInReferenceResolver;
		}
		if (reference == org.emftext.language.office.OfficePackage.eINSTANCE.getEmployee_WorksWith()) {
			return employeeWorksWithReferenceResolver;
		}
		return null;
	}
	
}
