/**
 * <copyright>
 * </copyright>
 *
 * 
 */
package org.emftext.language.pl0.resource.pl0;

/**
 * An element that is expected at a given position in a resource stream.
 */
public interface IPl0ExpectedElement {
	
	/**
	 * Returns the names of all tokens that are expected at the given position
	 */
	public java.util.Set<String> getTokenNames();
	
	/**
	 * Returns the metaclass of the rule that contains the expected element
	 */
	public org.eclipse.emf.ecore.EClass getRuleMetaclass();
	
	/**
	 * Adds an element that is a valid follower for this element
	 */
	public void addFollower(org.emftext.language.pl0.resource.pl0.IPl0ExpectedElement follower, org.eclipse.emf.ecore.EStructuralFeature[] path);
	
	/**
	 * Returns all valid followers for this element
	 */
	public java.util.Collection<org.emftext.language.pl0.resource.pl0.util.Pl0Pair<org.emftext.language.pl0.resource.pl0.IPl0ExpectedElement, org.eclipse.emf.ecore.EStructuralFeature[]>> getFollowers();
	
}
