/**
 * <copyright>
 * </copyright>
 *
 * 
 */
package org.emftext.language.pl0.resource.pl0.grammar;

/**
 * The abstract super class for all elements of a grammar. This class provides
 * methods to traverse the grammar rules.
 */
public abstract class Pl0SyntaxElement {
	
	private Pl0SyntaxElement[] children;
	private Pl0SyntaxElement parent;
	private org.emftext.language.pl0.resource.pl0.grammar.Pl0Cardinality cardinality;
	
	public Pl0SyntaxElement(org.emftext.language.pl0.resource.pl0.grammar.Pl0Cardinality cardinality, Pl0SyntaxElement[] children) {
		this.cardinality = cardinality;
		this.children = children;
		if (this.children != null) {
			for (Pl0SyntaxElement child : this.children) {
				child.setParent(this);
			}
		}
	}
	
	public void setParent(Pl0SyntaxElement parent) {
		assert this.parent == null;
		this.parent = parent;
	}
	
	public Pl0SyntaxElement[] getChildren() {
		if (children == null) {
			return new Pl0SyntaxElement[0];
		}
		return children;
	}
	
	public org.eclipse.emf.ecore.EClass getMetaclass() {
		return parent.getMetaclass();
	}
	
	public org.emftext.language.pl0.resource.pl0.grammar.Pl0Cardinality getCardinality() {
		return cardinality;
	}
	
}
