/**
 * <copyright>
 * </copyright>
 *
 * 
 */
package org.emftext.language.pl0.resource.pl0.mopp;

/**
 * A representation for a range in a document where an enumeration literal (i.e.,
 * a set of static strings) is expected.
 */
public class Pl0ExpectedEnumerationTerminal extends org.emftext.language.pl0.resource.pl0.mopp.Pl0AbstractExpectedElement {
	
	private org.emftext.language.pl0.resource.pl0.grammar.Pl0EnumerationTerminal enumerationTerminal;
	
	public Pl0ExpectedEnumerationTerminal(org.emftext.language.pl0.resource.pl0.grammar.Pl0EnumerationTerminal enumerationTerminal) {
		super(enumerationTerminal.getMetaclass());
		this.enumerationTerminal = enumerationTerminal;
	}
	
	public java.util.Set<String> getTokenNames() {
		// EnumerationTerminals are associated with multiple tokens, one for each literal
		// that was mapped to a string
		java.util.Set<String> tokenNames = new java.util.LinkedHashSet<String>();
		java.util.Map<String, String> mapping = enumerationTerminal.getLiteralMapping();
		for (String literalName : mapping.keySet()) {
			String text = mapping.get(literalName);
			if (text != null && !"".equals(text)) {
				tokenNames.add("'" + text + "'");
			}
		}
		return tokenNames;
	}
	
	public org.emftext.language.pl0.resource.pl0.grammar.Pl0EnumerationTerminal getEnumerationTerminal() {
		return this.enumerationTerminal;
	}
}
