/**
 * <copyright>
 * </copyright>
 *
 * 
 */
package org.emftext.language.pl0.resource.pl0.mopp;

public class Pl0NewFileContentProvider {
	
	public org.emftext.language.pl0.resource.pl0.IPl0MetaInformation getMetaInformation() {
		return new org.emftext.language.pl0.resource.pl0.mopp.Pl0MetaInformation();
	}
	
	public String getNewFileContent(String newFileName) {
		return getExampleContent(new org.eclipse.emf.ecore.EClass[] {
			org.emftext.language.pl0.PL0Package.eINSTANCE.getProgram(),
		}, getMetaInformation().getClassesWithSyntax(), newFileName);
	}
	
	protected String getExampleContent(org.eclipse.emf.ecore.EClass[] startClasses, org.eclipse.emf.ecore.EClass[] allClassesWithSyntax, String newFileName) {
		String content = "program square\n\nVAR x, squ;\n\nPROCEDURE square;\nBEGIN\n   squ := x * x\nEND;\n\nBEGIN\n   x := 1;\n   WHILE x <= 10 DO\n   BEGIN\n      CALL square;\n      x := x + 1\n   END\nEND.".replace("\n", System.getProperty("line.separator"));
		return content;
	}
	
	protected String getExampleContent(org.eclipse.emf.ecore.EClass eClass, org.eclipse.emf.ecore.EClass[] allClassesWithSyntax, String newFileName) {
		// create a minimal model
		org.eclipse.emf.ecore.EObject root = new org.emftext.language.pl0.resource.pl0.util.Pl0MinimalModelHelper().getMinimalModel(eClass, allClassesWithSyntax, newFileName);
		if (root == null) {
			// could not create a minimal model. returning an empty document is the best we
			// can do.
			return "";
		}
		// use printer to get text for model
		java.io.ByteArrayOutputStream buffer = new java.io.ByteArrayOutputStream();
		org.emftext.language.pl0.resource.pl0.IPl0TextPrinter printer = getPrinter(buffer);
		try {
			printer.print(root);
		} catch (java.io.IOException e) {
			org.emftext.language.pl0.resource.pl0.mopp.Pl0Plugin.logError("Exception while generating example content.", e);
		}
		return buffer.toString();
	}
	
	public org.emftext.language.pl0.resource.pl0.IPl0TextPrinter getPrinter(java.io.OutputStream outputStream) {
		return getMetaInformation().createPrinter(outputStream, new org.emftext.language.pl0.resource.pl0.mopp.Pl0Resource());
	}
	
}
