/**
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (C) 2007 Matthias Braeuer (braeuer.matthias@web.de).            *
 * All rights reserved.                                                      *
 *                                                                           *
 * This work was done as a project at the Chair for Software Technology,     *
 * Dresden University Of Technology, Germany (http://st.inf.tu-dresden.de).  *
 * It is understood that any modification not identified as such is not      *
 * covered by the preceding statement.                                       *
 *                                                                           *
 * This work is free software; you can redistribute it and/or modify it      *
 * under the terms of the GNU Library General Public License as published    *
 * by the Free Software Foundation; either version 2 of the License, or      *
 * (at your option) any later version.                                       *
 *                                                                           *
 * This work is distributed in the hope that it will be useful, but WITHOUT  *
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or     *
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library General Public     *
 * License for more details.                                                 *
 *                                                                           *
 * You should have received a copy of the GNU Library General Public License *
 * along with this library; if not, you can view it online at                *
 * http://www.fsf.org/licensing/licenses/gpl.html.                           *
 *                                                                           *
 * To submit a bug report, send a comment, or get the latest news on this    *
 * project, please visit the website: http://dresden-ocl.sourceforge.net.    *
 * For more information on OCL and related projects visit the OCL Portal:    *
 * http://st.inf.tu-dresden.de/ocl                                           *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 * $Id$
 */
package tudresden.ocl20.pivot.essentialocl.standardlibrary;

import tudresden.ocl20.pivot.essentialocl.expressions.CollectionKind;
import tudresden.ocl20.pivot.modelinstance.IModelInstance;

/**
 * <p>
 * This enumeration contains constants that represent the various OCL collection
 * types. It is required during evaluation of OCL expressions when concrete
 * collection types are requested from an {@link IModelInstance} by a compiler
 * or interpreter. It should not be mixed up with the enumeration
 * {@link CollectionKind} in the Essential OCL Expressions package because that
 * one is used in the abstract syntax (i.e., one layer higer up in the meta
 * hierachy).
 * </p>
 * 
 * @author Matthias Braeuer
 */
public enum OclCollectionTypeKind {

	/** Enum constant representing the OCL Collection type. */
	COLLECTION,

	/** Enum constant representing the OCL Sequence type. */
	SEQUENCE,

	/** Enum constant representing the OCL Bag type. */
	BAG,

	/** Enum constant representing the OCL Set type. */
	SET,

	/** Enum constant representing the OCL OrderedSet type. */
	ORDEREDSET
}